// python wrapper for vtkGLSLShaderDeviceAdapter2
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGLSLShaderDeviceAdapter2.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGLSLShaderDeviceAdapter2(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGLSLShaderDeviceAdapter2_ClassNew(); }

#ifndef DECLARED_PyvtkShaderDeviceAdapter2_ClassNew
extern "C" { PyObject *PyvtkShaderDeviceAdapter2_ClassNew(); }
#define DECLARED_PyvtkShaderDeviceAdapter2_ClassNew
#endif

static const char **PyvtkGLSLShaderDeviceAdapter2_Doc();


static PyObject *
PyvtkGLSLShaderDeviceAdapter2_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkGLSLShaderDeviceAdapter2::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGLSLShaderDeviceAdapter2_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGLSLShaderDeviceAdapter2 *op = static_cast<vtkGLSLShaderDeviceAdapter2 *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGLSLShaderDeviceAdapter2::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGLSLShaderDeviceAdapter2_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGLSLShaderDeviceAdapter2 *tempr = vtkGLSLShaderDeviceAdapter2::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGLSLShaderDeviceAdapter2_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGLSLShaderDeviceAdapter2 *op = static_cast<vtkGLSLShaderDeviceAdapter2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGLSLShaderDeviceAdapter2 *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGLSLShaderDeviceAdapter2::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGLSLShaderDeviceAdapter2_PrepareForRender(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PrepareForRender");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGLSLShaderDeviceAdapter2 *op = static_cast<vtkGLSLShaderDeviceAdapter2 *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PrepareForRender();
    }
    else
    {
      op->vtkGLSLShaderDeviceAdapter2::PrepareForRender();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGLSLShaderDeviceAdapter2_SendAttribute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SendAttribute");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGLSLShaderDeviceAdapter2 *op = static_cast<vtkGLSLShaderDeviceAdapter2 *>(vp);

  char *temp0 = NULL;
  int temp1;
  int temp2;
  void  *temp3 = NULL;
  Py_buffer pbuf3 = VTK_PYBUFFER_INITIALIZER;
  unsigned long temp4 = 0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4, 5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetBuffer(temp3, &pbuf3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    if (ap.IsBound())
    {
      op->SendAttribute(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkGLSLShaderDeviceAdapter2::SendAttribute(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf3.obj != 0)
  {
    PyBuffer_Release(&pbuf3);
  }
#endif
  return result;
}

static PyMethodDef PyvtkGLSLShaderDeviceAdapter2_Methods[] = {
  {"IsTypeOf", PyvtkGLSLShaderDeviceAdapter2_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkGLSLShaderDeviceAdapter2_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkGLSLShaderDeviceAdapter2_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkGLSLShaderDeviceAdapter2\nC++: static vtkGLSLShaderDeviceAdapter2 *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkGLSLShaderDeviceAdapter2_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGLSLShaderDeviceAdapter2\nC++: vtkGLSLShaderDeviceAdapter2 *NewInstance()\n\n"},
  {"PrepareForRender", PyvtkGLSLShaderDeviceAdapter2_PrepareForRender, METH_VARARGS,
   "V.PrepareForRender()\nC++: void PrepareForRender()\n\n"},
  {"SendAttribute", PyvtkGLSLShaderDeviceAdapter2_SendAttribute, METH_VARARGS,
   "V.SendAttribute(string, int, int, void, int)\nC++: void SendAttribute(const char *attrname, int components,\n    int type, const void *attribute, unsigned long offset=0)\n\nSends a single attribute to the graphics card. The attrname\nparameter identifies the name of attribute. The components\nparameter gives the number of components in the attribute.  In\ngeneral, components must be between 1-4, but a rendering system\nmay impose even more constraints.  The type parameter is a VTK\ntype enumeration (VTK_FLOAT, VTK_INT, etc.). Again, a rendering\nsystem may not support all types for all attributes.  The\nattribute parameter is the actual data for the attribute. If\noffset is specified, it is added to attribute pointer after it\nhas been casted to the proper type. If attribute is NULL, the\nOpenGL ID for the attribute will simply be cached.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGLSLShaderDeviceAdapter2_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkGLSLShaderDeviceAdapter2", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGLSLShaderDeviceAdapter2_StaticNew()
{
  return vtkGLSLShaderDeviceAdapter2::New();
}

PyObject *PyvtkGLSLShaderDeviceAdapter2_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGLSLShaderDeviceAdapter2_Type, PyvtkGLSLShaderDeviceAdapter2_Methods,
    "vtkGLSLShaderDeviceAdapter2",
    PyvtkGLSLShaderDeviceAdapter2_Doc(), &PyvtkGLSLShaderDeviceAdapter2_StaticNew);

  PyTypeObject *pytype = &PyvtkGLSLShaderDeviceAdapter2_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkShaderDeviceAdapter2_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGLSLShaderDeviceAdapter2_Doc()
{
  static const char *docstring[] = {
    "vtkGLSLShaderDeviceAdapter2 - adapter to pass generic vertex\nattributes to the rendering pipeline to be used in a\nvtkShaderProgram2.\n\n",
    "Superclass: vtkShaderDeviceAdapter2\n\n",
    "vtkShaderDeviceAdapter subclass for vtkShaderProgram2.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGLSLShaderDeviceAdapter2(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGLSLShaderDeviceAdapter2_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGLSLShaderDeviceAdapter2", o) != 0)
  {
    Py_DECREF(o);
  }

}

