// python wrapper for vtkHardwareSelectionPolyDataPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkHardwareSelectionPolyDataPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkHardwareSelectionPolyDataPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkHardwareSelectionPolyDataPainter_ClassNew(); }

#ifndef DECLARED_PyvtkStandardPolyDataPainter_ClassNew
extern "C" { PyObject *PyvtkStandardPolyDataPainter_ClassNew(); }
#define DECLARED_PyvtkStandardPolyDataPainter_ClassNew
#endif

static const char **PyvtkHardwareSelectionPolyDataPainter_Doc();


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkHardwareSelectionPolyDataPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkHardwareSelectionPolyDataPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkHardwareSelectionPolyDataPainter *tempr = vtkHardwareSelectionPolyDataPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkHardwareSelectionPolyDataPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkHardwareSelectionPolyDataPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_SetEnableSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEnableSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEnableSelection(temp0);
    }
    else
    {
      op->vtkHardwareSelectionPolyDataPainter::SetEnableSelection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_GetEnableSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEnableSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetEnableSelection() :
      op->vtkHardwareSelectionPolyDataPainter::GetEnableSelection());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_EnableSelectionOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EnableSelectionOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EnableSelectionOn();
    }
    else
    {
      op->vtkHardwareSelectionPolyDataPainter::EnableSelectionOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_EnableSelectionOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EnableSelectionOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EnableSelectionOff();
    }
    else
    {
      op->vtkHardwareSelectionPolyDataPainter::EnableSelectionOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_SetPointIdArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPointIdArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPointIdArrayName(temp0);
    }
    else
    {
      op->vtkHardwareSelectionPolyDataPainter::SetPointIdArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_GetPointIdArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPointIdArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetPointIdArrayName() :
      op->vtkHardwareSelectionPolyDataPainter::GetPointIdArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_SetCellIdArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCellIdArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCellIdArrayName(temp0);
    }
    else
    {
      op->vtkHardwareSelectionPolyDataPainter::SetCellIdArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_GetCellIdArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCellIdArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetCellIdArrayName() :
      op->vtkHardwareSelectionPolyDataPainter::GetCellIdArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_SetProcessIdArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetProcessIdArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetProcessIdArrayName(temp0);
    }
    else
    {
      op->vtkHardwareSelectionPolyDataPainter::SetProcessIdArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_GetProcessIdArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProcessIdArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetProcessIdArrayName() :
      op->vtkHardwareSelectionPolyDataPainter::GetProcessIdArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_SetCompositeIdArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompositeIdArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCompositeIdArrayName(temp0);
    }
    else
    {
      op->vtkHardwareSelectionPolyDataPainter::SetCompositeIdArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHardwareSelectionPolyDataPainter_GetCompositeIdArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompositeIdArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHardwareSelectionPolyDataPainter *op = static_cast<vtkHardwareSelectionPolyDataPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetCompositeIdArrayName() :
      op->vtkHardwareSelectionPolyDataPainter::GetCompositeIdArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkHardwareSelectionPolyDataPainter_Methods[] = {
  {"IsTypeOf", PyvtkHardwareSelectionPolyDataPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkHardwareSelectionPolyDataPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkHardwareSelectionPolyDataPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkHardwareSelectionPolyDataPainter\nC++: static vtkHardwareSelectionPolyDataPainter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkHardwareSelectionPolyDataPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkHardwareSelectionPolyDataPainter\nC++: vtkHardwareSelectionPolyDataPainter *NewInstance()\n\n"},
  {"SetEnableSelection", PyvtkHardwareSelectionPolyDataPainter_SetEnableSelection, METH_VARARGS,
   "V.SetEnableSelection(int)\nC++: virtual void SetEnableSelection(int _arg)\n\nEnable/Disable vtkHardwareSelector class. Useful when using this\npainter as an internal painter. Default is enabled.\n"},
  {"GetEnableSelection", PyvtkHardwareSelectionPolyDataPainter_GetEnableSelection, METH_VARARGS,
   "V.GetEnableSelection() -> int\nC++: virtual int GetEnableSelection()\n\nEnable/Disable vtkHardwareSelector class. Useful when using this\npainter as an internal painter. Default is enabled.\n"},
  {"EnableSelectionOn", PyvtkHardwareSelectionPolyDataPainter_EnableSelectionOn, METH_VARARGS,
   "V.EnableSelectionOn()\nC++: virtual void EnableSelectionOn()\n\nEnable/Disable vtkHardwareSelector class. Useful when using this\npainter as an internal painter. Default is enabled.\n"},
  {"EnableSelectionOff", PyvtkHardwareSelectionPolyDataPainter_EnableSelectionOff, METH_VARARGS,
   "V.EnableSelectionOff()\nC++: virtual void EnableSelectionOff()\n\nEnable/Disable vtkHardwareSelector class. Useful when using this\npainter as an internal painter. Default is enabled.\n"},
  {"SetPointIdArrayName", PyvtkHardwareSelectionPolyDataPainter_SetPointIdArrayName, METH_VARARGS,
   "V.SetPointIdArrayName(string)\nC++: virtual void SetPointIdArrayName(const char *_arg)\n\nBy default, this painters uses the dataset's point and cell ids\nduring rendering. However, one can override those by specifying\ncell and point data arrays to use instead. Currently, only\nvtkIdType array is supported. Set to NULL string (default) to use\nthe point ids instead.\n"},
  {"GetPointIdArrayName", PyvtkHardwareSelectionPolyDataPainter_GetPointIdArrayName, METH_VARARGS,
   "V.GetPointIdArrayName() -> string\nC++: virtual char *GetPointIdArrayName()\n\nBy default, this painters uses the dataset's point and cell ids\nduring rendering. However, one can override those by specifying\ncell and point data arrays to use instead. Currently, only\nvtkIdType array is supported. Set to NULL string (default) to use\nthe point ids instead.\n"},
  {"SetCellIdArrayName", PyvtkHardwareSelectionPolyDataPainter_SetCellIdArrayName, METH_VARARGS,
   "V.SetCellIdArrayName(string)\nC++: virtual void SetCellIdArrayName(const char *_arg)\n\nBy default, this painters uses the dataset's point and cell ids\nduring rendering. However, one can override those by specifying\ncell and point data arrays to use instead. Currently, only\nvtkIdType array is supported. Set to NULL string (default) to use\nthe point ids instead.\n"},
  {"GetCellIdArrayName", PyvtkHardwareSelectionPolyDataPainter_GetCellIdArrayName, METH_VARARGS,
   "V.GetCellIdArrayName() -> string\nC++: virtual char *GetCellIdArrayName()\n\nBy default, this painters uses the dataset's point and cell ids\nduring rendering. However, one can override those by specifying\ncell and point data arrays to use instead. Currently, only\nvtkIdType array is supported. Set to NULL string (default) to use\nthe point ids instead.\n"},
  {"SetProcessIdArrayName", PyvtkHardwareSelectionPolyDataPainter_SetProcessIdArrayName, METH_VARARGS,
   "V.SetProcessIdArrayName(string)\nC++: virtual void SetProcessIdArrayName(const char *_arg)\n\nIf the painter should override the process id using a data-array,\nset this variable to the name of the array to use. It must be a\npoint-array.\n"},
  {"GetProcessIdArrayName", PyvtkHardwareSelectionPolyDataPainter_GetProcessIdArrayName, METH_VARARGS,
   "V.GetProcessIdArrayName() -> string\nC++: virtual char *GetProcessIdArrayName()\n\nIf the painter should override the process id using a data-array,\nset this variable to the name of the array to use. It must be a\npoint-array.\n"},
  {"SetCompositeIdArrayName", PyvtkHardwareSelectionPolyDataPainter_SetCompositeIdArrayName, METH_VARARGS,
   "V.SetCompositeIdArrayName(string)\nC++: virtual void SetCompositeIdArrayName(const char *_arg)\n\nGenerally, vtkCompositePainter can render the composite id when\niterating over composite datasets. However in some cases (as in\nAMR), the rendered structure may not correspond to the input\ndata, in which case we need to provide a cell array that can be\nused to render in the composite id in selection passes. Set to\nNULL (default) to not override the composite id color set by\nvtkCompositePainter if any. The array *MUST* be a cell array and\nof type vtkUnsignedIntArray.\n"},
  {"GetCompositeIdArrayName", PyvtkHardwareSelectionPolyDataPainter_GetCompositeIdArrayName, METH_VARARGS,
   "V.GetCompositeIdArrayName() -> string\nC++: virtual char *GetCompositeIdArrayName()\n\nGenerally, vtkCompositePainter can render the composite id when\niterating over composite datasets. However in some cases (as in\nAMR), the rendered structure may not correspond to the input\ndata, in which case we need to provide a cell array that can be\nused to render in the composite id in selection passes. Set to\nNULL (default) to not override the composite id color set by\nvtkCompositePainter if any. The array *MUST* be a cell array and\nof type vtkUnsignedIntArray.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkHardwareSelectionPolyDataPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkHardwareSelectionPolyDataPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkHardwareSelectionPolyDataPainter_StaticNew()
{
  return vtkHardwareSelectionPolyDataPainter::New();
}

PyObject *PyvtkHardwareSelectionPolyDataPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkHardwareSelectionPolyDataPainter_Type, PyvtkHardwareSelectionPolyDataPainter_Methods,
    "vtkHardwareSelectionPolyDataPainter",
    PyvtkHardwareSelectionPolyDataPainter_Doc(), &PyvtkHardwareSelectionPolyDataPainter_StaticNew);

  PyTypeObject *pytype = &PyvtkHardwareSelectionPolyDataPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkStandardPolyDataPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkHardwareSelectionPolyDataPainter_Doc()
{
  static const char *docstring[] = {
    "vtkHardwareSelectionPolyDataPainter - painter used to render polydata\nfor selection passes.\n\n",
    "Superclass: vtkStandardPolyDataPainter\n\n",
    "vtkHardwareSelectionPolyDataPainter is a painter for polydata used\nwhen rendering hardware selection passes.\n@sa\nvtkHardwareSelector\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkHardwareSelectionPolyDataPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkHardwareSelectionPolyDataPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkHardwareSelectionPolyDataPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

