// python wrapper for vtkOpenGLModelViewProjectionMonitor
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkOpenGLModelViewProjectionMonitor.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLModelViewProjectionMonitor(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLModelViewProjectionMonitor_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkOpenGLModelViewProjectionMonitor_Doc();


static PyObject *
PyvtkOpenGLModelViewProjectionMonitor_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkOpenGLModelViewProjectionMonitor::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLModelViewProjectionMonitor_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLModelViewProjectionMonitor *op = static_cast<vtkOpenGLModelViewProjectionMonitor *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLModelViewProjectionMonitor::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLModelViewProjectionMonitor_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkOpenGLModelViewProjectionMonitor *tempr = vtkOpenGLModelViewProjectionMonitor::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLModelViewProjectionMonitor_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLModelViewProjectionMonitor *op = static_cast<vtkOpenGLModelViewProjectionMonitor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkOpenGLModelViewProjectionMonitor *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLModelViewProjectionMonitor::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLModelViewProjectionMonitor_StateChanged(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StateChanged");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLModelViewProjectionMonitor *op = static_cast<vtkOpenGLModelViewProjectionMonitor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->StateChanged() :
      op->vtkOpenGLModelViewProjectionMonitor::StateChanged());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLModelViewProjectionMonitor_Update(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLModelViewProjectionMonitor *op = static_cast<vtkOpenGLModelViewProjectionMonitor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Update();
    }
    else
    {
      op->vtkOpenGLModelViewProjectionMonitor::Update();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLModelViewProjectionMonitor_SetProjection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetProjection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLModelViewProjectionMonitor *op = static_cast<vtkOpenGLModelViewProjectionMonitor *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<float> store0(2*size0);
  float *temp0 = store0.Data();
  float *save0 = (size0 == 0 ? NULL : temp0 + size0);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetProjection(temp0);
    }
    else
    {
      op->vtkOpenGLModelViewProjectionMonitor::SetProjection(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLModelViewProjectionMonitor_SetModelView(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetModelView");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLModelViewProjectionMonitor *op = static_cast<vtkOpenGLModelViewProjectionMonitor *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<float> store0(2*size0);
  float *temp0 = store0.Data();
  float *save0 = (size0 == 0 ? NULL : temp0 + size0);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetModelView(temp0);
    }
    else
    {
      op->vtkOpenGLModelViewProjectionMonitor::SetModelView(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkOpenGLModelViewProjectionMonitor_Methods[] = {
  {"IsTypeOf", PyvtkOpenGLModelViewProjectionMonitor_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkOpenGLModelViewProjectionMonitor_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkOpenGLModelViewProjectionMonitor_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkOpenGLModelViewProjectionMonitor\nC++: static vtkOpenGLModelViewProjectionMonitor *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkOpenGLModelViewProjectionMonitor_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLModelViewProjectionMonitor\nC++: vtkOpenGLModelViewProjectionMonitor *NewInstance()\n\n"},
  {"StateChanged", PyvtkOpenGLModelViewProjectionMonitor_StateChanged, METH_VARARGS,
   "V.StateChanged() -> bool\nC++: bool StateChanged()\n\nFetches the current GL state and updates the internal copies of\nthe data. returns true if any of the tracked OpenGL matrices have\nchanged. Typically this is the only function a user needs to\ncall.\n"},
  {"Update", PyvtkOpenGLModelViewProjectionMonitor_Update, METH_VARARGS,
   "V.Update()\nC++: void Update()\n\nFetch and store OpenGL model view matrix. Note, this is done\nautomatically in SateChanged.\n"},
  {"SetProjection", PyvtkOpenGLModelViewProjectionMonitor_SetProjection, METH_VARARGS,
   "V.SetProjection([float, ...])\nC++: void SetProjection(float *val)\n\nSet the matrix data.\n"},
  {"SetModelView", PyvtkOpenGLModelViewProjectionMonitor_SetModelView, METH_VARARGS,
   "V.SetModelView([float, ...])\nC++: void SetModelView(float *val)\n\nSet the matrix data.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOpenGLModelViewProjectionMonitor_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkOpenGLModelViewProjectionMonitor", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLModelViewProjectionMonitor_StaticNew()
{
  return vtkOpenGLModelViewProjectionMonitor::New();
}

PyObject *PyvtkOpenGLModelViewProjectionMonitor_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLModelViewProjectionMonitor_Type, PyvtkOpenGLModelViewProjectionMonitor_Methods,
    "vtkOpenGLModelViewProjectionMonitor",
    PyvtkOpenGLModelViewProjectionMonitor_Doc(), &PyvtkOpenGLModelViewProjectionMonitor_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLModelViewProjectionMonitor_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOpenGLModelViewProjectionMonitor_Doc()
{
  static const char *docstring[] = {
    "vtkOpenGLModelViewProjectionMonitor - tracks state of OpenGL\nmodel-view and projection matrices.\n\n",
    "Superclass: vtkObject\n\n",
    "vtkOpenGLModelViewProjectionMonitor -- A helper for painters that\ntracks state of OpenGL model-view and projection matrices. A Painter\ncould use this to skip expensive processing that is only needed when\nthe model-view or projection matrices change.\n\nthis is not intended to be shared. each object should use it's own\ninstance of this class. it's intended to be called once per render.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOpenGLModelViewProjectionMonitor(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOpenGLModelViewProjectionMonitor_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLModelViewProjectionMonitor", o) != 0)
  {
    Py_DECREF(o);
  }

}

