// python wrapper for vtkOpenGLRepresentationPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkOpenGLRepresentationPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLRepresentationPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLRepresentationPainter_ClassNew(); }

#ifndef DECLARED_PyvtkRepresentationPainter_ClassNew
extern "C" { PyObject *PyvtkRepresentationPainter_ClassNew(); }
#define DECLARED_PyvtkRepresentationPainter_ClassNew
#endif

static const char **PyvtkOpenGLRepresentationPainter_Doc();


static PyObject *
PyvtkOpenGLRepresentationPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkOpenGLRepresentationPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLRepresentationPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLRepresentationPainter *op = static_cast<vtkOpenGLRepresentationPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLRepresentationPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLRepresentationPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkOpenGLRepresentationPainter *tempr = vtkOpenGLRepresentationPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLRepresentationPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLRepresentationPainter *op = static_cast<vtkOpenGLRepresentationPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkOpenGLRepresentationPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLRepresentationPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLRepresentationPainter_GetTimeToDraw(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeToDraw");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLRepresentationPainter *op = static_cast<vtkOpenGLRepresentationPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTimeToDraw() :
      op->vtkOpenGLRepresentationPainter::GetTimeToDraw());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkOpenGLRepresentationPainter_Methods[] = {
  {"IsTypeOf", PyvtkOpenGLRepresentationPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkOpenGLRepresentationPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkOpenGLRepresentationPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkOpenGLRepresentationPainter\nC++: static vtkOpenGLRepresentationPainter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkOpenGLRepresentationPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLRepresentationPainter\nC++: vtkOpenGLRepresentationPainter *NewInstance()\n\n"},
  {"GetTimeToDraw", PyvtkOpenGLRepresentationPainter_GetTimeToDraw, METH_VARARGS,
   "V.GetTimeToDraw() -> float\nC++: double GetTimeToDraw()\n\nThis painter overrides GetTimeToDraw() to never pass the request\nto the delegate. This is done since this class may propagate a\nsingle render request multiple times to the delegate. In that\ncase the time accumulation responsibility is borne by the painter\ncausing the multiple rendering requests i.e. this painter itself.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOpenGLRepresentationPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkOpenGLRepresentationPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLRepresentationPainter_StaticNew()
{
  return vtkOpenGLRepresentationPainter::New();
}

PyObject *PyvtkOpenGLRepresentationPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLRepresentationPainter_Type, PyvtkOpenGLRepresentationPainter_Methods,
    "vtkOpenGLRepresentationPainter",
    PyvtkOpenGLRepresentationPainter_Doc(), &PyvtkOpenGLRepresentationPainter_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLRepresentationPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkRepresentationPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOpenGLRepresentationPainter_Doc()
{
  static const char *docstring[] = {
    "vtkOpenGLRepresentationPainter - painter handling representation\nusing OpenGL.\n\n",
    "Superclass: vtkRepresentationPainter\n\n",
    "This is OpenGL implementation of a painter handling representation\ni.e. Points, Wireframe, Surface.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOpenGLRepresentationPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOpenGLRepresentationPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLRepresentationPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

