// python wrapper for vtkPainterDeviceAdapter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPainterDeviceAdapter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPainterDeviceAdapter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPainterDeviceAdapter_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkPainterDeviceAdapter_Doc();


static PyObject *
PyvtkPainterDeviceAdapter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPainterDeviceAdapter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPainterDeviceAdapter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPainterDeviceAdapter *tempr = vtkPainterDeviceAdapter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPainterDeviceAdapter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPainterDeviceAdapter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_BeginPrimitive(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "BeginPrimitive");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    op->BeginPrimitive(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_EndPrimitive(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EndPrimitive");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(0))
  {
    op->EndPrimitive();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_IsAttributesSupported(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsAttributesSupported");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = op->IsAttributesSupported(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_SendMultiTextureCoords(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SendMultiTextureCoords");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  int temp0;
  int temp1;
  void  *temp2 = NULL;
  Py_buffer pbuf2 = VTK_PYBUFFER_INITIALIZER;
  int temp3;
  vtkIdType temp4;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetBuffer(temp2, &pbuf2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4))
  {
    op->SendMultiTextureCoords(temp0, temp1, temp2, temp3, temp4);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf2.obj != 0)
  {
    PyBuffer_Release(&pbuf2);
  }
#endif
  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_SendAttribute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SendAttribute");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  int temp0;
  int temp1;
  int temp2;
  void  *temp3 = NULL;
  Py_buffer pbuf3 = VTK_PYBUFFER_INITIALIZER;
  vtkIdType temp4 = 0;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(4, 5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetBuffer(temp3, &pbuf3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    op->SendAttribute(temp0, temp1, temp2, temp3, temp4);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf3.obj != 0)
  {
    PyBuffer_Release(&pbuf3);
  }
#endif
  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_SetAttributePointer_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributePointer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  int temp0;
  vtkDataArray *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkDataArray"))
  {
    if (ap.IsBound())
    {
      op->SetAttributePointer(temp0, temp1);
    }
    else
    {
      op->vtkPainterDeviceAdapter::SetAttributePointer(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkPainterDeviceAdapter_SetAttributePointer_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributePointer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  int temp0;
  int temp1;
  int temp2;
  int temp3;
  void  *temp4 = NULL;
  Py_buffer pbuf4 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetBuffer(temp4, &pbuf4))
  {
    op->SetAttributePointer(temp0, temp1, temp2, temp3, temp4);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf4.obj != 0)
  {
    PyBuffer_Release(&pbuf4);
  }
#endif
  return result;
}

static PyObject *
PyvtkPainterDeviceAdapter_SetAttributePointer(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkPainterDeviceAdapter_SetAttributePointer_s1(self, args);
    case 5:
      return PyvtkPainterDeviceAdapter_SetAttributePointer_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetAttributePointer");
  return NULL;
}



static PyObject *
PyvtkPainterDeviceAdapter_EnableAttributeArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EnableAttributeArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    op->EnableAttributeArray(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_DisableAttributeArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DisableAttributeArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    op->DisableAttributeArray(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_DrawArrays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DrawArrays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  int temp0;
  vtkIdType temp1;
  vtkIdType temp2;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    op->DrawArrays(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_DrawElements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DrawElements");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  int temp0;
  vtkIdType temp1;
  int temp2;
  void  *temp3 = NULL;
  Py_buffer pbuf3 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetBuffer(temp3, &pbuf3))
  {
    op->DrawElements(temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf3.obj != 0)
  {
    PyBuffer_Release(&pbuf3);
  }
#endif
  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_Compatible(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Compatible");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  vtkRenderer *temp0 = NULL;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderer"))
  {
    int tempr = op->Compatible(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_MakeVertexEmphasis(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MakeVertexEmphasis");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    op->MakeVertexEmphasis(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_Stencil(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Stencil");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    op->Stencil(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_WriteStencil(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "WriteStencil");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    op->WriteStencil(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPainterDeviceAdapter_TestStencil(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "TestStencil");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPainterDeviceAdapter *op = static_cast<vtkPainterDeviceAdapter *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    op->TestStencil(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPainterDeviceAdapter_Methods[] = {
  {"IsTypeOf", PyvtkPainterDeviceAdapter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPainterDeviceAdapter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPainterDeviceAdapter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPainterDeviceAdapter\nC++: static vtkPainterDeviceAdapter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPainterDeviceAdapter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPainterDeviceAdapter\nC++: vtkPainterDeviceAdapter *NewInstance()\n\n"},
  {"BeginPrimitive", PyvtkPainterDeviceAdapter_BeginPrimitive, METH_VARARGS,
   "V.BeginPrimitive(int)\nC++: virtual void BeginPrimitive(int mode)\n\nSignals the start of sending a primitive to the graphics card. \nThe mode is one of VTK_VERTEX, VTK_POLY_VERTEX, VTK_LINE,\nVTK_POLY_LINE, VTK_TRIANGLE, VTK_TRIANGLE_STRIP, VTK_POLYGON, or\nVTK_QUAD.  The primitive is defined by the attributes sent\nbetween the calls to BeginPrimitive and EndPrimitive.  You do not\nneed to call EndPrimitive/BeginPrimitive between primitives that\nhave a constant number of points (i.e. VTK_VERTEX, VTK_LINE,\nVTK_TRIANGLE, and VTK_QUAD).\n"},
  {"EndPrimitive", PyvtkPainterDeviceAdapter_EndPrimitive, METH_VARARGS,
   "V.EndPrimitive()\nC++: virtual void EndPrimitive()\n\nSignals the end of sending a primitive to the graphics card.\n"},
  {"IsAttributesSupported", PyvtkPainterDeviceAdapter_IsAttributesSupported, METH_VARARGS,
   "V.IsAttributesSupported(int) -> int\nC++: virtual int IsAttributesSupported(int attribute)\n\nReturns if the given attribute type is supported by the device.\nReturns 1 is supported, 0 otherwise.\n"},
  {"SendMultiTextureCoords", PyvtkPainterDeviceAdapter_SendMultiTextureCoords, METH_VARARGS,
   "V.SendMultiTextureCoords(int, int, void, int, int)\nC++: virtual void SendMultiTextureCoords(int numcomp, int type,\n    const void *attribute, int idx, vtkIdType offset)\n\nCalls glMultiTex\n"},
  {"SendAttribute", PyvtkPainterDeviceAdapter_SendAttribute, METH_VARARGS,
   "V.SendAttribute(int, int, int, void, int)\nC++: virtual void SendAttribute(int index, int components,\n    int type, const void *attribute, vtkIdType offset=0)\n\nSends a single attribute to the graphics card.  The index\nparameter identifies the attribute.  Some indices have special\nmeaning (see vtkPainter for details).  The components parameter\ngives the number of components in the attribute.  In general,\ncomponents must be between 1-4, but a rendering system may impose\neven more constraints.  The type parameter is a VTK type\nenumeration (VTK_FLOAT, VTK_INT, etc.). Again, a rendering system\nmay not support all types for all attributes.  The attribute\nparameter is the actual data for the attribute. If offset is\nspecified, it is added to attribute pointer after it has been\ncasted to the proper type.\n"},
  {"SetAttributePointer", PyvtkPainterDeviceAdapter_SetAttributePointer, METH_VARARGS,
   "V.SetAttributePointer(int, vtkDataArray)\nC++: void SetAttributePointer(int index,\n    vtkDataArray *attributeArray)\nV.SetAttributePointer(int, int, int, int, void)\nC++: virtual void SetAttributePointer(int index,\n    int numcomponents, int type, int stride, const void *pointer)\n\nSets an array of attributes.  This allows you to send all the\ndata for a particular attribute with one call, thus greatly\nreducing function call overhead.  Once set, the array is enabled\nwith EnableAttributeArray, and the data is sent with a call to\nDrawArrays DrawElements.\n"},
  {"EnableAttributeArray", PyvtkPainterDeviceAdapter_EnableAttributeArray, METH_VARARGS,
   "V.EnableAttributeArray(int)\nC++: virtual void EnableAttributeArray(int index)\n\nEnable/disable the attribute array set with SetAttributePointer.\n"},
  {"DisableAttributeArray", PyvtkPainterDeviceAdapter_DisableAttributeArray, METH_VARARGS,
   "V.DisableAttributeArray(int)\nC++: virtual void DisableAttributeArray(int index)\n\nEnable/disable the attribute array set with SetAttributePointer.\n"},
  {"DrawArrays", PyvtkPainterDeviceAdapter_DrawArrays, METH_VARARGS,
   "V.DrawArrays(int, int, int)\nC++: virtual void DrawArrays(int mode, vtkIdType first,\n    vtkIdType count)\n\nSend a section of the enabled attribute pointers to the graphics\ncard to define a primitive.  The mode is one of VTK_VERTEX,\nVTK_POLY_VERTEX, VTK_LINE, VTK_POLY_LINE, VTK_TRIANGLE,\nVTK_TRIANGLE_STRIP, VTK_POLYGON, or VTK_QUAD.  It identifies\nwhich type of primitive the attribute data is defining.  The\nparameters first and count identify what part of the attribute\narrays define the given primitive.  If mode is a primitive that\nhas a constant number of points (i.e. VTK_VERTEX, VTK_LINE,\nVTK_TRIANGLE, and VTK_QUAD), you may draw multiple primitives\nwith one call to DrawArrays.\n"},
  {"DrawElements", PyvtkPainterDeviceAdapter_DrawElements, METH_VARARGS,
   "V.DrawElements(int, int, int, void)\nC++: virtual void DrawElements(int mode, vtkIdType count,\n    int type, void *indices)\n\nSend items in the attribute pointers to the graphics card to\ndefine a primitive.  The mode is one of VTK_VERTEX,\nVTK_POLY_VERTEX, VTK_LINE, VTK_POLY_LINE, VTK_TRIANGLE,\nVTK_TRIANGLE_STRIP, VTK_POLYGON, or VTK_QUAD.  It identifies\nwhich type of primitive the attribute data is defining.  The\nindices array holds the list of attribute elements that define\nthe primitive.  The count and type parameters give the number and\ndata type of the indices array.  The type parameter is a VTK type\nenumeration (VTK_UNSIGNED_INT, ...).  The type should be an\ninteger type (for obvious reasons).  If mode is a primitive that\nhas a constant number of points (i.e. VTK_VERTEX, VTK_LINE,\nVTK_TRIANGLE, and VTK_QUAD), you may draw multiple primitives\nwith one call to DrawArrays.\n"},
  {"Compatible", PyvtkPainterDeviceAdapter_Compatible, METH_VARARGS,
   "V.Compatible(vtkRenderer) -> int\nC++: virtual int Compatible(vtkRenderer *renderer)\n\nReturns true if this device adapter is compatible with the given\nvtkRenderer.\n"},
  {"MakeVertexEmphasis", PyvtkPainterDeviceAdapter_MakeVertexEmphasis, METH_VARARGS,
   "V.MakeVertexEmphasis(bool)\nC++: virtual void MakeVertexEmphasis(bool mode)\n\nTurns emphasis of vertices on or off for vertex selection.\n"},
  {"Stencil", PyvtkPainterDeviceAdapter_Stencil, METH_VARARGS,
   "V.Stencil(int)\nC++: virtual void Stencil(int on)\n\nControl use of the stencil buffer (for vertex selection).\n"},
  {"WriteStencil", PyvtkPainterDeviceAdapter_WriteStencil, METH_VARARGS,
   "V.WriteStencil(int)\nC++: virtual void WriteStencil(vtkIdType value)\n\nControl use of the stencil buffer (for vertex selection).\n"},
  {"TestStencil", PyvtkPainterDeviceAdapter_TestStencil, METH_VARARGS,
   "V.TestStencil(int)\nC++: virtual void TestStencil(vtkIdType value)\n\nControl use of the stencil buffer (for vertex selection).\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPainterDeviceAdapter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingCorePython.vtkPainterDeviceAdapter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPainterDeviceAdapter_StaticNew()
{
  return vtkPainterDeviceAdapter::New();
}

PyObject *PyvtkPainterDeviceAdapter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPainterDeviceAdapter_Type, PyvtkPainterDeviceAdapter_Methods,
    "vtkPainterDeviceAdapter",
    PyvtkPainterDeviceAdapter_Doc(), &PyvtkPainterDeviceAdapter_StaticNew);

  PyTypeObject *pytype = &PyvtkPainterDeviceAdapter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPainterDeviceAdapter_Doc()
{
  static const char *docstring[] = {
    "vtkPainterDeviceAdapter - An adapter between a vtkPainter and a\nrendering device.\n\n",
    "Superclass: vtkObject\n\n",
    "This class is an adapter between a vtkPainter and a rendering device\n(such as an OpenGL machine).  Having an abstract adapter allows\nvtkPainters to be re-used for any rendering system.\n\nAlthough VTK really only uses OpenGL right now, there are reasons to\nswap out the rendering functions.  Sometimes MESA with mangled names\nis used.  Also, different shader extensions use different functions.\nFurther",
    "more, Cg also has its own interface.\n\nThe interface for this class should be familier to anyone experienced\nwith OpenGL.\n\n@sa\nvtkPainter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPainterDeviceAdapter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPainterDeviceAdapter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPainterDeviceAdapter", o) != 0)
  {
    Py_DECREF(o);
  }

}

