// python wrapper for vtkShader2Collection
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkShader2Collection.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkShader2Collection(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkShader2Collection_ClassNew(); }

#ifndef DECLARED_PyvtkCollection_ClassNew
extern "C" { PyObject *PyvtkCollection_ClassNew(); }
#define DECLARED_PyvtkCollection_ClassNew
#endif

static const char **PyvtkShader2Collection_Doc();


static PyObject *
PyvtkShader2Collection_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkShader2Collection::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkShader2Collection::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkShader2Collection *tempr = vtkShader2Collection::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkShader2Collection *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkShader2Collection::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_GetMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetMTime() :
      op->vtkShader2Collection::GetMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_AddItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  vtkShader2 *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkShader2"))
  {
    if (ap.IsBound())
    {
      op->AddItem(temp0);
    }
    else
    {
      op->vtkShader2Collection::AddItem(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_GetNextShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNextShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkShader2 *tempr = (ap.IsBound() ?
      op->GetNextShader() :
      op->vtkShader2Collection::GetNextShader());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_GetLastShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkShader2 *tempr = (ap.IsBound() ?
      op->GetLastShader() :
      op->vtkShader2Collection::GetLastShader());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_AddCollection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddCollection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  vtkShader2Collection *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkShader2Collection"))
  {
    if (ap.IsBound())
    {
      op->AddCollection(temp0);
    }
    else
    {
      op->vtkShader2Collection::AddCollection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_RemoveCollection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveCollection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  vtkShader2Collection *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkShader2Collection"))
  {
    if (ap.IsBound())
    {
      op->RemoveCollection(temp0);
    }
    else
    {
      op->vtkShader2Collection::RemoveCollection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_HasVertexShaders(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasVertexShaders");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasVertexShaders() :
      op->vtkShader2Collection::HasVertexShaders());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_HasTessellationControlShaders(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasTessellationControlShaders");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasTessellationControlShaders() :
      op->vtkShader2Collection::HasTessellationControlShaders());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_HasTessellationEvaluationShaders(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasTessellationEvaluationShaders");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasTessellationEvaluationShaders() :
      op->vtkShader2Collection::HasTessellationEvaluationShaders());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_HasGeometryShaders(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasGeometryShaders");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasGeometryShaders() :
      op->vtkShader2Collection::HasGeometryShaders());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_HasFragmentShaders(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasFragmentShaders");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasFragmentShaders() :
      op->vtkShader2Collection::HasFragmentShaders());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkShader2Collection_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkShader2Collection *op = static_cast<vtkShader2Collection *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources();
    }
    else
    {
      op->vtkShader2Collection::ReleaseGraphicsResources();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkShader2Collection_Methods[] = {
  {"IsTypeOf", PyvtkShader2Collection_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkShader2Collection_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkShader2Collection_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkShader2Collection\nC++: static vtkShader2Collection *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkShader2Collection_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkShader2Collection\nC++: vtkShader2Collection *NewInstance()\n\n"},
  {"GetMTime", PyvtkShader2Collection_GetMTime, METH_VARARGS,
   "V.GetMTime() -> int\nC++: vtkMTimeType GetMTime()\n\nModified GetMTime because the collection time depends on the\ncontent of the shaders.\n"},
  {"AddItem", PyvtkShader2Collection_AddItem, METH_VARARGS,
   "V.AddItem(vtkShader2)\nC++: void AddItem(vtkShader2 *shader)\n\nAdd a shader to the bottom of the list.\n"},
  {"GetNextShader", PyvtkShader2Collection_GetNextShader, METH_VARARGS,
   "V.GetNextShader() -> vtkShader2\nC++: vtkShader2 *GetNextShader()\n\nGet the next shader in the list.\n"},
  {"GetLastShader", PyvtkShader2Collection_GetLastShader, METH_VARARGS,
   "V.GetLastShader() -> vtkShader2\nC++: vtkShader2 *GetLastShader()\n\nGet the last shader in the list.\n"},
  {"AddCollection", PyvtkShader2Collection_AddCollection, METH_VARARGS,
   "V.AddCollection(vtkShader2Collection)\nC++: void AddCollection(vtkShader2Collection *other)\n\nAdd the elements of `other' to the end of `this'.\n\\pre other_exists: other!=0\n\\pre not_self: other!=this\n\\post added: this->GetNumberOfItems()=old\n    this->GetNumberOfItems()+other->GetNumberOfItems()\n"},
  {"RemoveCollection", PyvtkShader2Collection_RemoveCollection, METH_VARARGS,
   "V.RemoveCollection(vtkShader2Collection)\nC++: void RemoveCollection(vtkShader2Collection *other)\n\nRemove the elements of `other' from `this'. It assumes that\n`this' already has all the elements of `other' added\ncontiguously.\n\\pre other_exists: other!=0\n\\pre not_self: other!=this\n\\post removed: this->GetNumberOfItems()=old\n    this->GetNumberOfItems()-other->GetNumberOfItems()\n"},
  {"HasVertexShaders", PyvtkShader2Collection_HasVertexShaders, METH_VARARGS,
   "V.HasVertexShaders() -> bool\nC++: bool HasVertexShaders()\n\nTells if at least one of the shaders is a vertex shader. If yes,\nit means the vertex processing of the fixed-pipeline is bypassed.\nIf no, it means the vertex processing of the fixed-pipeline is\nused.\n"},
  {"HasTessellationControlShaders", PyvtkShader2Collection_HasTessellationControlShaders, METH_VARARGS,
   "V.HasTessellationControlShaders() -> bool\nC++: bool HasTessellationControlShaders()\n\nTells if at least one of the shaders is a tessellation control\nshader.\n"},
  {"HasTessellationEvaluationShaders", PyvtkShader2Collection_HasTessellationEvaluationShaders, METH_VARARGS,
   "V.HasTessellationEvaluationShaders() -> bool\nC++: bool HasTessellationEvaluationShaders()\n\nTells if at least one of the shaders is a tessellation evaluation\nshader.\n"},
  {"HasGeometryShaders", PyvtkShader2Collection_HasGeometryShaders, METH_VARARGS,
   "V.HasGeometryShaders() -> bool\nC++: bool HasGeometryShaders()\n\nTells if at least one of the shaders is a geometry shader.\n"},
  {"HasFragmentShaders", PyvtkShader2Collection_HasFragmentShaders, METH_VARARGS,
   "V.HasFragmentShaders() -> bool\nC++: bool HasFragmentShaders()\n\nTells if at least one of the shaders is a fragment shader. If\nyes, it means the fragment processing of the fixed-pipeline is\nbypassed. If no, it means the fragment processing of the\nfixed-pipeline is used.\n"},
  {"ReleaseGraphicsResources", PyvtkShader2Collection_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources()\nC++: void ReleaseGraphicsResources()\n\nRelease OpenGL resources (shader id of each item).\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkShader2Collection_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkShader2Collection", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkShader2Collection_StaticNew()
{
  return vtkShader2Collection::New();
}

PyObject *PyvtkShader2Collection_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkShader2Collection_Type, PyvtkShader2Collection_Methods,
    "vtkShader2Collection",
    PyvtkShader2Collection_Doc(), &PyvtkShader2Collection_StaticNew);

  PyTypeObject *pytype = &PyvtkShader2Collection_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkCollection_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkShader2Collection_Doc()
{
  static const char *docstring[] = {
    "vtkShader2Collection - an ordered list of Shader2 objects.\n\n",
    "Superclass: vtkCollection\n\n",
    "vtkShader2Collection represents and provides methods to manipulate a\nlist of Shader2 objects. The list is ordered and duplicate entries\nare not prevented.\n\n@sa\nvtkShader2 vtkCollection\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkShader2Collection(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkShader2Collection_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkShader2Collection", o) != 0)
  {
    Py_DECREF(o);
  }

}

