/* DO NOT EDIT.
 * Generated by ../../bin/vtkEncodeString
 * 
 * Define the vtkUncertaintySurfacePainter_fs string.
 *
 * Generated from file: /builddir/build/BUILD/ParaView-v5.4.1/Plugins/UncertaintyRendering/vtkUncertaintySurfacePainter_fs.glsl
 */
const char *vtkUncertaintySurfacePainter_fs =
"#version 120\n"
"\n"
"varying vec4 vColor;\n"
"varying vec3 v_texCoord3D;\n"
"varying float vUncertainty;\n"
"uniform sampler2D texture;\n"
"uniform float uncertaintyScaleFactor;\n"
"uniform float scalarValueRange;\n"
"uniform sampler2D permTexture;\n"
"uniform sampler1D simplexTexture;\n"
"uniform sampler2D gradTexture;\n"
"\n"
"/*\n"
" * To create offsets of one texel and one half texel in the\n"
" * texture lookup, we need to know the texture image size.\n"
" */\n"
"#define ONE 0.00390625\n"
"#define ONEHALF 0.001953125\n"
"// The numbers above are 1/256 and 0.5/256, change accordingly\n"
"// if you change the code to use another texture size.\n"
"\n"
"/*\n"
" * 4D simplex noise. A lot faster than classic 4D noise, and better looking.\n"
" */\n"
"float snoise(vec4 P)\n"
"{\n"
"\n"
"// The skewing and unskewing factors are hairy again for the 4D case\n"
"// This is (sqrt(5.0)-1.0)/4.0\n"
"#define F4 0.309016994375\n"
"// This is (5.0-sqrt(5.0))/20.0\n"
"#define G4 0.138196601125\n"
"\n"
"  // Skew the (x,y,z,w) space to determine which cell of 24 simplices we're in\n"
"  float s = (P.x + P.y + P.z + P.w) * F4; // Factor for 4D skewing\n"
"  vec4 Pi = floor(P + s);\n"
"  float t = (Pi.x + Pi.y + Pi.z + Pi.w) * G4;\n"
"  vec4 P0 = Pi - t;        // Unskew the cell origin back to (x,y,z,w) space\n"
"  Pi = Pi * ONE + ONEHALF; // Integer part, scaled and offset for texture lookup\n"
"\n"
"  vec4 Pf0 = P - P0; // The x,y distances from the cell origin\n"
"\n"
"  // For the 4D case, the simplex is a 4D shape I won't even try to describe.\n"
"  // To find out which of the 24 possible simplices we're in, we need to\n"
"  // determine the magnitude ordering of x, y, z and w components of Pf0.\n"
"  // The method below is presented without explanation. It uses a small 1D\n"
"  // texture as a lookup table. The table is designed to work for both\n"
"  // 3D and 4D noise and contains 64 indices, of which only 24 are actually\n"
"  // used. An extension to 5D would require a larger texture here.\n"
"  float c1 = (Pf0.x > Pf0.y) ? 0.5078125 : 0.0078125; // 1/2 + 1/128\n"
"  float c2 = (Pf0.x > Pf0.z) ? 0.25 : 0.0;\n"
"  float c3 = (Pf0.y > Pf0.z) ? 0.125 : 0.0;\n"
"  float c4 = (Pf0.x > Pf0.w) ? 0.0625 : 0.0;\n"
"  float c5 = (Pf0.y > Pf0.w) ? 0.03125 : 0.0;\n"
"  float c6 = (Pf0.z > Pf0.w) ? 0.015625 : 0.0;\n"
"  float sindex = c1 + c2 + c3 + c4 + c5 + c6;\n"
"  vec4 offsets = texture1D(simplexTexture, sindex).rgba;\n"
"  vec4 o1 = step(0.625, offsets);\n"
"  vec4 o2 = step(0.375, offsets);\n"
"  vec4 o3 = step(0.125, offsets);\n"
"\n"
"  // Noise contribution from simplex origin\n"
"  float perm0xy = texture2D(permTexture, Pi.xy).a;\n"
"  float perm0zw = texture2D(permTexture, Pi.zw).a;\n"
"  vec4 grad0 = texture2D(gradTexture, vec2(perm0xy, perm0zw)).rgba * 4.0 - 1.0;\n"
"  float t0 = 0.6 - dot(Pf0, Pf0);\n"
"  float n0;\n"
"  if (t0 < 0.0)\n"
"    n0 = 0.0;\n"
"  else\n"
"  {\n"
"    t0 *= t0;\n"
"    n0 = t0 * t0 * dot(grad0, Pf0);\n"
"  }\n"
"\n"
"  // Noise contribution from second corner\n"
"  vec4 Pf1 = Pf0 - o1 + G4;\n"
"  o1 = o1 * ONE;\n"
"  float perm1xy = texture2D(permTexture, Pi.xy + o1.xy).a;\n"
"  float perm1zw = texture2D(permTexture, Pi.zw + o1.zw).a;\n"
"  vec4 grad1 = texture2D(gradTexture, vec2(perm1xy, perm1zw)).rgba * 4.0 - 1.0;\n"
"  float t1 = 0.6 - dot(Pf1, Pf1);\n"
"  float n1;\n"
"  if (t1 < 0.0)\n"
"    n1 = 0.0;\n"
"  else\n"
"  {\n"
"    t1 *= t1;\n"
"    n1 = t1 * t1 * dot(grad1, Pf1);\n"
"  }\n"
"\n"
"  // Noise contribution from third corner\n"
"  vec4 Pf2 = Pf0 - o2 + 2.0 * G4;\n"
"  o2 = o2 * ONE;\n"
"  float perm2xy = texture2D(permTexture, Pi.xy + o2.xy).a;\n"
"  float perm2zw = texture2D(permTexture, Pi.zw + o2.zw).a;\n"
"  vec4 grad2 = texture2D(gradTexture, vec2(perm2xy, perm2zw)).rgba * 4.0 - 1.0;\n"
"  float t2 = 0.6 - dot(Pf2, Pf2);\n"
"  float n2;\n"
"  if (t2 < 0.0)\n"
"    n2 = 0.0;\n"
"  else\n"
"  {\n"
"    t2 *= t2;\n"
"    n2 = t2 * t2 * dot(grad2, Pf2);\n"
"  }\n"
"\n"
"  // Noise contribution from fourth corner\n"
"  vec4 Pf3 = Pf0 - o3 + 3.0 * G4;\n"
"  o3 = o3 * ONE;\n"
"  float perm3xy = texture2D(permTexture, Pi.xy + o3.xy).a;\n"
"  float perm3zw = texture2D(permTexture, Pi.zw + o3.zw).a;\n"
"  vec4 grad3 = texture2D(gradTexture, vec2(perm3xy, perm3zw)).rgba * 4.0 - 1.0;\n"
"  float t3 = 0.6 - dot(Pf3, Pf3);\n"
"  float n3;\n"
"  if (t3 < 0.0)\n"
"    n3 = 0.0;\n"
"  else\n"
"  {\n"
"    t3 *= t3;\n"
"    n3 = t3 * t3 * dot(grad3, Pf3);\n"
"  }\n"
"\n"
"  // Noise contribution from last corner\n"
"  vec4 Pf4 = Pf0 - vec4(1.0 - 4.0 * G4);\n"
"  float perm4xy = texture2D(permTexture, Pi.xy + vec2(ONE, ONE)).a;\n"
"  float perm4zw = texture2D(permTexture, Pi.zw + vec2(ONE, ONE)).a;\n"
"  vec4 grad4 = texture2D(gradTexture, vec2(perm4xy, perm4zw)).rgba * 4.0 - 1.0;\n"
"  float t4 = 0.6 - dot(Pf4, Pf4);\n"
"  float n4;\n"
"  if (t4 < 0.0)\n"
"    n4 = 0.0;\n"
"  else\n"
"  {\n"
"    t4 *= t4;\n"
"    n4 = t4 * t4 * dot(grad4, Pf4);\n"
"  }\n"
"\n"
"  // Sum up and scale the result to cover the range [-1,1]\n"
"  return 27.0 * (n0 + n1 + n2 + n3 + n4);\n"
"}\n"
"\n"
"vec2 mix_random_noise(vec2 inputCoord, float uncertainty)\n"
"{\n"
"  float n = 0.0;\n"
"  float s = uncertaintyScaleFactor;\n"
"  int octs = 5;\n"
"  for (int i = 0; i < octs; i++)\n"
"  {\n"
"    n += snoise(vec4(4.0 * pow(2.0, float(i)) * s * v_texCoord3D.xyz, gl_TexCoord[0].x));\n"
"  }\n"
"  n /= float(octs);\n"
"\n"
"  float scale = scalarValueRange;\n"
"\n"
"  inputCoord.x = clamp(inputCoord.x + uncertaintyScaleFactor * uncertainty / scale * n, 0.0f, 1.0f);\n"
"  return inputCoord;\n"
"}\n"
"\n"
"void main()\n"
"{\n"
"  // offset the texture coordinate by the uncertainty value\n"
"  float uncertainty = vUncertainty;\n"
"  vec2 coord = mix_random_noise(gl_TexCoord[0].xy, uncertainty);\n"
"  gl_FragColor = vColor * texture2D(texture, coord);\n"
"}\n"
"\n";

