// python wrapper for vtkChooserPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkChooserPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkChooserPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkChooserPainter_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataPainter_ClassNew
extern "C" { PyObject *PyvtkPolyDataPainter_ClassNew(); }
#define DECLARED_PyvtkPolyDataPainter_ClassNew
#endif

static const char **PyvtkChooserPainter_Doc();


static PyObject *
PyvtkChooserPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkChooserPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChooserPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChooserPainter *op = static_cast<vtkChooserPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkChooserPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChooserPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkChooserPainter *tempr = vtkChooserPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChooserPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChooserPainter *op = static_cast<vtkChooserPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkChooserPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkChooserPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkChooserPainter_SetVertPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVertPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChooserPainter *op = static_cast<vtkChooserPainter *>(vp);

  vtkPolyDataPainter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPolyDataPainter"))
  {
    if (ap.IsBound())
    {
      op->SetVertPainter(temp0);
    }
    else
    {
      op->vtkChooserPainter::SetVertPainter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChooserPainter_SetLinePainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLinePainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChooserPainter *op = static_cast<vtkChooserPainter *>(vp);

  vtkPolyDataPainter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPolyDataPainter"))
  {
    if (ap.IsBound())
    {
      op->SetLinePainter(temp0);
    }
    else
    {
      op->vtkChooserPainter::SetLinePainter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChooserPainter_SetPolyPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPolyPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChooserPainter *op = static_cast<vtkChooserPainter *>(vp);

  vtkPolyDataPainter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPolyDataPainter"))
  {
    if (ap.IsBound())
    {
      op->SetPolyPainter(temp0);
    }
    else
    {
      op->vtkChooserPainter::SetPolyPainter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChooserPainter_SetStripPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStripPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChooserPainter *op = static_cast<vtkChooserPainter *>(vp);

  vtkPolyDataPainter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPolyDataPainter"))
  {
    if (ap.IsBound())
    {
      op->SetStripPainter(temp0);
    }
    else
    {
      op->vtkChooserPainter::SetStripPainter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkChooserPainter_Methods[] = {
  {"IsTypeOf", PyvtkChooserPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkChooserPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkChooserPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkChooserPainter\nC++: static vtkChooserPainter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkChooserPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkChooserPainter\nC++: vtkChooserPainter *NewInstance()\n\n"},
  {"SetVertPainter", PyvtkChooserPainter_SetVertPainter, METH_VARARGS,
   "V.SetVertPainter(vtkPolyDataPainter)\nC++: void SetVertPainter(vtkPolyDataPainter *)\n\n"},
  {"SetLinePainter", PyvtkChooserPainter_SetLinePainter, METH_VARARGS,
   "V.SetLinePainter(vtkPolyDataPainter)\nC++: void SetLinePainter(vtkPolyDataPainter *)\n\n"},
  {"SetPolyPainter", PyvtkChooserPainter_SetPolyPainter, METH_VARARGS,
   "V.SetPolyPainter(vtkPolyDataPainter)\nC++: void SetPolyPainter(vtkPolyDataPainter *)\n\n"},
  {"SetStripPainter", PyvtkChooserPainter_SetStripPainter, METH_VARARGS,
   "V.SetStripPainter(vtkPolyDataPainter)\nC++: void SetStripPainter(vtkPolyDataPainter *)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkChooserPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkChooserPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkChooserPainter_StaticNew()
{
  return vtkChooserPainter::New();
}

PyObject *PyvtkChooserPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkChooserPainter_Type, PyvtkChooserPainter_Methods,
    "vtkChooserPainter",
    PyvtkChooserPainter_Doc(), &PyvtkChooserPainter_StaticNew);

  PyTypeObject *pytype = &PyvtkChooserPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkChooserPainter_Doc()
{
  static const char *docstring[] = {
    "vtkChooserPainter - Painter that selects painters to render\nprimitives.\n\n",
    "Superclass: vtkPolyDataPainter\n\n",
    "This painter does not actually do any painting.  Instead, it picks\nother painters based on the current state of itself and its poly\ndata.  It then delegates the work to these other painters.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkChooserPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkChooserPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkChooserPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

