// python wrapper for vtkClipPlanesPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkClipPlanesPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkClipPlanesPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkClipPlanesPainter_ClassNew(); }

#ifndef DECLARED_PyvtkPainter_ClassNew
extern "C" { PyObject *PyvtkPainter_ClassNew(); }
#define DECLARED_PyvtkPainter_ClassNew
#endif

static const char **PyvtkClipPlanesPainter_Doc();


static PyObject *
PyvtkClipPlanesPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkClipPlanesPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkClipPlanesPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkClipPlanesPainter *op = static_cast<vtkClipPlanesPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkClipPlanesPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkClipPlanesPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkClipPlanesPainter *tempr = vtkClipPlanesPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkClipPlanesPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkClipPlanesPainter *op = static_cast<vtkClipPlanesPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkClipPlanesPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkClipPlanesPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkClipPlanesPainter_CLIPPING_PLANES(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "CLIPPING_PLANES");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationObjectBaseKey *tempr = vtkClipPlanesPainter::CLIPPING_PLANES();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkClipPlanesPainter_Methods[] = {
  {"IsTypeOf", PyvtkClipPlanesPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkClipPlanesPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkClipPlanesPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkClipPlanesPainter\nC++: static vtkClipPlanesPainter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkClipPlanesPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkClipPlanesPainter\nC++: vtkClipPlanesPainter *NewInstance()\n\n"},
  {"CLIPPING_PLANES", PyvtkClipPlanesPainter_CLIPPING_PLANES, METH_VARARGS,
   "V.CLIPPING_PLANES() -> vtkInformationObjectBaseKey\nC++: static vtkInformationObjectBaseKey *CLIPPING_PLANES()\n\nGet/Set the vtkPlaneCollection which specifies the clipping\nplanes.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkClipPlanesPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkClipPlanesPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkClipPlanesPainter_StaticNew()
{
  return vtkClipPlanesPainter::New();
}

PyObject *PyvtkClipPlanesPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkClipPlanesPainter_Type, PyvtkClipPlanesPainter_Methods,
    "vtkClipPlanesPainter",
    PyvtkClipPlanesPainter_Doc(), &PyvtkClipPlanesPainter_StaticNew);

  PyTypeObject *pytype = &PyvtkClipPlanesPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkClipPlanesPainter_Doc()
{
  static const char *docstring[] = {
    "vtkClipPlanesPainter - abstract class defining interface for painter\nthat manages clipping.\n\n",
    "Superclass: vtkPainter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkClipPlanesPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkClipPlanesPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkClipPlanesPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

