// python wrapper for vtkCoincidentTopologyResolutionPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkCoincidentTopologyResolutionPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkCoincidentTopologyResolutionPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkCoincidentTopologyResolutionPainter_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataPainter_ClassNew
extern "C" { PyObject *PyvtkPolyDataPainter_ClassNew(); }
#define DECLARED_PyvtkPolyDataPainter_ClassNew
#endif

static const char **PyvtkCoincidentTopologyResolutionPainter_Doc();


static PyObject *
PyvtkCoincidentTopologyResolutionPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkCoincidentTopologyResolutionPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCoincidentTopologyResolutionPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCoincidentTopologyResolutionPainter *op = static_cast<vtkCoincidentTopologyResolutionPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkCoincidentTopologyResolutionPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCoincidentTopologyResolutionPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkCoincidentTopologyResolutionPainter *tempr = vtkCoincidentTopologyResolutionPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCoincidentTopologyResolutionPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCoincidentTopologyResolutionPainter *op = static_cast<vtkCoincidentTopologyResolutionPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkCoincidentTopologyResolutionPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkCoincidentTopologyResolutionPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkCoincidentTopologyResolutionPainter_RESOLVE_COINCIDENT_TOPOLOGY(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "RESOLVE_COINCIDENT_TOPOLOGY");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkCoincidentTopologyResolutionPainter::RESOLVE_COINCIDENT_TOPOLOGY();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCoincidentTopologyResolutionPainter_Z_SHIFT(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "Z_SHIFT");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationDoubleKey *tempr = vtkCoincidentTopologyResolutionPainter::Z_SHIFT();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCoincidentTopologyResolutionPainter_POLYGON_OFFSET_PARAMETERS(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "POLYGON_OFFSET_PARAMETERS");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationDoubleVectorKey *tempr = vtkCoincidentTopologyResolutionPainter::POLYGON_OFFSET_PARAMETERS();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCoincidentTopologyResolutionPainter_POLYGON_OFFSET_FACES(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "POLYGON_OFFSET_FACES");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkCoincidentTopologyResolutionPainter::POLYGON_OFFSET_FACES();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkCoincidentTopologyResolutionPainter_Methods[] = {
  {"IsTypeOf", PyvtkCoincidentTopologyResolutionPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkCoincidentTopologyResolutionPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkCoincidentTopologyResolutionPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkCoincidentTopologyResolutionPainter\nC++: static vtkCoincidentTopologyResolutionPainter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkCoincidentTopologyResolutionPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkCoincidentTopologyResolutionPainter\nC++: vtkCoincidentTopologyResolutionPainter *NewInstance()\n\n"},
  {"RESOLVE_COINCIDENT_TOPOLOGY", PyvtkCoincidentTopologyResolutionPainter_RESOLVE_COINCIDENT_TOPOLOGY, METH_VARARGS,
   "V.RESOLVE_COINCIDENT_TOPOLOGY() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *RESOLVE_COINCIDENT_TOPOLOGY(\n    )\n\nSet/Get a global flag that controls whether coincident topology\n(e.g., a line on top of a polygon) is shifted to avoid z-buffer\nresolution (and hence rendering problems). If not off, there are\ntwo methods to choose from. PolygonOffset uses graphics systems\ncalls to shift polygons, but does not distinguish vertices and\nlines from one another. ShiftZBuffer remaps the z-buffer to\ndistinguish vertices, lines, and polygons, but does not always\nproduce acceptable results. If you use the ShiftZBuffer approach,\nyou may also want to set the ResolveCoincidentTopologyZShift\nvalue. (Note: not all mappers/graphics systems implement this\nfunctionality.)\n"},
  {"Z_SHIFT", PyvtkCoincidentTopologyResolutionPainter_Z_SHIFT, METH_VARARGS,
   "V.Z_SHIFT() -> vtkInformationDoubleKey\nC++: static vtkInformationDoubleKey *Z_SHIFT()\n\nUsed to set the z-shift if ResolveCoincidentTopology is set to\nShiftZBuffer.\n"},
  {"POLYGON_OFFSET_PARAMETERS", PyvtkCoincidentTopologyResolutionPainter_POLYGON_OFFSET_PARAMETERS, METH_VARARGS,
   "V.POLYGON_OFFSET_PARAMETERS() -> vtkInformationDoubleVectorKey\nC++: static vtkInformationDoubleVectorKey *POLYGON_OFFSET_PARAMETERS(\n    )\n\nUsed to set the polygon offset scale factor and units. Used when\nResolveCoincidentTopology is set to PolygonOffset.\n"},
  {"POLYGON_OFFSET_FACES", PyvtkCoincidentTopologyResolutionPainter_POLYGON_OFFSET_FACES, METH_VARARGS,
   "V.POLYGON_OFFSET_FACES() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *POLYGON_OFFSET_FACES()\n\nWhen set and when RESOLVE_COINCIDENT_TOPOLOGY is set to use\npolygon offset, solid polygonal faces will be offsetted,\notherwise lines/vertices will be offsetted.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkCoincidentTopologyResolutionPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkCoincidentTopologyResolutionPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkCoincidentTopologyResolutionPainter_StaticNew()
{
  return vtkCoincidentTopologyResolutionPainter::New();
}

PyObject *PyvtkCoincidentTopologyResolutionPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkCoincidentTopologyResolutionPainter_Type, PyvtkCoincidentTopologyResolutionPainter_Methods,
    "vtkCoincidentTopologyResolutionPainter",
    PyvtkCoincidentTopologyResolutionPainter_Doc(), &PyvtkCoincidentTopologyResolutionPainter_StaticNew);

  PyTypeObject *pytype = &PyvtkCoincidentTopologyResolutionPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkCoincidentTopologyResolutionPainter_Doc()
{
  static const char *docstring[] = {
    "vtkCoincidentTopologyResolutionPainter - painter that resolves\nconicident topology.\n\n",
    "Superclass: vtkPolyDataPainter\n\n",
    "Provides the ability to shift the z-buffer to resolve coincident\ntopology. For example, if you'd like to draw a mesh with some edges a\ndifferent color, and the edges lie on the mesh, this feature can be\nuseful to get nice looking lines.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkCoincidentTopologyResolutionPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkCoincidentTopologyResolutionPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkCoincidentTopologyResolutionPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

