// python wrapper for vtkDefaultPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDefaultPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDefaultPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkDefaultPainter_ClassNew(); }

#ifndef DECLARED_PyvtkPainter_ClassNew
extern "C" { PyObject *PyvtkPainter_ClassNew(); }
#define DECLARED_PyvtkPainter_ClassNew
#endif

static const char **PyvtkDefaultPainter_Doc();


static PyObject *
PyvtkDefaultPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDefaultPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDefaultPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDefaultPainter *tempr = vtkDefaultPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDefaultPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDefaultPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_SetScalarsToColorsPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalarsToColorsPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  vtkScalarsToColorsPainter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkScalarsToColorsPainter"))
  {
    if (ap.IsBound())
    {
      op->SetScalarsToColorsPainter(temp0);
    }
    else
    {
      op->vtkDefaultPainter::SetScalarsToColorsPainter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_GetScalarsToColorsPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScalarsToColorsPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkScalarsToColorsPainter *tempr = (ap.IsBound() ?
      op->GetScalarsToColorsPainter() :
      op->vtkDefaultPainter::GetScalarsToColorsPainter());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_SetClipPlanesPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetClipPlanesPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  vtkClipPlanesPainter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkClipPlanesPainter"))
  {
    if (ap.IsBound())
    {
      op->SetClipPlanesPainter(temp0);
    }
    else
    {
      op->vtkDefaultPainter::SetClipPlanesPainter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_GetClipPlanesPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClipPlanesPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkClipPlanesPainter *tempr = (ap.IsBound() ?
      op->GetClipPlanesPainter() :
      op->vtkDefaultPainter::GetClipPlanesPainter());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_SetDisplayListPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDisplayListPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  vtkDisplayListPainter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDisplayListPainter"))
  {
    if (ap.IsBound())
    {
      op->SetDisplayListPainter(temp0);
    }
    else
    {
      op->vtkDefaultPainter::SetDisplayListPainter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_GetDisplayListPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDisplayListPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDisplayListPainter *tempr = (ap.IsBound() ?
      op->GetDisplayListPainter() :
      op->vtkDefaultPainter::GetDisplayListPainter());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_SetCompositePainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompositePainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  vtkCompositePainter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCompositePainter"))
  {
    if (ap.IsBound())
    {
      op->SetCompositePainter(temp0);
    }
    else
    {
      op->vtkDefaultPainter::SetCompositePainter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_GetCompositePainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompositePainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkCompositePainter *tempr = (ap.IsBound() ?
      op->GetCompositePainter() :
      op->vtkDefaultPainter::GetCompositePainter());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_SetCoincidentTopologyResolutionPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCoincidentTopologyResolutionPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  vtkCoincidentTopologyResolutionPainter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCoincidentTopologyResolutionPainter"))
  {
    if (ap.IsBound())
    {
      op->SetCoincidentTopologyResolutionPainter(temp0);
    }
    else
    {
      op->vtkDefaultPainter::SetCoincidentTopologyResolutionPainter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_GetCoincidentTopologyResolutionPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCoincidentTopologyResolutionPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkCoincidentTopologyResolutionPainter *tempr = (ap.IsBound() ?
      op->GetCoincidentTopologyResolutionPainter() :
      op->vtkDefaultPainter::GetCoincidentTopologyResolutionPainter());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_SetLightingPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLightingPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  vtkLightingPainter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkLightingPainter"))
  {
    if (ap.IsBound())
    {
      op->SetLightingPainter(temp0);
    }
    else
    {
      op->vtkDefaultPainter::SetLightingPainter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_GetLightingPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLightingPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkLightingPainter *tempr = (ap.IsBound() ?
      op->GetLightingPainter() :
      op->vtkDefaultPainter::GetLightingPainter());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_SetRepresentationPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRepresentationPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  vtkRepresentationPainter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRepresentationPainter"))
  {
    if (ap.IsBound())
    {
      op->SetRepresentationPainter(temp0);
    }
    else
    {
      op->vtkDefaultPainter::SetRepresentationPainter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_GetRepresentationPainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRepresentationPainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRepresentationPainter *tempr = (ap.IsBound() ?
      op->GetRepresentationPainter() :
      op->vtkDefaultPainter::GetRepresentationPainter());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_SetDelegatePainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDelegatePainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  vtkPainter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPainter"))
  {
    if (ap.IsBound())
    {
      op->SetDelegatePainter(temp0);
    }
    else
    {
      op->vtkDefaultPainter::SetDelegatePainter(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_GetDelegatePainter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDelegatePainter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPainter *tempr = (ap.IsBound() ?
      op->GetDelegatePainter() :
      op->vtkDefaultPainter::GetDelegatePainter());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_Render(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Render");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  vtkRenderer *temp0 = NULL;
  vtkActor *temp1 = NULL;
  unsigned long temp2;
  bool temp3 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetVTKObject(temp0, "vtkRenderer") &&
      ap.GetVTKObject(temp1, "vtkActor") &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    if (ap.IsBound())
    {
      op->Render(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkDefaultPainter::Render(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkDefaultPainter::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDefaultPainter_UpdateBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDefaultPainter *op = static_cast<vtkDefaultPainter *>(vp);

  const int size0 = 6;
  double temp0[6];
  double save0[6];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->UpdateBounds(temp0);
    }
    else
    {
      op->vtkDefaultPainter::UpdateBounds(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkDefaultPainter_Methods[] = {
  {"IsTypeOf", PyvtkDefaultPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkDefaultPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkDefaultPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkDefaultPainter\nC++: static vtkDefaultPainter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDefaultPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkDefaultPainter\nC++: vtkDefaultPainter *NewInstance()\n\n"},
  {"SetScalarsToColorsPainter", PyvtkDefaultPainter_SetScalarsToColorsPainter, METH_VARARGS,
   "V.SetScalarsToColorsPainter(vtkScalarsToColorsPainter)\nC++: void SetScalarsToColorsPainter(vtkScalarsToColorsPainter *)\n\nGet/Set the painter that maps scalars to colors.\n"},
  {"GetScalarsToColorsPainter", PyvtkDefaultPainter_GetScalarsToColorsPainter, METH_VARARGS,
   "V.GetScalarsToColorsPainter() -> vtkScalarsToColorsPainter\nC++: virtual vtkScalarsToColorsPainter *GetScalarsToColorsPainter(\n    )\n\nGet/Set the painter that maps scalars to colors.\n"},
  {"SetClipPlanesPainter", PyvtkDefaultPainter_SetClipPlanesPainter, METH_VARARGS,
   "V.SetClipPlanesPainter(vtkClipPlanesPainter)\nC++: void SetClipPlanesPainter(vtkClipPlanesPainter *)\n\nGet/Set the painter that handles clipping.\n"},
  {"GetClipPlanesPainter", PyvtkDefaultPainter_GetClipPlanesPainter, METH_VARARGS,
   "V.GetClipPlanesPainter() -> vtkClipPlanesPainter\nC++: virtual vtkClipPlanesPainter *GetClipPlanesPainter()\n\nGet/Set the painter that handles clipping.\n"},
  {"SetDisplayListPainter", PyvtkDefaultPainter_SetDisplayListPainter, METH_VARARGS,
   "V.SetDisplayListPainter(vtkDisplayListPainter)\nC++: void SetDisplayListPainter(vtkDisplayListPainter *)\n\nGet/Set the painter that builds display lists.\n"},
  {"GetDisplayListPainter", PyvtkDefaultPainter_GetDisplayListPainter, METH_VARARGS,
   "V.GetDisplayListPainter() -> vtkDisplayListPainter\nC++: virtual vtkDisplayListPainter *GetDisplayListPainter()\n\nGet/Set the painter that builds display lists.\n"},
  {"SetCompositePainter", PyvtkDefaultPainter_SetCompositePainter, METH_VARARGS,
   "V.SetCompositePainter(vtkCompositePainter)\nC++: void SetCompositePainter(vtkCompositePainter *)\n\nGet/Set the painter used to handle composite datasets.\n"},
  {"GetCompositePainter", PyvtkDefaultPainter_GetCompositePainter, METH_VARARGS,
   "V.GetCompositePainter() -> vtkCompositePainter\nC++: virtual vtkCompositePainter *GetCompositePainter()\n\nGet/Set the painter used to handle composite datasets.\n"},
  {"SetCoincidentTopologyResolutionPainter", PyvtkDefaultPainter_SetCoincidentTopologyResolutionPainter, METH_VARARGS,
   "V.SetCoincidentTopologyResolutionPainter(\n    vtkCoincidentTopologyResolutionPainter)\nC++: void SetCoincidentTopologyResolutionPainter(\n    vtkCoincidentTopologyResolutionPainter *)\n\nPainter used to resolve coincident topology.\n"},
  {"GetCoincidentTopologyResolutionPainter", PyvtkDefaultPainter_GetCoincidentTopologyResolutionPainter, METH_VARARGS,
   "V.GetCoincidentTopologyResolutionPainter()\n    -> vtkCoincidentTopologyResolutionPainter\nC++: virtual vtkCoincidentTopologyResolutionPainter *GetCoincidentTopologyResolutionPainter(\n    )\n\nPainter used to resolve coincident topology.\n"},
  {"SetLightingPainter", PyvtkDefaultPainter_SetLightingPainter, METH_VARARGS,
   "V.SetLightingPainter(vtkLightingPainter)\nC++: void SetLightingPainter(vtkLightingPainter *)\n\nGet/Set the painter that controls lighting.\n"},
  {"GetLightingPainter", PyvtkDefaultPainter_GetLightingPainter, METH_VARARGS,
   "V.GetLightingPainter() -> vtkLightingPainter\nC++: virtual vtkLightingPainter *GetLightingPainter()\n\nGet/Set the painter that controls lighting.\n"},
  {"SetRepresentationPainter", PyvtkDefaultPainter_SetRepresentationPainter, METH_VARARGS,
   "V.SetRepresentationPainter(vtkRepresentationPainter)\nC++: void SetRepresentationPainter(vtkRepresentationPainter *)\n\nPainter used to convert polydata to Wireframe/Points\nrepresentation.\n"},
  {"GetRepresentationPainter", PyvtkDefaultPainter_GetRepresentationPainter, METH_VARARGS,
   "V.GetRepresentationPainter() -> vtkRepresentationPainter\nC++: virtual vtkRepresentationPainter *GetRepresentationPainter()\n\nPainter used to convert polydata to Wireframe/Points\nrepresentation.\n"},
  {"SetDelegatePainter", PyvtkDefaultPainter_SetDelegatePainter, METH_VARARGS,
   "V.SetDelegatePainter(vtkPainter)\nC++: void SetDelegatePainter(vtkPainter *)\n\nSet/Get the painter to which this painter should propagare its\ndraw calls. These methods are overridden so that the delegate is\nset to the end of the Painter Chain.\n"},
  {"GetDelegatePainter", PyvtkDefaultPainter_GetDelegatePainter, METH_VARARGS,
   "V.GetDelegatePainter() -> vtkPainter\nC++: vtkPainter *GetDelegatePainter()\n\n"},
  {"Render", PyvtkDefaultPainter_Render, METH_VARARGS,
   "V.Render(vtkRenderer, vtkActor, int, bool)\nC++: void Render(vtkRenderer *renderer, vtkActor *actor,\n    unsigned long typeflags, bool forceCompileOnly)\n\nOverridden to setup the chain of painter depending on the actor\nrepresentation. The chain is rebuilt if this->MTime has changed\nsince last BuildPainterChain(); Building of the chain does not\ndepend on input polydata, hence it does not check if the input\nhas changed at all.\n"},
  {"ReleaseGraphicsResources", PyvtkDefaultPainter_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: void ReleaseGraphicsResources(vtkWindow *)\n\nRelease any graphics resources that are being consumed by this\npainter. The parameter window could be used to determine which\ngraphic resources to release. The call is propagated to the\ndelegate painter, if any.\n"},
  {"UpdateBounds", PyvtkDefaultPainter_UpdateBounds, METH_VARARGS,
   "V.UpdateBounds([float, float, float, float, float, float])\nC++: void UpdateBounds(double bounds[6])\n\nExpand or shrink the estimated bounds based on the geometric\ntransformations applied in the painter. The bounds are left\nunchanged if the painter does not change the geometry.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkDefaultPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkDefaultPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDefaultPainter_StaticNew()
{
  return vtkDefaultPainter::New();
}

PyObject *PyvtkDefaultPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkDefaultPainter_Type, PyvtkDefaultPainter_Methods,
    "vtkDefaultPainter",
    PyvtkDefaultPainter_Doc(), &PyvtkDefaultPainter_StaticNew);

  PyTypeObject *pytype = &PyvtkDefaultPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkDefaultPainter_Doc()
{
  static const char *docstring[] = {
    "vtkDefaultPainter - sets up a default chain of painters.\n\n",
    "Superclass: vtkPainter\n\n",
    "This painter does not do any actual rendering. Sets up a default\npipeline of painters to mimick the behaiour of old vtkPolyDataMapper.\nThe chain is as follows: input--> vtkScalarsToColorsPainter -->\nvtkClipPlanesPainter --> vtkDisplayListPainter -->\nvtkCompositePainter --> vtkCoincidentTopologyResolutionPainter -->\nvtkLightingPainter --> vtkRepresentationPainter --><Delegate of\nvtkDefaultPainter>.",
    " Typically, the delegate of the default painter be\none that is capable of r rendering graphics primitives or a\nvtkChooserPainter which can select appropriate painters to do the\nrendering.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkDefaultPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDefaultPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDefaultPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

