// python wrapper for vtkDisplayListPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDisplayListPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDisplayListPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkDisplayListPainter_ClassNew(); }

#ifndef DECLARED_PyvtkPainter_ClassNew
extern "C" { PyObject *PyvtkPainter_ClassNew(); }
#define DECLARED_PyvtkPainter_ClassNew
#endif

static const char **PyvtkDisplayListPainter_Doc();


static PyObject *
PyvtkDisplayListPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDisplayListPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDisplayListPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDisplayListPainter *op = static_cast<vtkDisplayListPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDisplayListPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDisplayListPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDisplayListPainter *tempr = vtkDisplayListPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDisplayListPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDisplayListPainter *op = static_cast<vtkDisplayListPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDisplayListPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDisplayListPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkDisplayListPainter_IMMEDIATE_MODE_RENDERING(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IMMEDIATE_MODE_RENDERING");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkDisplayListPainter::IMMEDIATE_MODE_RENDERING();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDisplayListPainter_GetTimeToDraw(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeToDraw");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDisplayListPainter *op = static_cast<vtkDisplayListPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTimeToDraw() :
      op->vtkDisplayListPainter::GetTimeToDraw());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDisplayListPainter_Methods[] = {
  {"IsTypeOf", PyvtkDisplayListPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkDisplayListPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkDisplayListPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkDisplayListPainter\nC++: static vtkDisplayListPainter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDisplayListPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkDisplayListPainter\nC++: vtkDisplayListPainter *NewInstance()\n\n"},
  {"IMMEDIATE_MODE_RENDERING", PyvtkDisplayListPainter_IMMEDIATE_MODE_RENDERING, METH_VARARGS,
   "V.IMMEDIATE_MODE_RENDERING() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *IMMEDIATE_MODE_RENDERING()\n\nTurn on/off flag to control whether data is rendered using\nimmediate mode or note. Immediate mode rendering tends to be\nslower but it can handle larger datasets. The default value is\nimmediate mode off. If you are having problems rendering a large\ndataset you might want to consider using immediate more\nrendering.\n"},
  {"GetTimeToDraw", PyvtkDisplayListPainter_GetTimeToDraw, METH_VARARGS,
   "V.GetTimeToDraw() -> float\nC++: double GetTimeToDraw()\n\nGet the time required to draw the geometry last time it was\nrendered. Overridden to avoid adding of delegate rendering time\nwhen Display Lists are used.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkDisplayListPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkDisplayListPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDisplayListPainter_StaticNew()
{
  return vtkDisplayListPainter::New();
}

PyObject *PyvtkDisplayListPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkDisplayListPainter_Type, PyvtkDisplayListPainter_Methods,
    "vtkDisplayListPainter",
    PyvtkDisplayListPainter_Doc(), &PyvtkDisplayListPainter_StaticNew);

  PyTypeObject *pytype = &PyvtkDisplayListPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkDisplayListPainter_Doc()
{
  static const char *docstring[] = {
    "vtkDisplayListPainter - abstract superclass for painter that\nbuilds/uses display lists.\n\n",
    "Superclass: vtkPainter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkDisplayListPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDisplayListPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDisplayListPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

