// python wrapper for vtkHAVSVolumeMapper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkHAVSVolumeMapper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkHAVSVolumeMapper(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkHAVSVolumeMapper_ClassNew(); }

#ifndef DECLARED_PyvtkUnstructuredGridVolumeMapper_ClassNew
extern "C" { PyObject *PyvtkUnstructuredGridVolumeMapper_ClassNew(); }
#define DECLARED_PyvtkUnstructuredGridVolumeMapper_ClassNew
#endif

static const char **PyvtkHAVSVolumeMapper_Doc();


static PyObject *
PyvtkHAVSVolumeMapper_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkHAVSVolumeMapper::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkHAVSVolumeMapper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkHAVSVolumeMapper *tempr = vtkHAVSVolumeMapper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkHAVSVolumeMapper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkHAVSVolumeMapper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_SetPartiallyRemoveNonConvexities(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPartiallyRemoveNonConvexities");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPartiallyRemoveNonConvexities(temp0);
    }
    else
    {
      op->vtkHAVSVolumeMapper::SetPartiallyRemoveNonConvexities(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_GetPartiallyRemoveNonConvexities(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPartiallyRemoveNonConvexities");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetPartiallyRemoveNonConvexities() :
      op->vtkHAVSVolumeMapper::GetPartiallyRemoveNonConvexities());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_SetLevelOfDetailTargetTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLevelOfDetailTargetTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLevelOfDetailTargetTime(temp0);
    }
    else
    {
      op->vtkHAVSVolumeMapper::SetLevelOfDetailTargetTime(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_GetLevelOfDetailTargetTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLevelOfDetailTargetTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetLevelOfDetailTargetTime() :
      op->vtkHAVSVolumeMapper::GetLevelOfDetailTargetTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_SetLevelOfDetail(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLevelOfDetail");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLevelOfDetail(temp0);
    }
    else
    {
      op->vtkHAVSVolumeMapper::SetLevelOfDetail(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_GetLevelOfDetail(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLevelOfDetail");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetLevelOfDetail() :
      op->vtkHAVSVolumeMapper::GetLevelOfDetail());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_SetLevelOfDetailMethod(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLevelOfDetailMethod");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLevelOfDetailMethod(temp0);
    }
    else
    {
      op->vtkHAVSVolumeMapper::SetLevelOfDetailMethod(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_GetLevelOfDetailMethod(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLevelOfDetailMethod");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLevelOfDetailMethod() :
      op->vtkHAVSVolumeMapper::GetLevelOfDetailMethod());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_SetLevelOfDetailMethodField(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLevelOfDetailMethodField");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLevelOfDetailMethodField();
    }
    else
    {
      op->vtkHAVSVolumeMapper::SetLevelOfDetailMethodField();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_SetLevelOfDetailMethodArea(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLevelOfDetailMethodArea");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLevelOfDetailMethodArea();
    }
    else
    {
      op->vtkHAVSVolumeMapper::SetLevelOfDetailMethodArea();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_SetKBufferSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetKBufferSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetKBufferSize(temp0);
    }
    else
    {
      op->vtkHAVSVolumeMapper::SetKBufferSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_GetKBufferSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetKBufferSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetKBufferSize() :
      op->vtkHAVSVolumeMapper::GetKBufferSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_SetKBufferSizeTo2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetKBufferSizeTo2");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetKBufferSizeTo2();
    }
    else
    {
      op->vtkHAVSVolumeMapper::SetKBufferSizeTo2();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_SetKBufferSizeTo6(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetKBufferSizeTo6");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetKBufferSizeTo6();
    }
    else
    {
      op->vtkHAVSVolumeMapper::SetKBufferSizeTo6();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_SupportedByHardware(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SupportedByHardware");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  vtkRenderer *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderer"))
  {
    bool tempr = (ap.IsBound() ?
      op->SupportedByHardware(temp0) :
      op->vtkHAVSVolumeMapper::SupportedByHardware(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_SetGPUDataStructures(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGPUDataStructures");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    op->SetGPUDataStructures(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHAVSVolumeMapper_GetGPUDataStructures(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGPUDataStructures");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHAVSVolumeMapper *op = static_cast<vtkHAVSVolumeMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetGPUDataStructures() :
      op->vtkHAVSVolumeMapper::GetGPUDataStructures());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkHAVSVolumeMapper_Methods[] = {
  {"IsTypeOf", PyvtkHAVSVolumeMapper_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkHAVSVolumeMapper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkHAVSVolumeMapper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkHAVSVolumeMapper\nC++: static vtkHAVSVolumeMapper *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkHAVSVolumeMapper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkHAVSVolumeMapper\nC++: vtkHAVSVolumeMapper *NewInstance()\n\n"},
  {"SetPartiallyRemoveNonConvexities", PyvtkHAVSVolumeMapper_SetPartiallyRemoveNonConvexities, METH_VARARGS,
   "V.SetPartiallyRemoveNonConvexities(bool)\nC++: virtual void SetPartiallyRemoveNonConvexities(bool _arg)\n\nregions by removing ray segments larger than the max cell size.\n"},
  {"GetPartiallyRemoveNonConvexities", PyvtkHAVSVolumeMapper_GetPartiallyRemoveNonConvexities, METH_VARARGS,
   "V.GetPartiallyRemoveNonConvexities() -> bool\nC++: virtual bool GetPartiallyRemoveNonConvexities()\n\nregions by removing ray segments larger than the max cell size.\n"},
  {"SetLevelOfDetailTargetTime", PyvtkHAVSVolumeMapper_SetLevelOfDetailTargetTime, METH_VARARGS,
   "V.SetLevelOfDetailTargetTime(float)\nC++: virtual void SetLevelOfDetailTargetTime(float _arg)\n\nSet/get the desired level of detail target time measured in\nframes/sec.\n"},
  {"GetLevelOfDetailTargetTime", PyvtkHAVSVolumeMapper_GetLevelOfDetailTargetTime, METH_VARARGS,
   "V.GetLevelOfDetailTargetTime() -> float\nC++: virtual float GetLevelOfDetailTargetTime()\n\nSet/get the desired level of detail target time measured in\nframes/sec.\n"},
  {"SetLevelOfDetail", PyvtkHAVSVolumeMapper_SetLevelOfDetail, METH_VARARGS,
   "V.SetLevelOfDetail(bool)\nC++: virtual void SetLevelOfDetail(bool _arg)\n\nTurn on/off level-of-detail volume rendering\n"},
  {"GetLevelOfDetail", PyvtkHAVSVolumeMapper_GetLevelOfDetail, METH_VARARGS,
   "V.GetLevelOfDetail() -> bool\nC++: virtual bool GetLevelOfDetail()\n\nTurn on/off level-of-detail volume rendering\n"},
  {"SetLevelOfDetailMethod", PyvtkHAVSVolumeMapper_SetLevelOfDetailMethod, METH_VARARGS,
   "V.SetLevelOfDetailMethod(int)\nC++: void SetLevelOfDetailMethod(int)\n\nSet/get the current level-of-detail method\n"},
  {"GetLevelOfDetailMethod", PyvtkHAVSVolumeMapper_GetLevelOfDetailMethod, METH_VARARGS,
   "V.GetLevelOfDetailMethod() -> int\nC++: virtual int GetLevelOfDetailMethod()\n\nSet/get the current level-of-detail method\n"},
  {"SetLevelOfDetailMethodField", PyvtkHAVSVolumeMapper_SetLevelOfDetailMethodField, METH_VARARGS,
   "V.SetLevelOfDetailMethodField()\nC++: void SetLevelOfDetailMethodField()\n\nSet/get the current level-of-detail method\n"},
  {"SetLevelOfDetailMethodArea", PyvtkHAVSVolumeMapper_SetLevelOfDetailMethodArea, METH_VARARGS,
   "V.SetLevelOfDetailMethodArea()\nC++: void SetLevelOfDetailMethodArea()\n\nSet/get the current level-of-detail method\n"},
  {"SetKBufferSize", PyvtkHAVSVolumeMapper_SetKBufferSize, METH_VARARGS,
   "V.SetKBufferSize(int)\nC++: virtual void SetKBufferSize(int _arg)\n\nSet the kbuffer size\n"},
  {"GetKBufferSize", PyvtkHAVSVolumeMapper_GetKBufferSize, METH_VARARGS,
   "V.GetKBufferSize() -> int\nC++: virtual int GetKBufferSize()\n\nSet the kbuffer size\n"},
  {"SetKBufferSizeTo2", PyvtkHAVSVolumeMapper_SetKBufferSizeTo2, METH_VARARGS,
   "V.SetKBufferSizeTo2()\nC++: void SetKBufferSizeTo2()\n\nSet the kbuffer size\n"},
  {"SetKBufferSizeTo6", PyvtkHAVSVolumeMapper_SetKBufferSizeTo6, METH_VARARGS,
   "V.SetKBufferSizeTo6()\nC++: void SetKBufferSizeTo6()\n\nSet the kbuffer size\n"},
  {"SupportedByHardware", PyvtkHAVSVolumeMapper_SupportedByHardware, METH_VARARGS,
   "V.SupportedByHardware(vtkRenderer) -> bool\nC++: virtual bool SupportedByHardware(vtkRenderer *r)\n\nCheck hardware support for the HAVS algorithm.  Necessary\nfeatures include off-screen rendering, 32-bit fp textures,\nmultiple render targets, and framebuffer objects. Subclasses must\noverride this method to indicate if supported by Hardware.\n"},
  {"SetGPUDataStructures", PyvtkHAVSVolumeMapper_SetGPUDataStructures, METH_VARARGS,
   "V.SetGPUDataStructures(bool)\nC++: virtual void SetGPUDataStructures(bool)\n\nSet/get whether or not the data structures should be stored on\nthe GPU for better peformance.\n"},
  {"GetGPUDataStructures", PyvtkHAVSVolumeMapper_GetGPUDataStructures, METH_VARARGS,
   "V.GetGPUDataStructures() -> bool\nC++: virtual bool GetGPUDataStructures()\n\nSet/get whether or not the data structures should be stored on\nthe GPU for better peformance.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkHAVSVolumeMapper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingVolumePython.vtkHAVSVolumeMapper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkHAVSVolumeMapper_StaticNew()
{
  return vtkHAVSVolumeMapper::New();
}

PyObject *PyvtkHAVSVolumeMapper_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkHAVSVolumeMapper_Type, PyvtkHAVSVolumeMapper_Methods,
    "vtkHAVSVolumeMapper",
    PyvtkHAVSVolumeMapper_Doc(), &PyvtkHAVSVolumeMapper_StaticNew);

  PyTypeObject *pytype = &PyvtkHAVSVolumeMapper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkUnstructuredGridVolumeMapper_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkHAVSVolumeMapper_Doc()
{
  static const char *docstring[] = {
    "vtkHAVSVolumeMapper - Hardware-Assisted Visibility Sorting\nunstructured grid mapper\n\n",
    "Superclass: vtkUnstructuredGridVolumeMapper\n\n",
    "vtkHAVSVolumeMapper is a class that renders polygonal data\n(represented as an unstructured grid) using the Hardware-Assisted\nVisibility Sorting (HAVS) algorithm.  First the unique triangles are\nsorted in object space, then they are sorted in image space using a\nfixed size A-buffer implemented on the GPU called the k-buffer.  The\nHAVS algorithm excels at rendering large datasets quickly.  The\ntrade",
    "-off is that the algorithm may produce some rendering artifacts\ndue to an insufficient k size (currently 2 or 6 is supported) or\nread/write race conditions.\n\nA built in level-of-detail (LOD) approach samples the geometry using\none of two heuristics (field or area).  If LOD is enabled, the amount\nof geometry that is sampled and rendered changes dynamically to stay\nwithin the target frame rate.  The",
    " field sampling method generally\nworks best for datasets with cell sizes that don't vary much in size.\n On the contrary, the area sampling approach gives better\napproximations when the volume has a lot of variation in cell size.\n\nThe HAVS algorithm uses several advanced features on graphics\nhardware. The k-buffer sorting network is implemented using\nframebuffer objects (FBOs) with multiple render ",
    "targets (MRTs). \nTherefore, only cards that support these features can run the\nalgorithm (at least an ATI 9500 or an NVidia NV40 (6600)).\n\n@attention Several issues had to be addressed to get the HAVS\nalgorithm working within the vtk framework.  These additions forced\nthe code to forsake speed for the sake of compliance and robustness.\n\n@attention The HAVS algorithm operates on the triangles that ",
    "compose\nthe mesh. Therefore, before rendering, the cells are decomposed into\nunique triangles and stored on the GPU for efficient rendering.  The\nuse of GPU data structures is only recommended if the entire geometry\ncan fit in graphics memory.  Otherwise this feature should be\ndisabled.\n\n@attention Another new feature is the handling of mixed data types\n(eg., polygonal data with volume data).  Thi",
    "s is handled by reading\nthe z-buffer from the current window and copying it into the\nframebuffer object for off-screen rendering.  The depth test is then\nenabled so that the volume only appears over the opaque geometry. \nFinally, the results of the off-screen rendering are blended into the\nframebuffer as a transparent, view-aligned texture.\n\n@attention Instead of using a preintegrated 3D lookup ta",
    "ble for\nstoring the ray integral, this implementation uses partial\npre-integration.  This improves the performance of dynamic transfer\nfunction updates by avoiding a costly preprocess of the table.\n\n@attention A final change to the original algorithm is the handling\nof non-convexities in the mesh.  Due to read/write hazards that may\ncreate undesired artifacts with non-convexities when using a\ninsi",
    "de/outside toggle in the fragment program, another approach was\nemployed.  To handle non-convexities, the fragment shader determines\nif a ray-gap is larger than the max cell size and kill the fragment\nif so.  This approximation performs rather well in practice but may\nmiss small non-convexities.\n\n@attention For more information on the HAVS algorithm see:\n\n@attention\n \"Hardware-Assisted Visibility ",
    "Sorting for Unstructured Volume\nRendering\" by S. P. Callahan, M. Ikits, J. L. D. Comba, and C. T.\nSilva, IEEE Transactions of Visualization and Computer Graphics;\nMay/June 2005.\n\n@attention For more information on the Level-of-Detail algorithm,\nsee:\n\n@attention \"Interactive Rendering of Large Unstructured Grids Using\nDynamic Level-of-Detail\" by S. P. Callahan, J. L. D. Comba, P.\nShirley, and C. T.",
    " Silva, Proceedings of IEEE Visualization '05, Oct.\n2005.\n\n@par Acknowledgments: This code was developed by Steven P. Callahan\nunder the supervision of Prof. Claudio T. Silva. The code also\ncontains contributions from Milan Ikits, Linh Ha, Huy T. Vo, Carlos\nE. Scheidegger, and Joao L. D. Comba.\n\n@par Acknowledgments: The work was supported by grants, contracts,\nand gifts from the National Science ",
    "Foundation, the Department of\nEnergy, the Army Research Office, and IBM.\n\n@par Acknowledgments: The port of HAVS to VTK and ParaView has been\nprimarily supported by Sandia National Labs.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkHAVSVolumeMapper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkHAVSVolumeMapper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkHAVSVolumeMapper", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 4; c++)
  {
    static const struct { const char *name; int value; }
      constants[4] = {
        { "VTK_KBUFFER_SIZE_2", 0 },
        { "VTK_KBUFFER_SIZE_6", 1 },
        { "VTK_FIELD_LEVEL_OF_DETAIL", 0 },
        { "VTK_AREA_LEVEL_OF_DETAIL", 1 },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(dict, constants[c].name, o);
      Py_DECREF(o);
    }
  }

}

