// python wrapper for vtkOpenGLLightMonitor
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkOpenGLLightMonitor.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLLightMonitor(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLLightMonitor_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkOpenGLLightMonitor_Doc();


static PyObject *
PyvtkOpenGLLightMonitor_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkOpenGLLightMonitor::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLLightMonitor::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkOpenGLLightMonitor *tempr = vtkOpenGLLightMonitor::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkOpenGLLightMonitor *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLLightMonitor::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_SetLightId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLightId");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLightId(temp0);
    }
    else
    {
      op->vtkOpenGLLightMonitor::SetLightId(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_GetLightId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLightId");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLightId() :
      op->vtkOpenGLLightMonitor::GetLightId());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_StateChanged(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StateChanged");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->StateChanged() :
      op->vtkOpenGLLightMonitor::StateChanged());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_Update(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Update();
    }
    else
    {
      op->vtkOpenGLLightMonitor::Update();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_SetEnabled(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEnabled");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEnabled(temp0);
    }
    else
    {
      op->vtkOpenGLLightMonitor::SetEnabled(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_SetAmbient(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAmbient");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<float> store0(2*size0);
  float *temp0 = store0.Data();
  float *save0 = (size0 == 0 ? NULL : temp0 + size0);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetAmbient(temp0);
    }
    else
    {
      op->vtkOpenGLLightMonitor::SetAmbient(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_SetDiffuse(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDiffuse");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<float> store0(2*size0);
  float *temp0 = store0.Data();
  float *save0 = (size0 == 0 ? NULL : temp0 + size0);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetDiffuse(temp0);
    }
    else
    {
      op->vtkOpenGLLightMonitor::SetDiffuse(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_SetSpecular(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSpecular");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<float> store0(2*size0);
  float *temp0 = store0.Data();
  float *save0 = (size0 == 0 ? NULL : temp0 + size0);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetSpecular(temp0);
    }
    else
    {
      op->vtkOpenGLLightMonitor::SetSpecular(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_SetPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<float> store0(2*size0);
  float *temp0 = store0.Data();
  float *save0 = (size0 == 0 ? NULL : temp0 + size0);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetPosition(temp0);
    }
    else
    {
      op->vtkOpenGLLightMonitor::SetPosition(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_SetSpotDirection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSpotDirection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<float> store0(2*size0);
  float *temp0 = store0.Data();
  float *save0 = (size0 == 0 ? NULL : temp0 + size0);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetSpotDirection(temp0);
    }
    else
    {
      op->vtkOpenGLLightMonitor::SetSpotDirection(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_SetSpotExponent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSpotExponent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSpotExponent(temp0);
    }
    else
    {
      op->vtkOpenGLLightMonitor::SetSpotExponent(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_SetSpotCutoff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSpotCutoff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSpotCutoff(temp0);
    }
    else
    {
      op->vtkOpenGLLightMonitor::SetSpotCutoff(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLLightMonitor_SetAttenuation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttenuation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLLightMonitor *op = static_cast<vtkOpenGLLightMonitor *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<float> store0(2*size0);
  float *temp0 = store0.Data();
  float *save0 = (size0 == 0 ? NULL : temp0 + size0);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetAttenuation(temp0);
    }
    else
    {
      op->vtkOpenGLLightMonitor::SetAttenuation(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkOpenGLLightMonitor_Methods[] = {
  {"IsTypeOf", PyvtkOpenGLLightMonitor_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkOpenGLLightMonitor_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkOpenGLLightMonitor_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkOpenGLLightMonitor\nC++: static vtkOpenGLLightMonitor *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkOpenGLLightMonitor_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLLightMonitor\nC++: vtkOpenGLLightMonitor *NewInstance()\n\n"},
  {"SetLightId", PyvtkOpenGLLightMonitor_SetLightId, METH_VARARGS,
   "V.SetLightId(int)\nC++: virtual void SetLightId(int _arg)\n\nSet/Get the light id of the OpenGL light to track. The light id\nmust be set prior to use. Default value 0.\n"},
  {"GetLightId", PyvtkOpenGLLightMonitor_GetLightId, METH_VARARGS,
   "V.GetLightId() -> int\nC++: virtual int GetLightId()\n\nSet/Get the light id of the OpenGL light to track. The light id\nmust be set prior to use. Default value 0.\n"},
  {"StateChanged", PyvtkOpenGLLightMonitor_StateChanged, METH_VARARGS,
   "V.StateChanged() -> bool\nC++: bool StateChanged()\n\nFetches the current GL state and updates the internal copies of\nthe data. returns true if any of the tracked OpenGL lights have\nchanged. Typically this is the only function a user needs to\ncall.\n"},
  {"Update", PyvtkOpenGLLightMonitor_Update, METH_VARARGS,
   "V.Update()\nC++: void Update()\n\nFetch and save OpenGL light state. Note, this is done\nautomatically in SateChanged.\n"},
  {"SetEnabled", PyvtkOpenGLLightMonitor_SetEnabled, METH_VARARGS,
   "V.SetEnabled(int)\nC++: void SetEnabled(int val)\n\nSetters for internal state.\n"},
  {"SetAmbient", PyvtkOpenGLLightMonitor_SetAmbient, METH_VARARGS,
   "V.SetAmbient([float, ...])\nC++: void SetAmbient(float *val)\n\nSetters for internal state.\n"},
  {"SetDiffuse", PyvtkOpenGLLightMonitor_SetDiffuse, METH_VARARGS,
   "V.SetDiffuse([float, ...])\nC++: void SetDiffuse(float *val)\n\nSetters for internal state.\n"},
  {"SetSpecular", PyvtkOpenGLLightMonitor_SetSpecular, METH_VARARGS,
   "V.SetSpecular([float, ...])\nC++: void SetSpecular(float *val)\n\nSetters for internal state.\n"},
  {"SetPosition", PyvtkOpenGLLightMonitor_SetPosition, METH_VARARGS,
   "V.SetPosition([float, ...])\nC++: void SetPosition(float *val)\n\nSetters for internal state.\n"},
  {"SetSpotDirection", PyvtkOpenGLLightMonitor_SetSpotDirection, METH_VARARGS,
   "V.SetSpotDirection([float, ...])\nC++: void SetSpotDirection(float *val)\n\nSetters for internal state.\n"},
  {"SetSpotExponent", PyvtkOpenGLLightMonitor_SetSpotExponent, METH_VARARGS,
   "V.SetSpotExponent(float)\nC++: void SetSpotExponent(float val)\n\nSetters for internal state.\n"},
  {"SetSpotCutoff", PyvtkOpenGLLightMonitor_SetSpotCutoff, METH_VARARGS,
   "V.SetSpotCutoff(float)\nC++: void SetSpotCutoff(float val)\n\nSetters for internal state.\n"},
  {"SetAttenuation", PyvtkOpenGLLightMonitor_SetAttenuation, METH_VARARGS,
   "V.SetAttenuation([float, ...])\nC++: void SetAttenuation(float *val)\n\nSetters for internal state.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOpenGLLightMonitor_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkOpenGLLightMonitor", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLLightMonitor_StaticNew()
{
  return vtkOpenGLLightMonitor::New();
}

PyObject *PyvtkOpenGLLightMonitor_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLLightMonitor_Type, PyvtkOpenGLLightMonitor_Methods,
    "vtkOpenGLLightMonitor",
    PyvtkOpenGLLightMonitor_Doc(), &PyvtkOpenGLLightMonitor_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLLightMonitor_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOpenGLLightMonitor_Doc()
{
  static const char *docstring[] = {
    "vtkOpenGLLightMonitor - tracks state of OpenGL model-view and\nprojection matrices.\n\n",
    "Superclass: vtkObject\n\n",
    "vtkOpenGLLightMonitor -- A helper for painters that tracks state of\nOpenGL lights. A Painter could use this to skip expensive processing\nthat is only needed when lights change.\n\nthis is not intended to be shared. each object should use it's own\ninstance of this class. it's intended to be called once per render.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOpenGLLightMonitor(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOpenGLLightMonitor_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLLightMonitor", o) != 0)
  {
    Py_DECREF(o);
  }

}

