// python wrapper for vtkOpenGLPainterDeviceAdapter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkOpenGLPainterDeviceAdapter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLPainterDeviceAdapter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLPainterDeviceAdapter_ClassNew(); }

#ifndef DECLARED_PyvtkPainterDeviceAdapter_ClassNew
extern "C" { PyObject *PyvtkPainterDeviceAdapter_ClassNew(); }
#define DECLARED_PyvtkPainterDeviceAdapter_ClassNew
#endif

static const char **PyvtkOpenGLPainterDeviceAdapter_Doc();


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkOpenGLPainterDeviceAdapter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLPainterDeviceAdapter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkOpenGLPainterDeviceAdapter *tempr = vtkOpenGLPainterDeviceAdapter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkOpenGLPainterDeviceAdapter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLPainterDeviceAdapter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_BeginPrimitive(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "BeginPrimitive");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->BeginPrimitive(temp0);
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::BeginPrimitive(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_EndPrimitive(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EndPrimitive");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EndPrimitive();
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::EndPrimitive();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_IsAttributesSupported(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsAttributesSupported");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsAttributesSupported(temp0) :
      op->vtkOpenGLPainterDeviceAdapter::IsAttributesSupported(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_SendAttribute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SendAttribute");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  int temp0;
  int temp1;
  int temp2;
  void  *temp3 = NULL;
  Py_buffer pbuf3 = VTK_PYBUFFER_INITIALIZER;
  vtkIdType temp4 = 0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4, 5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetBuffer(temp3, &pbuf3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    if (ap.IsBound())
    {
      op->SendAttribute(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::SendAttribute(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf3.obj != 0)
  {
    PyBuffer_Release(&pbuf3);
  }
#endif
  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_SendMultiTextureCoords(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SendMultiTextureCoords");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  int temp0;
  int temp1;
  void  *temp2 = NULL;
  Py_buffer pbuf2 = VTK_PYBUFFER_INITIALIZER;
  int temp3;
  vtkIdType temp4;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetBuffer(temp2, &pbuf2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4))
  {
    if (ap.IsBound())
    {
      op->SendMultiTextureCoords(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::SendMultiTextureCoords(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf2.obj != 0)
  {
    PyBuffer_Release(&pbuf2);
  }
#endif
  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_SetAttributePointer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAttributePointer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  int temp0;
  int temp1;
  int temp2;
  int temp3;
  void  *temp4 = NULL;
  Py_buffer pbuf4 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetBuffer(temp4, &pbuf4))
  {
    if (ap.IsBound())
    {
      op->SetAttributePointer(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::SetAttributePointer(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf4.obj != 0)
  {
    PyBuffer_Release(&pbuf4);
  }
#endif
  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_EnableAttributeArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EnableAttributeArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->EnableAttributeArray(temp0);
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::EnableAttributeArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_DisableAttributeArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DisableAttributeArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->DisableAttributeArray(temp0);
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::DisableAttributeArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_DrawArrays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DrawArrays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  int temp0;
  vtkIdType temp1;
  vtkIdType temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->DrawArrays(temp0, temp1, temp2);
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::DrawArrays(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_DrawElements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DrawElements");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  int temp0;
  vtkIdType temp1;
  int temp2;
  void  *temp3 = NULL;
  Py_buffer pbuf3 = VTK_PYBUFFER_INITIALIZER;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetBuffer(temp3, &pbuf3))
  {
    if (ap.IsBound())
    {
      op->DrawElements(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::DrawElements(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf3.obj != 0)
  {
    PyBuffer_Release(&pbuf3);
  }
#endif
  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_Compatible(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Compatible");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  vtkRenderer *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderer"))
  {
    int tempr = (ap.IsBound() ?
      op->Compatible(temp0) :
      op->vtkOpenGLPainterDeviceAdapter::Compatible(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_MakeVertexEmphasis(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MakeVertexEmphasis");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->MakeVertexEmphasis(temp0);
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::MakeVertexEmphasis(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_Stencil(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Stencil");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->Stencil(temp0);
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::Stencil(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_WriteStencil(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "WriteStencil");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->WriteStencil(temp0);
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::WriteStencil(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLPainterDeviceAdapter_TestStencil(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "TestStencil");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLPainterDeviceAdapter *op = static_cast<vtkOpenGLPainterDeviceAdapter *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->TestStencil(temp0);
    }
    else
    {
      op->vtkOpenGLPainterDeviceAdapter::TestStencil(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkOpenGLPainterDeviceAdapter_Methods[] = {
  {"IsTypeOf", PyvtkOpenGLPainterDeviceAdapter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkOpenGLPainterDeviceAdapter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkOpenGLPainterDeviceAdapter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkOpenGLPainterDeviceAdapter\nC++: static vtkOpenGLPainterDeviceAdapter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkOpenGLPainterDeviceAdapter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLPainterDeviceAdapter\nC++: vtkOpenGLPainterDeviceAdapter *NewInstance()\n\n"},
  {"BeginPrimitive", PyvtkOpenGLPainterDeviceAdapter_BeginPrimitive, METH_VARARGS,
   "V.BeginPrimitive(int)\nC++: void BeginPrimitive(int mode)\n\nConverts mode from VTK_* to GL_* and calls glBegin.\n"},
  {"EndPrimitive", PyvtkOpenGLPainterDeviceAdapter_EndPrimitive, METH_VARARGS,
   "V.EndPrimitive()\nC++: void EndPrimitive()\n\nCalls glEnd.\n"},
  {"IsAttributesSupported", PyvtkOpenGLPainterDeviceAdapter_IsAttributesSupported, METH_VARARGS,
   "V.IsAttributesSupported(int) -> int\nC++: int IsAttributesSupported(int attribute)\n\nReturns if the given attribute type is supported by the device.\nReturns 1 is supported, 0 otherwise.\n"},
  {"SendAttribute", PyvtkOpenGLPainterDeviceAdapter_SendAttribute, METH_VARARGS,
   "V.SendAttribute(int, int, int, void, int)\nC++: void SendAttribute(int index, int components, int type,\n    const void *attribute, vtkIdType offset=0)\n\nCalls one of glVertex*, glNormal*, glColor*, or glTexCoord*.\n"},
  {"SendMultiTextureCoords", PyvtkOpenGLPainterDeviceAdapter_SendMultiTextureCoords, METH_VARARGS,
   "V.SendMultiTextureCoords(int, int, void, int, int)\nC++: void SendMultiTextureCoords(int numcomp, int type,\n    const void *attribute, int idx, vtkIdType offset)\n\nCalls glMultiTex\n"},
  {"SetAttributePointer", PyvtkOpenGLPainterDeviceAdapter_SetAttributePointer, METH_VARARGS,
   "V.SetAttributePointer(int, int, int, int, void)\nC++: void SetAttributePointer(int index, int numcomponents,\n    int type, int stride, const void *pointer)\n\nCalls one of glVertexPointer, glNormalPointer, glColorPointer, or\nglTexCoordPointer.\n"},
  {"EnableAttributeArray", PyvtkOpenGLPainterDeviceAdapter_EnableAttributeArray, METH_VARARGS,
   "V.EnableAttributeArray(int)\nC++: void EnableAttributeArray(int index)\n\nCalls glEnableClientState or glDisableClientState.\n"},
  {"DisableAttributeArray", PyvtkOpenGLPainterDeviceAdapter_DisableAttributeArray, METH_VARARGS,
   "V.DisableAttributeArray(int)\nC++: void DisableAttributeArray(int index)\n\nCalls glEnableClientState or glDisableClientState.\n"},
  {"DrawArrays", PyvtkOpenGLPainterDeviceAdapter_DrawArrays, METH_VARARGS,
   "V.DrawArrays(int, int, int)\nC++: void DrawArrays(int mode, vtkIdType first, vtkIdType count)\n\nCalls glDrawArrays.  Mode is converted from VTK_* to GL_*.\n"},
  {"DrawElements", PyvtkOpenGLPainterDeviceAdapter_DrawElements, METH_VARARGS,
   "V.DrawElements(int, int, int, void)\nC++: void DrawElements(int mode, vtkIdType count, int type,\n    void *indices)\n\nCalls glDrawElements.  Mode and type are converted from VTK_* to\nGL_*.\n"},
  {"Compatible", PyvtkOpenGLPainterDeviceAdapter_Compatible, METH_VARARGS,
   "V.Compatible(vtkRenderer) -> int\nC++: int Compatible(vtkRenderer *renderer)\n\nReturns true if renderer is a vtkOpenGLRenderer.\n"},
  {"MakeVertexEmphasis", PyvtkOpenGLPainterDeviceAdapter_MakeVertexEmphasis, METH_VARARGS,
   "V.MakeVertexEmphasis(bool)\nC++: void MakeVertexEmphasis(bool mode)\n\nTurns emphasis of vertices on or off for vertex selection. When\nemphasized verts are drawn nearer to the camera and are drawn\nlarger than normal to make selection of them more reliable.\n"},
  {"Stencil", PyvtkOpenGLPainterDeviceAdapter_Stencil, METH_VARARGS,
   "V.Stencil(int)\nC++: void Stencil(int on)\n\nControl use of the stencil buffer (for vertex selection).\n"},
  {"WriteStencil", PyvtkOpenGLPainterDeviceAdapter_WriteStencil, METH_VARARGS,
   "V.WriteStencil(int)\nC++: void WriteStencil(vtkIdType value)\n\nControl use of the stencil buffer (for vertex selection).\n"},
  {"TestStencil", PyvtkOpenGLPainterDeviceAdapter_TestStencil, METH_VARARGS,
   "V.TestStencil(int)\nC++: void TestStencil(vtkIdType value)\n\nControl use of the stencil buffer (for vertex selection).\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOpenGLPainterDeviceAdapter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkOpenGLPainterDeviceAdapter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLPainterDeviceAdapter_StaticNew()
{
  return vtkOpenGLPainterDeviceAdapter::New();
}

PyObject *PyvtkOpenGLPainterDeviceAdapter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLPainterDeviceAdapter_Type, PyvtkOpenGLPainterDeviceAdapter_Methods,
    "vtkOpenGLPainterDeviceAdapter",
    PyvtkOpenGLPainterDeviceAdapter_Doc(), &PyvtkOpenGLPainterDeviceAdapter_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLPainterDeviceAdapter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPainterDeviceAdapter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOpenGLPainterDeviceAdapter_Doc()
{
  static const char *docstring[] = {
    "vtkOpenGLPainterDeviceAdapter - An adapter between a vtkPainter and a\nrendering device.\n\n",
    "Superclass: vtkPainterDeviceAdapter\n\n",
    "An adapter between vtkPainter and the OpenGL rendering system.  Only\na handful of attributes with special meaning are supported.  The\nOpenGL attribute used for each attribute is given below.\n\n\n vtkDataSetAttributes::NORMALS          glNormal\n vtkDataSetAttributes:::SCALARS         glColor\n vtkDataSetAttributes::TCOORDS          glTexCoord\n vtkDataSetAttributes::NUM_ATTRIBUTES   glVertex\n \n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOpenGLPainterDeviceAdapter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOpenGLPainterDeviceAdapter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLPainterDeviceAdapter", o) != 0)
  {
    Py_DECREF(o);
  }

}

