// python wrapper for vtkOpenGLScalarsToColorsPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkOpenGLScalarsToColorsPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLScalarsToColorsPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLScalarsToColorsPainter_ClassNew(); }

#ifndef DECLARED_PyvtkScalarsToColorsPainter_ClassNew
extern "C" { PyObject *PyvtkScalarsToColorsPainter_ClassNew(); }
#define DECLARED_PyvtkScalarsToColorsPainter_ClassNew
#endif

static const char **PyvtkOpenGLScalarsToColorsPainter_Doc();


static PyObject *
PyvtkOpenGLScalarsToColorsPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkOpenGLScalarsToColorsPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLScalarsToColorsPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLScalarsToColorsPainter *op = static_cast<vtkOpenGLScalarsToColorsPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLScalarsToColorsPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLScalarsToColorsPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkOpenGLScalarsToColorsPainter *tempr = vtkOpenGLScalarsToColorsPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLScalarsToColorsPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLScalarsToColorsPainter *op = static_cast<vtkOpenGLScalarsToColorsPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkOpenGLScalarsToColorsPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLScalarsToColorsPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLScalarsToColorsPainter_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLScalarsToColorsPainter *op = static_cast<vtkOpenGLScalarsToColorsPainter *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkOpenGLScalarsToColorsPainter::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLScalarsToColorsPainter_GetPremultiplyColorsWithAlpha(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPremultiplyColorsWithAlpha");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLScalarsToColorsPainter *op = static_cast<vtkOpenGLScalarsToColorsPainter *>(vp);

  vtkActor *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkActor"))
  {
    int tempr = (ap.IsBound() ?
      op->GetPremultiplyColorsWithAlpha(temp0) :
      op->vtkOpenGLScalarsToColorsPainter::GetPremultiplyColorsWithAlpha(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLScalarsToColorsPainter_GetTextureSizeLimit(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTextureSizeLimit");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLScalarsToColorsPainter *op = static_cast<vtkOpenGLScalarsToColorsPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetTextureSizeLimit() :
      op->vtkOpenGLScalarsToColorsPainter::GetTextureSizeLimit());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkOpenGLScalarsToColorsPainter_Methods[] = {
  {"IsTypeOf", PyvtkOpenGLScalarsToColorsPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkOpenGLScalarsToColorsPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkOpenGLScalarsToColorsPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkOpenGLScalarsToColorsPainter\nC++: static vtkOpenGLScalarsToColorsPainter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkOpenGLScalarsToColorsPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLScalarsToColorsPainter\nC++: vtkOpenGLScalarsToColorsPainter *NewInstance()\n\n"},
  {"ReleaseGraphicsResources", PyvtkOpenGLScalarsToColorsPainter_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: void ReleaseGraphicsResources(vtkWindow *)\n\nRelease any graphics resources that are being consumed by this\nmapper. The parameter window could be used to determine which\ngraphic resources to release.\n"},
  {"GetPremultiplyColorsWithAlpha", PyvtkOpenGLScalarsToColorsPainter_GetPremultiplyColorsWithAlpha, METH_VARARGS,
   "V.GetPremultiplyColorsWithAlpha(vtkActor) -> int\nC++: int GetPremultiplyColorsWithAlpha(vtkActor *actor)\n\n"},
  {"GetTextureSizeLimit", PyvtkOpenGLScalarsToColorsPainter_GetTextureSizeLimit, METH_VARARGS,
   "V.GetTextureSizeLimit() -> int\nC++: vtkIdType GetTextureSizeLimit()\n\nReturn the texture size limit, i.e. GL_MAX_TEXTURE_SIZE.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOpenGLScalarsToColorsPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkOpenGLScalarsToColorsPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLScalarsToColorsPainter_StaticNew()
{
  return vtkOpenGLScalarsToColorsPainter::New();
}

PyObject *PyvtkOpenGLScalarsToColorsPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLScalarsToColorsPainter_Type, PyvtkOpenGLScalarsToColorsPainter_Methods,
    "vtkOpenGLScalarsToColorsPainter",
    PyvtkOpenGLScalarsToColorsPainter_Doc(), &PyvtkOpenGLScalarsToColorsPainter_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLScalarsToColorsPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkScalarsToColorsPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOpenGLScalarsToColorsPainter_Doc()
{
  static const char *docstring[] = {
    "vtkOpenGLScalarsToColorsPainter - implementation of\nvtkScalarsToColorsPainter for OpenGL.\n\n",
    "Superclass: vtkScalarsToColorsPainter\n\n",
    "vtkOpenGLScalarsToColorsPainter is a concrete subclass of\nvtkScalarsToColorsPainter which uses OpenGL for color mapping.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOpenGLScalarsToColorsPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOpenGLScalarsToColorsPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLScalarsToColorsPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

