// python wrapper for vtkPolyDataPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPolyDataPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPolyDataPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPolyDataPainter_ClassNew(); }

#ifndef DECLARED_PyvtkPainter_ClassNew
extern "C" { PyObject *PyvtkPainter_ClassNew(); }
#define DECLARED_PyvtkPainter_ClassNew
#endif

static const char **PyvtkPolyDataPainter_Doc();


static PyObject *
PyvtkPolyDataPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPolyDataPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataPainter *op = static_cast<vtkPolyDataPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPolyDataPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPolyDataPainter *tempr = vtkPolyDataPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataPainter *op = static_cast<vtkPolyDataPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPolyDataPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPolyDataPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataPainter_GetInputAsPolyData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInputAsPolyData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataPainter *op = static_cast<vtkPolyDataPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPolyData *tempr = (ap.IsBound() ?
      op->GetInputAsPolyData() :
      op->vtkPolyDataPainter::GetInputAsPolyData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataPainter_GetOutputAsPolyData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputAsPolyData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataPainter *op = static_cast<vtkPolyDataPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPolyData *tempr = (ap.IsBound() ?
      op->GetOutputAsPolyData() :
      op->vtkPolyDataPainter::GetOutputAsPolyData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataPainter_BUILD_NORMALS(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "BUILD_NORMALS");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkPolyDataPainter::BUILD_NORMALS();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataPainter_DISABLE_SCALAR_COLOR(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "DISABLE_SCALAR_COLOR");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkPolyDataPainter::DISABLE_SCALAR_COLOR();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataPainter_DATA_ARRAY_TO_VERTEX_ATTRIBUTE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "DATA_ARRAY_TO_VERTEX_ATTRIBUTE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationObjectBaseKey *tempr = vtkPolyDataPainter::DATA_ARRAY_TO_VERTEX_ATTRIBUTE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataPainter_SHADER_DEVICE_ADAPTOR(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SHADER_DEVICE_ADAPTOR");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationObjectBaseKey *tempr = vtkPolyDataPainter::SHADER_DEVICE_ADAPTOR();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPolyDataPainter_Render(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Render");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPolyDataPainter *op = static_cast<vtkPolyDataPainter *>(vp);

  vtkRenderer *temp0 = NULL;
  vtkActor *temp1 = NULL;
  unsigned long temp2;
  bool temp3 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetVTKObject(temp0, "vtkRenderer") &&
      ap.GetVTKObject(temp1, "vtkActor") &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    if (ap.IsBound())
    {
      op->Render(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkPolyDataPainter::Render(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPolyDataPainter_Methods[] = {
  {"IsTypeOf", PyvtkPolyDataPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPolyDataPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPolyDataPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPolyDataPainter\nC++: static vtkPolyDataPainter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPolyDataPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPolyDataPainter\nC++: vtkPolyDataPainter *NewInstance()\n\n"},
  {"GetInputAsPolyData", PyvtkPolyDataPainter_GetInputAsPolyData, METH_VARARGS,
   "V.GetInputAsPolyData() -> vtkPolyData\nC++: vtkPolyData *GetInputAsPolyData()\n\nGet/set the poly data to render.\n"},
  {"GetOutputAsPolyData", PyvtkPolyDataPainter_GetOutputAsPolyData, METH_VARARGS,
   "V.GetOutputAsPolyData() -> vtkPolyData\nC++: vtkPolyData *GetOutputAsPolyData()\n\nGet the output polydata from this Painter. The default\nimplementation forwards the input polydata as the output.\n"},
  {"BUILD_NORMALS", PyvtkPolyDataPainter_BUILD_NORMALS, METH_VARARGS,
   "V.BUILD_NORMALS() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *BUILD_NORMALS()\n\nKeys used to specify control the behaviour of the painter. When\non, the painter creates normals when none are available in the\npolydata. On by default.\n"},
  {"DISABLE_SCALAR_COLOR", PyvtkPolyDataPainter_DISABLE_SCALAR_COLOR, METH_VARARGS,
   "V.DISABLE_SCALAR_COLOR() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *DISABLE_SCALAR_COLOR()\n\nKey added to disable any scalar coloring for the current pass.\n"},
  {"DATA_ARRAY_TO_VERTEX_ATTRIBUTE", PyvtkPolyDataPainter_DATA_ARRAY_TO_VERTEX_ATTRIBUTE, METH_VARARGS,
   "V.DATA_ARRAY_TO_VERTEX_ATTRIBUTE() -> vtkInformationObjectBaseKey\nC++: static vtkInformationObjectBaseKey *DATA_ARRAY_TO_VERTEX_ATTRIBUTE(\n    )\n\n"},
  {"SHADER_DEVICE_ADAPTOR", PyvtkPolyDataPainter_SHADER_DEVICE_ADAPTOR, METH_VARARGS,
   "V.SHADER_DEVICE_ADAPTOR() -> vtkInformationObjectBaseKey\nC++: static vtkInformationObjectBaseKey *SHADER_DEVICE_ADAPTOR()\n\nKey to store the shader device adaptor.\n"},
  {"Render", PyvtkPolyDataPainter_Render, METH_VARARGS,
   "V.Render(vtkRenderer, vtkActor, int, bool)\nC++: void Render(vtkRenderer *renderer, vtkActor *actor,\n    unsigned long typeflags, bool forceCompileOnly)\n\nOverridden to stop the render call if input polydata is not set,\nsince PolyDataPainter cannot paint without any polydata input.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPolyDataPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkPolyDataPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkPolyDataPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPolyDataPainter_Type, PyvtkPolyDataPainter_Methods,
    "vtkPolyDataPainter",
    PyvtkPolyDataPainter_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkPolyDataPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPolyDataPainter_Doc()
{
  static const char *docstring[] = {
    "vtkPolyDataPainter - Abstract class for drawing poly data.\n\n",
    "Superclass: vtkPainter\n\n",
    "vtkPolyDataPainter encapsulates a method of drawing poly data.  This\nis a subset of what a mapper does.  The painter does no maintenance\nof the rendering state (camera, lights, etc.).  It is solely\nresponsible for issuing rendering commands that build graphics\nprimitives.\n\nTo simplify coding, an implementation of vtkPolyDataPainter is\nallowed to support only certain types of poly data or certain t",
    "ypes\nof primitives.\n\n@sa\nvtkDefaultPainter vtkStandardPainter vtkPainterDeviceAdapter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPolyDataPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPolyDataPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPolyDataPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

