// python wrapper for vtkScatterPlotPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkScatterPlotPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkScatterPlotPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkScatterPlotPainter_ClassNew(); }

#ifndef DECLARED_PyvtkPainter_ClassNew
extern "C" { PyObject *PyvtkPainter_ClassNew(); }
#define DECLARED_PyvtkPainter_ClassNew
#endif

static const char **PyvtkScatterPlotPainter_Doc();


static PyObject *
PyvtkScatterPlotPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkScatterPlotPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotPainter *op = static_cast<vtkScatterPlotPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkScatterPlotPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkScatterPlotPainter *tempr = vtkScatterPlotPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotPainter *op = static_cast<vtkScatterPlotPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkScatterPlotPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkScatterPlotPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_GetMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotPainter *op = static_cast<vtkScatterPlotPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetMTime() :
      op->vtkScatterPlotPainter::GetMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_GetArray_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotPainter *op = static_cast<vtkScatterPlotPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkDataArray *tempr = (ap.IsBound() ?
      op->GetArray(temp0) :
      op->vtkScatterPlotPainter::GetArray(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkScatterPlotPainter_GetArray_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotPainter *op = static_cast<vtkScatterPlotPainter *>(vp);

  int temp0;
  vtkDataSet *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkDataSet"))
  {
    vtkDataArray *tempr = (ap.IsBound() ?
      op->GetArray(temp0, temp1) :
      op->vtkScatterPlotPainter::GetArray(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkScatterPlotPainter_GetArray(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkScatterPlotPainter_GetArray_s1(self, args);
    case 2:
      return PyvtkScatterPlotPainter_GetArray_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetArray");
  return NULL;
}



static PyObject *
PyvtkScatterPlotPainter_GetArrayComponent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetArrayComponent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotPainter *op = static_cast<vtkScatterPlotPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetArrayComponent(temp0) :
      op->vtkScatterPlotPainter::GetArrayComponent(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_THREED_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "THREED_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScatterPlotPainter::THREED_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_COLORIZE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "COLORIZE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScatterPlotPainter::COLORIZE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_GLYPH_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GLYPH_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScatterPlotPainter::GLYPH_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_SCALING_ARRAY_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALING_ARRAY_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScatterPlotPainter::SCALING_ARRAY_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_SCALE_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALE_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScatterPlotPainter::SCALE_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_SCALE_FACTOR(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALE_FACTOR");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationDoubleKey *tempr = vtkScatterPlotPainter::SCALE_FACTOR();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_ORIENTATION_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ORIENTATION_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScatterPlotPainter::ORIENTATION_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_NESTED_DISPLAY_LISTS(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "NESTED_DISPLAY_LISTS");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScatterPlotPainter::NESTED_DISPLAY_LISTS();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_PARALLEL_TO_CAMERA(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "PARALLEL_TO_CAMERA");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScatterPlotPainter::PARALLEL_TO_CAMERA();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_SetSourceGlyphMappers(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSourceGlyphMappers");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotPainter *op = static_cast<vtkScatterPlotPainter *>(vp);

  vtkCollection *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCollection"))
  {
    if (ap.IsBound())
    {
      op->SetSourceGlyphMappers(temp0);
    }
    else
    {
      op->vtkScatterPlotPainter::SetSourceGlyphMappers(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_GetSourceGlyphMappers(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSourceGlyphMappers");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotPainter *op = static_cast<vtkScatterPlotPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkCollection *tempr = (ap.IsBound() ?
      op->GetSourceGlyphMappers() :
      op->vtkScatterPlotPainter::GetSourceGlyphMappers());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotPainter *op = static_cast<vtkScatterPlotPainter *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkScatterPlotPainter::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_UpdateBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotPainter *op = static_cast<vtkScatterPlotPainter *>(vp);

  const int size0 = 6;
  double temp0[6];
  double save0[6];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->UpdateBounds(temp0);
    }
    else
    {
      op->vtkScatterPlotPainter::UpdateBounds(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScatterPlotPainter_GetInputArrayInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInputArrayInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScatterPlotPainter *op = static_cast<vtkScatterPlotPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkInformation *tempr = (ap.IsBound() ?
      op->GetInputArrayInformation(temp0) :
      op->vtkScatterPlotPainter::GetInputArrayInformation(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkScatterPlotPainter_Methods[] = {
  {"IsTypeOf", PyvtkScatterPlotPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkScatterPlotPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkScatterPlotPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkScatterPlotPainter\nC++: static vtkScatterPlotPainter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkScatterPlotPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkScatterPlotPainter\nC++: vtkScatterPlotPainter *NewInstance()\n\n"},
  {"GetMTime", PyvtkScatterPlotPainter_GetMTime, METH_VARARGS,
   "V.GetMTime() -> int\nC++: virtual vtkMTimeType GetMTime()\n\n"},
  {"GetArray", PyvtkScatterPlotPainter_GetArray, METH_VARARGS,
   "V.GetArray(int) -> vtkDataArray\nC++: vtkDataArray *GetArray(int idx)\nV.GetArray(int, vtkDataSet) -> vtkDataArray\nC++: vtkDataArray *GetArray(int idx, vtkDataSet *input)\n\nSee vtkScatterPlotMapper::ArrayIndex\n"},
  {"GetArrayComponent", PyvtkScatterPlotPainter_GetArrayComponent, METH_VARARGS,
   "V.GetArrayComponent(int) -> int\nC++: int GetArrayComponent(int idx)\n\nSee vtkScatterPlotMapper::ArrayIndex\n"},
  {"THREED_MODE", PyvtkScatterPlotPainter_THREED_MODE, METH_VARARGS,
   "V.THREED_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *THREED_MODE()\n\n"},
  {"COLORIZE", PyvtkScatterPlotPainter_COLORIZE, METH_VARARGS,
   "V.COLORIZE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *COLORIZE()\n\n"},
  {"GLYPH_MODE", PyvtkScatterPlotPainter_GLYPH_MODE, METH_VARARGS,
   "V.GLYPH_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *GLYPH_MODE()\n\n"},
  {"SCALING_ARRAY_MODE", PyvtkScatterPlotPainter_SCALING_ARRAY_MODE, METH_VARARGS,
   "V.SCALING_ARRAY_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *SCALING_ARRAY_MODE()\n\n"},
  {"SCALE_MODE", PyvtkScatterPlotPainter_SCALE_MODE, METH_VARARGS,
   "V.SCALE_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *SCALE_MODE()\n\n"},
  {"SCALE_FACTOR", PyvtkScatterPlotPainter_SCALE_FACTOR, METH_VARARGS,
   "V.SCALE_FACTOR() -> vtkInformationDoubleKey\nC++: static vtkInformationDoubleKey *SCALE_FACTOR()\n\n"},
  {"ORIENTATION_MODE", PyvtkScatterPlotPainter_ORIENTATION_MODE, METH_VARARGS,
   "V.ORIENTATION_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *ORIENTATION_MODE()\n\n"},
  {"NESTED_DISPLAY_LISTS", PyvtkScatterPlotPainter_NESTED_DISPLAY_LISTS, METH_VARARGS,
   "V.NESTED_DISPLAY_LISTS() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *NESTED_DISPLAY_LISTS()\n\n"},
  {"PARALLEL_TO_CAMERA", PyvtkScatterPlotPainter_PARALLEL_TO_CAMERA, METH_VARARGS,
   "V.PARALLEL_TO_CAMERA() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *PARALLEL_TO_CAMERA()\n\n"},
  {"SetSourceGlyphMappers", PyvtkScatterPlotPainter_SetSourceGlyphMappers, METH_VARARGS,
   "V.SetSourceGlyphMappers(vtkCollection)\nC++: virtual void SetSourceGlyphMappers(vtkCollection *)\n\n"},
  {"GetSourceGlyphMappers", PyvtkScatterPlotPainter_GetSourceGlyphMappers, METH_VARARGS,
   "V.GetSourceGlyphMappers() -> vtkCollection\nC++: virtual vtkCollection *GetSourceGlyphMappers()\n\n"},
  {"ReleaseGraphicsResources", PyvtkScatterPlotPainter_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: virtual void ReleaseGraphicsResources(vtkWindow *window)\n\nRelease any graphics resources that are being consumed by this\nmapper. The parameter window could be used to determine which\ngraphic resources to release.\n"},
  {"UpdateBounds", PyvtkScatterPlotPainter_UpdateBounds, METH_VARARGS,
   "V.UpdateBounds([float, float, float, float, float, float])\nC++: virtual void UpdateBounds(double bounds[6])\n\n"},
  {"GetInputArrayInformation", PyvtkScatterPlotPainter_GetInputArrayInformation, METH_VARARGS,
   "V.GetInputArrayInformation(int) -> vtkInformation\nC++: vtkInformation *GetInputArrayInformation(int idx)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkScatterPlotPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkScatterPlotPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkScatterPlotPainter_StaticNew()
{
  return vtkScatterPlotPainter::New();
}

PyObject *PyvtkScatterPlotPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkScatterPlotPainter_Type, PyvtkScatterPlotPainter_Methods,
    "vtkScatterPlotPainter",
    PyvtkScatterPlotPainter_Doc(), &PyvtkScatterPlotPainter_StaticNew);

  PyTypeObject *pytype = &PyvtkScatterPlotPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkScatterPlotPainter_Doc()
{
  static const char *docstring[] = {
    "vtkScatterPlotPainter - no description provided.\n\n",
    "Superclass: vtkPainter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkScatterPlotPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkScatterPlotPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkScatterPlotPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

