// python wrapper for vtkSurfaceLICPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSurfaceLICPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSurfaceLICPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSurfaceLICPainter_ClassNew(); }

#ifndef DECLARED_PyvtkPainter_ClassNew
extern "C" { PyObject *PyvtkPainter_ClassNew(); }
#define DECLARED_PyvtkPainter_ClassNew
#endif

static const char **PyvtkSurfaceLICPainter_Doc();


static PyObject *
PyvtkSurfaceLICPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSurfaceLICPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSurfaceLICPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSurfaceLICPainter *tempr = vtkSurfaceLICPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSurfaceLICPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSurfaceLICPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDataObject *tempr = (ap.IsBound() ?
      op->GetOutput() :
      op->vtkSurfaceLICPainter::GetOutput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetEnable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEnable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEnable(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetEnable(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetEnable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEnable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetEnable() :
      op->vtkSurfaceLICPainter::GetEnable());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetEnableOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEnableOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetEnableOn();
    }
    else
    {
      op->vtkSurfaceLICPainter::SetEnableOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetEnableOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEnableOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetEnableOff();
    }
    else
    {
      op->vtkSurfaceLICPainter::SetEnableOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetInputArrayToProcess_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputArrayToProcess");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetInputArrayToProcess(temp0, temp1);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetInputArrayToProcess(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkSurfaceLICPainter_SetInputArrayToProcess_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputArrayToProcess");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetInputArrayToProcess(temp0, temp1);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetInputArrayToProcess(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSurfaceLICPainter_SetInputArrayToProcess_Methods[] = {
  {NULL, PyvtkSurfaceLICPainter_SetInputArrayToProcess_s1, METH_VARARGS,
   "@iz"},
  {NULL, PyvtkSurfaceLICPainter_SetInputArrayToProcess_s2, METH_VARARGS,
   "@ii"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkSurfaceLICPainter_SetInputArrayToProcess(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkSurfaceLICPainter_SetInputArrayToProcess_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetInputArrayToProcess");
  return NULL;
}



static PyObject *
PyvtkSurfaceLICPainter_SetNumberOfSteps(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfSteps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfSteps(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetNumberOfSteps(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetNumberOfSteps(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfSteps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfSteps() :
      op->vtkSurfaceLICPainter::GetNumberOfSteps());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetStepSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStepSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetStepSize(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetStepSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetStepSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStepSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetStepSize() :
      op->vtkSurfaceLICPainter::GetStepSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetNormalizeVectors(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNormalizeVectors");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNormalizeVectors(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetNormalizeVectors(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_NormalizeVectorsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NormalizeVectorsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->NormalizeVectorsOn();
    }
    else
    {
      op->vtkSurfaceLICPainter::NormalizeVectorsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_NormalizeVectorsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NormalizeVectorsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->NormalizeVectorsOff();
    }
    else
    {
      op->vtkSurfaceLICPainter::NormalizeVectorsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetNormalizeVectors(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNormalizeVectors");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNormalizeVectors() :
      op->vtkSurfaceLICPainter::GetNormalizeVectors());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetMaskOnSurface(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaskOnSurface");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMaskOnSurface(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetMaskOnSurface(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_MaskOnSurfaceOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MaskOnSurfaceOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->MaskOnSurfaceOn();
    }
    else
    {
      op->vtkSurfaceLICPainter::MaskOnSurfaceOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_MaskOnSurfaceOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MaskOnSurfaceOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->MaskOnSurfaceOff();
    }
    else
    {
      op->vtkSurfaceLICPainter::MaskOnSurfaceOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetMaskOnSurface(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaskOnSurface");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMaskOnSurface() :
      op->vtkSurfaceLICPainter::GetMaskOnSurface());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetMaskThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaskThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMaskThreshold(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetMaskThreshold(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetMaskThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaskThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetMaskThreshold() :
      op->vtkSurfaceLICPainter::GetMaskThreshold());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetMaskColor_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaskColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(2*size0);
  double *temp0 = store0.Data();
  double *save0 = (size0 == 0 ? NULL : temp0 + size0);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetMaskColor(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetMaskColor(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkSurfaceLICPainter_SetMaskColor_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaskColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetMaskColor(temp0, temp1, temp2);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetMaskColor(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkSurfaceLICPainter_SetMaskColor(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkSurfaceLICPainter_SetMaskColor_s1(self, args);
    case 3:
      return PyvtkSurfaceLICPainter_SetMaskColor_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetMaskColor");
  return NULL;
}



static PyObject *
PyvtkSurfaceLICPainter_GetMaskColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaskColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetMaskColor() :
      op->vtkSurfaceLICPainter::GetMaskColor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetMaskIntensity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaskIntensity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMaskIntensity(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetMaskIntensity(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetMaskIntensity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaskIntensity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetMaskIntensity() :
      op->vtkSurfaceLICPainter::GetMaskIntensity());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetEnhancedLIC(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEnhancedLIC");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEnhancedLIC(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetEnhancedLIC(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetEnhancedLIC(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEnhancedLIC");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetEnhancedLIC() :
      op->vtkSurfaceLICPainter::GetEnhancedLIC());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_EnhancedLICOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EnhancedLICOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EnhancedLICOn();
    }
    else
    {
      op->vtkSurfaceLICPainter::EnhancedLICOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_EnhancedLICOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EnhancedLICOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EnhancedLICOff();
    }
    else
    {
      op->vtkSurfaceLICPainter::EnhancedLICOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetEnhanceContrast(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEnhanceContrast");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEnhanceContrast(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetEnhanceContrast(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetEnhanceContrast(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEnhanceContrast");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetEnhanceContrast() :
      op->vtkSurfaceLICPainter::GetEnhanceContrast());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetLowLICContrastEnhancementFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLowLICContrastEnhancementFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetLowLICContrastEnhancementFactor() :
      op->vtkSurfaceLICPainter::GetLowLICContrastEnhancementFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetHighLICContrastEnhancementFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHighLICContrastEnhancementFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetHighLICContrastEnhancementFactor() :
      op->vtkSurfaceLICPainter::GetHighLICContrastEnhancementFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetLowLICContrastEnhancementFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLowLICContrastEnhancementFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLowLICContrastEnhancementFactor(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetLowLICContrastEnhancementFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetHighLICContrastEnhancementFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetHighLICContrastEnhancementFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetHighLICContrastEnhancementFactor(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetHighLICContrastEnhancementFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetLowColorContrastEnhancementFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLowColorContrastEnhancementFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetLowColorContrastEnhancementFactor() :
      op->vtkSurfaceLICPainter::GetLowColorContrastEnhancementFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetHighColorContrastEnhancementFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHighColorContrastEnhancementFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetHighColorContrastEnhancementFactor() :
      op->vtkSurfaceLICPainter::GetHighColorContrastEnhancementFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetLowColorContrastEnhancementFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLowColorContrastEnhancementFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLowColorContrastEnhancementFactor(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetLowColorContrastEnhancementFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetHighColorContrastEnhancementFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetHighColorContrastEnhancementFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetHighColorContrastEnhancementFactor(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetHighColorContrastEnhancementFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetAntiAlias(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAntiAlias");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAntiAlias(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetAntiAlias(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_AntiAliasOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AntiAliasOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AntiAliasOn();
    }
    else
    {
      op->vtkSurfaceLICPainter::AntiAliasOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_AntiAliasOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AntiAliasOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AntiAliasOff();
    }
    else
    {
      op->vtkSurfaceLICPainter::AntiAliasOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetAntiAlias(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAntiAlias");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAntiAlias() :
      op->vtkSurfaceLICPainter::GetAntiAlias());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetColorMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetColorMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetColorMode(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetColorMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetColorMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColorMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetColorMode() :
      op->vtkSurfaceLICPainter::GetColorMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetLICIntensity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLICIntensity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLICIntensity(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetLICIntensity(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetLICIntensity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLICIntensity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetLICIntensity() :
      op->vtkSurfaceLICPainter::GetLICIntensity());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetMapModeBias(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMapModeBias");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMapModeBias(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetMapModeBias(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetMapModeBias(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMapModeBias");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetMapModeBias() :
      op->vtkSurfaceLICPainter::GetMapModeBias());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetNoiseDataSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNoiseDataSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  vtkImageData *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    if (ap.IsBound())
    {
      op->SetNoiseDataSet(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetNoiseDataSet(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetNoiseDataSet(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNoiseDataSet");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageData *tempr = (ap.IsBound() ?
      op->GetNoiseDataSet() :
      op->vtkSurfaceLICPainter::GetNoiseDataSet());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetGenerateNoiseTexture(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGenerateNoiseTexture");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGenerateNoiseTexture(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetGenerateNoiseTexture(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetGenerateNoiseTexture(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGenerateNoiseTexture");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetGenerateNoiseTexture() :
      op->vtkSurfaceLICPainter::GetGenerateNoiseTexture());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetNoiseType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNoiseType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNoiseType(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetNoiseType(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetNoiseType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNoiseType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNoiseType() :
      op->vtkSurfaceLICPainter::GetNoiseType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetNoiseTextureSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNoiseTextureSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNoiseTextureSize(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetNoiseTextureSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetNoiseTextureSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNoiseTextureSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNoiseTextureSize() :
      op->vtkSurfaceLICPainter::GetNoiseTextureSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetNoiseGrainSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNoiseGrainSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNoiseGrainSize(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetNoiseGrainSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetNoiseGrainSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNoiseGrainSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNoiseGrainSize() :
      op->vtkSurfaceLICPainter::GetNoiseGrainSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetMinNoiseValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMinNoiseValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMinNoiseValue(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetMinNoiseValue(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetMaxNoiseValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaxNoiseValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMaxNoiseValue(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetMaxNoiseValue(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetMinNoiseValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMinNoiseValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetMinNoiseValue() :
      op->vtkSurfaceLICPainter::GetMinNoiseValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetMaxNoiseValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaxNoiseValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetMaxNoiseValue() :
      op->vtkSurfaceLICPainter::GetMaxNoiseValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetNumberOfNoiseLevels(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfNoiseLevels");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfNoiseLevels(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetNumberOfNoiseLevels(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetNumberOfNoiseLevels(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfNoiseLevels");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfNoiseLevels() :
      op->vtkSurfaceLICPainter::GetNumberOfNoiseLevels());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetImpulseNoiseProbability(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetImpulseNoiseProbability");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetImpulseNoiseProbability(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetImpulseNoiseProbability(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetImpulseNoiseProbability(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetImpulseNoiseProbability");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetImpulseNoiseProbability() :
      op->vtkSurfaceLICPainter::GetImpulseNoiseProbability());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetImpulseNoiseBackgroundValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetImpulseNoiseBackgroundValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetImpulseNoiseBackgroundValue(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetImpulseNoiseBackgroundValue(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetImpulseNoiseBackgroundValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetImpulseNoiseBackgroundValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetImpulseNoiseBackgroundValue() :
      op->vtkSurfaceLICPainter::GetImpulseNoiseBackgroundValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetNoiseGeneratorSeed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNoiseGeneratorSeed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNoiseGeneratorSeed(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetNoiseGeneratorSeed(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetNoiseGeneratorSeed(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNoiseGeneratorSeed");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNoiseGeneratorSeed() :
      op->vtkSurfaceLICPainter::GetNoiseGeneratorSeed());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_SetCompositeStrategy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompositeStrategy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCompositeStrategy(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::SetCompositeStrategy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_GetCompositeStrategy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompositeStrategy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCompositeStrategy() :
      op->vtkSurfaceLICPainter::GetCompositeStrategy());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_IsSupported(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsSupported");

  vtkRenderWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderWindow"))
  {
    bool tempr = vtkSurfaceLICPainter::IsSupported(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSurfaceLICPainter_WriteTimerLog(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "WriteTimerLog");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSurfaceLICPainter *op = static_cast<vtkSurfaceLICPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->WriteTimerLog(temp0);
    }
    else
    {
      op->vtkSurfaceLICPainter::WriteTimerLog(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSurfaceLICPainter_Methods[] = {
  {"IsTypeOf", PyvtkSurfaceLICPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSurfaceLICPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSurfaceLICPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSurfaceLICPainter\nC++: static vtkSurfaceLICPainter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSurfaceLICPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSurfaceLICPainter\nC++: vtkSurfaceLICPainter *NewInstance()\n\n"},
  {"ReleaseGraphicsResources", PyvtkSurfaceLICPainter_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: void ReleaseGraphicsResources(vtkWindow *win)\n\nRelease any graphics resources that are being consumed by this\nmapper. The parameter window could be used to determine which\ngraphic resources to release. In this case, releases the display\nlists.\n"},
  {"GetOutput", PyvtkSurfaceLICPainter_GetOutput, METH_VARARGS,
   "V.GetOutput() -> vtkDataObject\nC++: vtkDataObject *GetOutput()\n\nGet the output data object from this painter. Overridden to pass\nthe input points (or cells) vectors as the tcoords to the\ndeletage painters. This is required by the internal GLSL shader\nprograms used for generating LIC.\n"},
  {"SetEnable", PyvtkSurfaceLICPainter_SetEnable, METH_VARARGS,
   "V.SetEnable(int)\nC++: void SetEnable(int val)\n\nEnable/Disable this painter.\n"},
  {"GetEnable", PyvtkSurfaceLICPainter_GetEnable, METH_VARARGS,
   "V.GetEnable() -> int\nC++: virtual int GetEnable()\n\nEnable/Disable this painter.\n"},
  {"SetEnableOn", PyvtkSurfaceLICPainter_SetEnableOn, METH_VARARGS,
   "V.SetEnableOn()\nC++: void SetEnableOn()\n\nEnable/Disable this painter.\n"},
  {"SetEnableOff", PyvtkSurfaceLICPainter_SetEnableOff, METH_VARARGS,
   "V.SetEnableOff()\nC++: void SetEnableOff()\n\nEnable/Disable this painter.\n"},
  {"SetInputArrayToProcess", PyvtkSurfaceLICPainter_SetInputArrayToProcess, METH_VARARGS,
   "V.SetInputArrayToProcess(int, string)\nC++: void SetInputArrayToProcess(int fieldAssociation,\n    const char *name)\nV.SetInputArrayToProcess(int, int)\nC++: void SetInputArrayToProcess(int fieldAssociation,\n    int fieldAttributeType)\n\nSet the vectors to used for applying LIC. By default point\nvectors are used. Arguments are same as those passed to\nvtkAlgorithm::SetInputArrayToProcess except the first 3 arguments\ni.e. idx, port, connection.\n"},
  {"SetNumberOfSteps", PyvtkSurfaceLICPainter_SetNumberOfSteps, METH_VARARGS,
   "V.SetNumberOfSteps(int)\nC++: void SetNumberOfSteps(int val)\n\nGet/Set the number of integration steps in each direction.\n"},
  {"GetNumberOfSteps", PyvtkSurfaceLICPainter_GetNumberOfSteps, METH_VARARGS,
   "V.GetNumberOfSteps() -> int\nC++: virtual int GetNumberOfSteps()\n\nGet/Set the number of integration steps in each direction.\n"},
  {"SetStepSize", PyvtkSurfaceLICPainter_SetStepSize, METH_VARARGS,
   "V.SetStepSize(float)\nC++: void SetStepSize(double val)\n\nGet/Set the step size (in pixels).\n"},
  {"GetStepSize", PyvtkSurfaceLICPainter_GetStepSize, METH_VARARGS,
   "V.GetStepSize() -> float\nC++: virtual double GetStepSize()\n\nGet/Set the step size (in pixels).\n"},
  {"SetNormalizeVectors", PyvtkSurfaceLICPainter_SetNormalizeVectors, METH_VARARGS,
   "V.SetNormalizeVectors(int)\nC++: void SetNormalizeVectors(int val)\n\nNormalize vectors during integration. When set(the default) the\ninput vector field is normalized during integration, and each\nintegration occurs over the same arclength. When not set each\nintegration occurs over an arc length proportional to the field\nmagnitude as is customary in traditional numerical methods. See, \"Imaging Vector Fields Using Line Integral\nConvolution\" for an axample where normalization is used. See,\n\"Image Space Based Visualization of Unsteady Flow on Surfaces\"\nfor an example of where no normalization is used.\n"},
  {"NormalizeVectorsOn", PyvtkSurfaceLICPainter_NormalizeVectorsOn, METH_VARARGS,
   "V.NormalizeVectorsOn()\nC++: virtual void NormalizeVectorsOn()\n\nNormalize vectors during integration. When set(the default) the\ninput vector field is normalized during integration, and each\nintegration occurs over the same arclength. When not set each\nintegration occurs over an arc length proportional to the field\nmagnitude as is customary in traditional numerical methods. See, \"Imaging Vector Fields Using Line Integral\nConvolution\" for an axample where normalization is used. See,\n\"Image Space Based Visualization of Unsteady Flow on Surfaces\"\nfor an example of where no normalization is used.\n"},
  {"NormalizeVectorsOff", PyvtkSurfaceLICPainter_NormalizeVectorsOff, METH_VARARGS,
   "V.NormalizeVectorsOff()\nC++: virtual void NormalizeVectorsOff()\n\nNormalize vectors during integration. When set(the default) the\ninput vector field is normalized during integration, and each\nintegration occurs over the same arclength. When not set each\nintegration occurs over an arc length proportional to the field\nmagnitude as is customary in traditional numerical methods. See, \"Imaging Vector Fields Using Line Integral\nConvolution\" for an axample where normalization is used. See,\n\"Image Space Based Visualization of Unsteady Flow on Surfaces\"\nfor an example of where no normalization is used.\n"},
  {"GetNormalizeVectors", PyvtkSurfaceLICPainter_GetNormalizeVectors, METH_VARARGS,
   "V.GetNormalizeVectors() -> int\nC++: virtual int GetNormalizeVectors()\n\nNormalize vectors during integration. When set(the default) the\ninput vector field is normalized during integration, and each\nintegration occurs over the same arclength. When not set each\nintegration occurs over an arc length proportional to the field\nmagnitude as is customary in traditional numerical methods. See, \"Imaging Vector Fields Using Line Integral\nConvolution\" for an axample where normalization is used. See,\n\"Image Space Based Visualization of Unsteady Flow on Surfaces\"\nfor an example of where no normalization is used.\n"},
  {"SetMaskOnSurface", PyvtkSurfaceLICPainter_SetMaskOnSurface, METH_VARARGS,
   "V.SetMaskOnSurface(int)\nC++: void SetMaskOnSurface(int val)\n\nWhen set MaskOnSurface computes |V| for use in the fragment\nmasking tests on the surface. When not set the original\nun-projected un-transformed |V| is used.\n"},
  {"MaskOnSurfaceOn", PyvtkSurfaceLICPainter_MaskOnSurfaceOn, METH_VARARGS,
   "V.MaskOnSurfaceOn()\nC++: virtual void MaskOnSurfaceOn()\n\nWhen set MaskOnSurface computes |V| for use in the fragment\nmasking tests on the surface. When not set the original\nun-projected un-transformed |V| is used.\n"},
  {"MaskOnSurfaceOff", PyvtkSurfaceLICPainter_MaskOnSurfaceOff, METH_VARARGS,
   "V.MaskOnSurfaceOff()\nC++: virtual void MaskOnSurfaceOff()\n\nWhen set MaskOnSurface computes |V| for use in the fragment\nmasking tests on the surface. When not set the original\nun-projected un-transformed |V| is used.\n"},
  {"GetMaskOnSurface", PyvtkSurfaceLICPainter_GetMaskOnSurface, METH_VARARGS,
   "V.GetMaskOnSurface() -> int\nC++: virtual int GetMaskOnSurface()\n\nWhen set MaskOnSurface computes |V| for use in the fragment\nmasking tests on the surface. When not set the original\nun-projected un-transformed |V| is used.\n"},
  {"SetMaskThreshold", PyvtkSurfaceLICPainter_SetMaskThreshold, METH_VARARGS,
   "V.SetMaskThreshold(float)\nC++: void SetMaskThreshold(double val)\n\nThe MaskThreshold controls the rendering of fragments in stagnant\nregions of flow.  // In these regions LIC noise texture will be\nmasked, where |V| < MaskThreshold is satisifed. The masking\nprocess blends a the MaskColor with the scalar color of the\nsurface proportional to MaskIntesnsity. See MaskIntensity for\nmore information on the blending algorithm. This blending allows\none control over the masking process so that masked fragments may\nbe: highlighted (by setting a unique mask color and mask\nintensity > 0), made invisible with and without passing the\nun-convolved noise texture (by setting mask intensity 0), made to\nblend into the LIC.\n\n* MaskThreshold units are in the original vector space. Note that\nthe\n* threshold can be applied to the original vector field or to the\nsurface\n* projected vector field. See MaskOnSurface.\n"},
  {"GetMaskThreshold", PyvtkSurfaceLICPainter_GetMaskThreshold, METH_VARARGS,
   "V.GetMaskThreshold() -> float\nC++: virtual double GetMaskThreshold()\n\nThe MaskThreshold controls the rendering of fragments in stagnant\nregions of flow.  // In these regions LIC noise texture will be\nmasked, where |V| < MaskThreshold is satisifed. The masking\nprocess blends a the MaskColor with the scalar color of the\nsurface proportional to MaskIntesnsity. See MaskIntensity for\nmore information on the blending algorithm. This blending allows\none control over the masking process so that masked fragments may\nbe: highlighted (by setting a unique mask color and mask\nintensity > 0), made invisible with and without passing the\nun-convolved noise texture (by setting mask intensity 0), made to\nblend into the LIC.\n\n* MaskThreshold units are in the original vector space. Note that\nthe\n* threshold can be applied to the original vector field or to the\nsurface\n* projected vector field. See MaskOnSurface.\n"},
  {"SetMaskColor", PyvtkSurfaceLICPainter_SetMaskColor, METH_VARARGS,
   "V.SetMaskColor([float, ...])\nC++: void SetMaskColor(double *val)\nV.SetMaskColor(float, float, float)\nC++: void SetMaskColor(double r, double g, double b)\n\nThe MaskColor is used on masked fragments. The default of (0.5,\n0.5, 0.5) makes the masked fragments look similar to the LIC'd\nfragments. The mask color is applied only when MaskIntensity > 0.\n"},
  {"GetMaskColor", PyvtkSurfaceLICPainter_GetMaskColor, METH_VARARGS,
   "V.GetMaskColor() -> (float, float, float)\nC++: double *GetMaskColor()\n\n"},
  {"SetMaskIntensity", PyvtkSurfaceLICPainter_SetMaskIntensity, METH_VARARGS,
   "V.SetMaskIntensity(float)\nC++: void SetMaskIntensity(double val)\n\nThe MaskIntensity controls the blending of the mask color and the\ngeometry color. The color of masked fragments is given by:\n\n* c = maskColor * maskIntensity + geomColor * (1 - maskIntensity)\n\n* The default value of 0.0 results in the geometry color being\n  used.\n"},
  {"GetMaskIntensity", PyvtkSurfaceLICPainter_GetMaskIntensity, METH_VARARGS,
   "V.GetMaskIntensity() -> float\nC++: virtual double GetMaskIntensity()\n\nThe MaskIntensity controls the blending of the mask color and the\ngeometry color. The color of masked fragments is given by:\n\n* c = maskColor * maskIntensity + geomColor * (1 - maskIntensity)\n\n* The default value of 0.0 results in the geometry color being\n  used.\n"},
  {"SetEnhancedLIC", PyvtkSurfaceLICPainter_SetEnhancedLIC, METH_VARARGS,
   "V.SetEnhancedLIC(int)\nC++: void SetEnhancedLIC(int val)\n\nEnhancedLIC mean compute the LIC twice with the second pass using\nthe edge-enhanced result of the first pass as a noise texture.\nEdge enhancedment is made by a simple Laplace convolution.\n"},
  {"GetEnhancedLIC", PyvtkSurfaceLICPainter_GetEnhancedLIC, METH_VARARGS,
   "V.GetEnhancedLIC() -> int\nC++: virtual int GetEnhancedLIC()\n\nEnhancedLIC mean compute the LIC twice with the second pass using\nthe edge-enhanced result of the first pass as a noise texture.\nEdge enhancedment is made by a simple Laplace convolution.\n"},
  {"EnhancedLICOn", PyvtkSurfaceLICPainter_EnhancedLICOn, METH_VARARGS,
   "V.EnhancedLICOn()\nC++: virtual void EnhancedLICOn()\n\nEnhancedLIC mean compute the LIC twice with the second pass using\nthe edge-enhanced result of the first pass as a noise texture.\nEdge enhancedment is made by a simple Laplace convolution.\n"},
  {"EnhancedLICOff", PyvtkSurfaceLICPainter_EnhancedLICOff, METH_VARARGS,
   "V.EnhancedLICOff()\nC++: virtual void EnhancedLICOff()\n\nEnhancedLIC mean compute the LIC twice with the second pass using\nthe edge-enhanced result of the first pass as a noise texture.\nEdge enhancedment is made by a simple Laplace convolution.\n"},
  {"SetEnhanceContrast", PyvtkSurfaceLICPainter_SetEnhanceContrast, METH_VARARGS,
   "V.SetEnhanceContrast(int)\nC++: void SetEnhanceContrast(int val)\n\nEnable/Disable contrast and dynamic range correction stages.\nContrast enhancement can be enabled during LIC computations (See\nvtkLineINtegralComvolution2D) and after the scalar colors have\nbeen combined with the LIC.\n\n* The best appraoch for using this feature is to enable LIC\n  enhancement,\n* and only if the image is to dark or dull enable COLOR\n  enhancement.\n\n* Both stages are implemented by a histogram stretching\n  algorithm. During\n* LIC stages the contrast enhancement is applied to gray scale\n  LIC image.\n* During the scalar coloring stage the contrast enhancement is\n  applied to\n* the lightness channel of the color image in HSL color space.\n  The\n* histogram stretching is implemented as follows:\n\n* L = (L-m)/(M-m)\n\n* where, L is the fragment intensity/lightness, m is the\n  intensity/lightness\n* to map to 0, M is the intensity/lightness to map to 1. The\n  default values\n* of m and M are the min and max taken over all fragments.\n\n* This increase the dynamic range and contrast in the LIC'd\n  image, both of\n* which are natuarly attenuated by the convolution process.\n\n* Values\n\n* ENHANCE_CONTRAST_OFF   -- don't enhance LIC or scalar colors\n* ENHANCE_CONTRAST_LIC   -- enhance in LIC high-pass input and\n  output\n* ENHANCE_CONTRAST_COLOR -- enhance after scalars are combined\n  with LIC\n* ENHANCE_CONTRAST_BOTH  -- enhance in LIC stages and after\n  scalar colors\n\n* This feature is disabled by default.\n"},
  {"GetEnhanceContrast", PyvtkSurfaceLICPainter_GetEnhanceContrast, METH_VARARGS,
   "V.GetEnhanceContrast() -> int\nC++: virtual int GetEnhanceContrast()\n\nEnable/Disable contrast and dynamic range correction stages.\nContrast enhancement can be enabled during LIC computations (See\nvtkLineINtegralComvolution2D) and after the scalar colors have\nbeen combined with the LIC.\n\n* The best appraoch for using this feature is to enable LIC\n  enhancement,\n* and only if the image is to dark or dull enable COLOR\n  enhancement.\n\n* Both stages are implemented by a histogram stretching\n  algorithm. During\n* LIC stages the contrast enhancement is applied to gray scale\n  LIC image.\n* During the scalar coloring stage the contrast enhancement is\n  applied to\n* the lightness channel of the color image in HSL color space.\n  The\n* histogram stretching is implemented as follows:\n\n* L = (L-m)/(M-m)\n\n* where, L is the fragment intensity/lightness, m is the\n  intensity/lightness\n* to map to 0, M is the intensity/lightness to map to 1. The\n  default values\n* of m and M are the min and max taken over all fragments.\n\n* This increase the dynamic range and contrast in the LIC'd\n  image, both of\n* which are natuarly attenuated by the convolution process.\n\n* Values\n\n* ENHANCE_CONTRAST_OFF   -- don't enhance LIC or scalar colors\n* ENHANCE_CONTRAST_LIC   -- enhance in LIC high-pass input and\n  output\n* ENHANCE_CONTRAST_COLOR -- enhance after scalars are combined\n  with LIC\n* ENHANCE_CONTRAST_BOTH  -- enhance in LIC stages and after\n  scalar colors\n\n* This feature is disabled by default.\n"},
  {"GetLowLICContrastEnhancementFactor", PyvtkSurfaceLICPainter_GetLowLICContrastEnhancementFactor, METH_VARARGS,
   "V.GetLowLICContrastEnhancementFactor() -> float\nC++: virtual double GetLowLICContrastEnhancementFactor()\n\nThis feature is used to fine tune the contrast enhancement. There\nare two modes AUTOMATIC and MANUAL.In AUTOMATIC mode values are\nprovided indicating the fraction of the range to adjust M and m\nby, during contrast enahncement histogram stretching. M and m are\nthe intensity/lightness values that map to 1 and 0. (see\nEnhanceContrast for an explanation of the mapping procedure). m\nand M are computed using the factors as follows:\n\n* m = min(C) + mFactor * (max(C) - min(C))\n* M = max(C) - MFactor * (max(C) - min(C))\n\n* the default values for mFactor and MFactor are 0 which result\n  in\n* m = min(C), M = max(C), taken over the entire image. Modifying\n  mFactor and\n* MFactor above or below zero provide control over the\n  saturation/\n* de-saturation during contrast enhancement.\n"},
  {"GetHighLICContrastEnhancementFactor", PyvtkSurfaceLICPainter_GetHighLICContrastEnhancementFactor, METH_VARARGS,
   "V.GetHighLICContrastEnhancementFactor() -> float\nC++: virtual double GetHighLICContrastEnhancementFactor()\n\nThis feature is used to fine tune the contrast enhancement. There\nare two modes AUTOMATIC and MANUAL.In AUTOMATIC mode values are\nprovided indicating the fraction of the range to adjust M and m\nby, during contrast enahncement histogram stretching. M and m are\nthe intensity/lightness values that map to 1 and 0. (see\nEnhanceContrast for an explanation of the mapping procedure). m\nand M are computed using the factors as follows:\n\n* m = min(C) + mFactor * (max(C) - min(C))\n* M = max(C) - MFactor * (max(C) - min(C))\n\n* the default values for mFactor and MFactor are 0 which result\n  in\n* m = min(C), M = max(C), taken over the entire image. Modifying\n  mFactor and\n* MFactor above or below zero provide control over the\n  saturation/\n* de-saturation during contrast enhancement.\n"},
  {"SetLowLICContrastEnhancementFactor", PyvtkSurfaceLICPainter_SetLowLICContrastEnhancementFactor, METH_VARARGS,
   "V.SetLowLICContrastEnhancementFactor(float)\nC++: void SetLowLICContrastEnhancementFactor(double val)\n\nThis feature is used to fine tune the contrast enhancement. There\nare two modes AUTOMATIC and MANUAL.In AUTOMATIC mode values are\nprovided indicating the fraction of the range to adjust M and m\nby, during contrast enahncement histogram stretching. M and m are\nthe intensity/lightness values that map to 1 and 0. (see\nEnhanceContrast for an explanation of the mapping procedure). m\nand M are computed using the factors as follows:\n\n* m = min(C) + mFactor * (max(C) - min(C))\n* M = max(C) - MFactor * (max(C) - min(C))\n\n* the default values for mFactor and MFactor are 0 which result\n  in\n* m = min(C), M = max(C), taken over the entire image. Modifying\n  mFactor and\n* MFactor above or below zero provide control over the\n  saturation/\n* de-saturation during contrast enhancement.\n"},
  {"SetHighLICContrastEnhancementFactor", PyvtkSurfaceLICPainter_SetHighLICContrastEnhancementFactor, METH_VARARGS,
   "V.SetHighLICContrastEnhancementFactor(float)\nC++: void SetHighLICContrastEnhancementFactor(double val)\n\nThis feature is used to fine tune the contrast enhancement. There\nare two modes AUTOMATIC and MANUAL.In AUTOMATIC mode values are\nprovided indicating the fraction of the range to adjust M and m\nby, during contrast enahncement histogram stretching. M and m are\nthe intensity/lightness values that map to 1 and 0. (see\nEnhanceContrast for an explanation of the mapping procedure). m\nand M are computed using the factors as follows:\n\n* m = min(C) + mFactor * (max(C) - min(C))\n* M = max(C) - MFactor * (max(C) - min(C))\n\n* the default values for mFactor and MFactor are 0 which result\n  in\n* m = min(C), M = max(C), taken over the entire image. Modifying\n  mFactor and\n* MFactor above or below zero provide control over the\n  saturation/\n* de-saturation during contrast enhancement.\n"},
  {"GetLowColorContrastEnhancementFactor", PyvtkSurfaceLICPainter_GetLowColorContrastEnhancementFactor, METH_VARARGS,
   "V.GetLowColorContrastEnhancementFactor() -> float\nC++: virtual double GetLowColorContrastEnhancementFactor()\n\n"},
  {"GetHighColorContrastEnhancementFactor", PyvtkSurfaceLICPainter_GetHighColorContrastEnhancementFactor, METH_VARARGS,
   "V.GetHighColorContrastEnhancementFactor() -> float\nC++: virtual double GetHighColorContrastEnhancementFactor()\n\n"},
  {"SetLowColorContrastEnhancementFactor", PyvtkSurfaceLICPainter_SetLowColorContrastEnhancementFactor, METH_VARARGS,
   "V.SetLowColorContrastEnhancementFactor(float)\nC++: void SetLowColorContrastEnhancementFactor(double val)\n\n"},
  {"SetHighColorContrastEnhancementFactor", PyvtkSurfaceLICPainter_SetHighColorContrastEnhancementFactor, METH_VARARGS,
   "V.SetHighColorContrastEnhancementFactor(float)\nC++: void SetHighColorContrastEnhancementFactor(double val)\n\n"},
  {"SetAntiAlias", PyvtkSurfaceLICPainter_SetAntiAlias, METH_VARARGS,
   "V.SetAntiAlias(int)\nC++: void SetAntiAlias(int val)\n\nEnable/Disable the anti-aliasing pass. This optional pass\n(disabled by default) can be enabled to reduce jagged patterns in\nthe final LIC image. Values greater than 0 control the number of\niterations, 1 is typically sufficient.\n"},
  {"AntiAliasOn", PyvtkSurfaceLICPainter_AntiAliasOn, METH_VARARGS,
   "V.AntiAliasOn()\nC++: virtual void AntiAliasOn()\n\nEnable/Disable the anti-aliasing pass. This optional pass\n(disabled by default) can be enabled to reduce jagged patterns in\nthe final LIC image. Values greater than 0 control the number of\niterations, 1 is typically sufficient.\n"},
  {"AntiAliasOff", PyvtkSurfaceLICPainter_AntiAliasOff, METH_VARARGS,
   "V.AntiAliasOff()\nC++: virtual void AntiAliasOff()\n\nEnable/Disable the anti-aliasing pass. This optional pass\n(disabled by default) can be enabled to reduce jagged patterns in\nthe final LIC image. Values greater than 0 control the number of\niterations, 1 is typically sufficient.\n"},
  {"GetAntiAlias", PyvtkSurfaceLICPainter_GetAntiAlias, METH_VARARGS,
   "V.GetAntiAlias() -> int\nC++: virtual int GetAntiAlias()\n\nEnable/Disable the anti-aliasing pass. This optional pass\n(disabled by default) can be enabled to reduce jagged patterns in\nthe final LIC image. Values greater than 0 control the number of\niterations, 1 is typically sufficient.\n"},
  {"SetColorMode", PyvtkSurfaceLICPainter_SetColorMode, METH_VARARGS,
   "V.SetColorMode(int)\nC++: void SetColorMode(int val)\n\nSet/Get the color mode. The color mode controls how scalar colors\nare combined with the LIC in the final image. The BLEND mode\ncombines scalar colors with LIC intensities with proportional\nblending controlled by the LICIntensity parameter. The MAP mode\ncombines scalar colors with LIC, by multiplication the HSL\nrepresntation of color's lightness.\n\n* The default is COLOR_MODE_BLEND.\n"},
  {"GetColorMode", PyvtkSurfaceLICPainter_GetColorMode, METH_VARARGS,
   "V.GetColorMode() -> int\nC++: virtual int GetColorMode()\n\nSet/Get the color mode. The color mode controls how scalar colors\nare combined with the LIC in the final image. The BLEND mode\ncombines scalar colors with LIC intensities with proportional\nblending controlled by the LICIntensity parameter. The MAP mode\ncombines scalar colors with LIC, by multiplication the HSL\nrepresntation of color's lightness.\n\n* The default is COLOR_MODE_BLEND.\n"},
  {"SetLICIntensity", PyvtkSurfaceLICPainter_SetLICIntensity, METH_VARARGS,
   "V.SetLICIntensity(float)\nC++: void SetLICIntensity(double val)\n\nFactor used when blend mode is set to COLOR_MODE_BLEND. This\ncontrols the contribution of the LIC in the final output image as\nfollows:\n\n* c = LIC * LICIntensity + scalar * (1 - LICIntensity);\n\n* 0.0 produces same result as disabling LIC altogether, while 1.0\nimplies\n* show LIC result alone.\n"},
  {"GetLICIntensity", PyvtkSurfaceLICPainter_GetLICIntensity, METH_VARARGS,
   "V.GetLICIntensity() -> float\nC++: virtual double GetLICIntensity()\n\nFactor used when blend mode is set to COLOR_MODE_BLEND. This\ncontrols the contribution of the LIC in the final output image as\nfollows:\n\n* c = LIC * LICIntensity + scalar * (1 - LICIntensity);\n\n* 0.0 produces same result as disabling LIC altogether, while 1.0\nimplies\n* show LIC result alone.\n"},
  {"SetMapModeBias", PyvtkSurfaceLICPainter_SetMapModeBias, METH_VARARGS,
   "V.SetMapModeBias(float)\nC++: void SetMapModeBias(double val)\n\nFactor used when blend mode is set to COLOR_MODE_MAP. This adds a\nbias to the LIC image. The purpose of this is to adjust the\nbrightness when a brighter image is desired. The default of 0.0\nresults in no change. Values gretaer than 0.0 will brighten the\nimage while values less than 0.0 darken the image.\n"},
  {"GetMapModeBias", PyvtkSurfaceLICPainter_GetMapModeBias, METH_VARARGS,
   "V.GetMapModeBias() -> float\nC++: virtual double GetMapModeBias()\n\nFactor used when blend mode is set to COLOR_MODE_MAP. This adds a\nbias to the LIC image. The purpose of this is to adjust the\nbrightness when a brighter image is desired. The default of 0.0\nresults in no change. Values gretaer than 0.0 will brighten the\nimage while values less than 0.0 darken the image.\n"},
  {"SetNoiseDataSet", PyvtkSurfaceLICPainter_SetNoiseDataSet, METH_VARARGS,
   "V.SetNoiseDataSet(vtkImageData)\nC++: void SetNoiseDataSet(vtkImageData *data)\n\nSet the data containing a noise array as active scalars. Active\nscalars array will be converted into a texture for use as noise\nin the LIC process. Noise datasets are expected to be gray scale.\n"},
  {"GetNoiseDataSet", PyvtkSurfaceLICPainter_GetNoiseDataSet, METH_VARARGS,
   "V.GetNoiseDataSet() -> vtkImageData\nC++: vtkImageData *GetNoiseDataSet()\n\nSet the data containing a noise array as active scalars. Active\nscalars array will be converted into a texture for use as noise\nin the LIC process. Noise datasets are expected to be gray scale.\n"},
  {"SetGenerateNoiseTexture", PyvtkSurfaceLICPainter_SetGenerateNoiseTexture, METH_VARARGS,
   "V.SetGenerateNoiseTexture(int)\nC++: void SetGenerateNoiseTexture(int shouldGenerate)\n\nSet/Get the noise texture source. When not set the default\n200x200 white noise texture is used (see\nVTKData/Data/Data/noise.png). When set a noise texture is\ngenerated based on the following parameters:\n\n* NoiseType               - select noise type. Gaussian, Uniform,\netc\n* NoiseTextureSize        - number of pixels in square noise\n  texture(side)\n* NoiseGrainSize          - number of pixels each noise value\n  spans(side)\n* MinNoiseValue           - minimum noise color >=0 && <\n  MaxNoiseValue\n* MaxNoiseValue           - maximum noise color <=1 ** >\n  MinNoiseValue\n* NumberOfNoiseLevels     - number of discrete noise colors\n* ImpulseNoiseProbability - impulse noise is generated when < 1\n* ImpulseNoiseBackgroundValue  - the background color for\n  untouched pixels\n* NoiseGeneratorSeed      - seed the random number generators\n\n* Changing the noise texture gives one greater control over the\n  look of the\n* final image. The default is 0 which results in the use of a\n  static 200x200\n* Gaussian noise texture. See VTKData/Data/Data/noise.png.\n"},
  {"GetGenerateNoiseTexture", PyvtkSurfaceLICPainter_GetGenerateNoiseTexture, METH_VARARGS,
   "V.GetGenerateNoiseTexture() -> int\nC++: virtual int GetGenerateNoiseTexture()\n\nSet/Get the noise texture source. When not set the default\n200x200 white noise texture is used (see\nVTKData/Data/Data/noise.png). When set a noise texture is\ngenerated based on the following parameters:\n\n* NoiseType               - select noise type. Gaussian, Uniform,\netc\n* NoiseTextureSize        - number of pixels in square noise\n  texture(side)\n* NoiseGrainSize          - number of pixels each noise value\n  spans(side)\n* MinNoiseValue           - minimum noise color >=0 && <\n  MaxNoiseValue\n* MaxNoiseValue           - maximum noise color <=1 ** >\n  MinNoiseValue\n* NumberOfNoiseLevels     - number of discrete noise colors\n* ImpulseNoiseProbability - impulse noise is generated when < 1\n* ImpulseNoiseBackgroundValue  - the background color for\n  untouched pixels\n* NoiseGeneratorSeed      - seed the random number generators\n\n* Changing the noise texture gives one greater control over the\n  look of the\n* final image. The default is 0 which results in the use of a\n  static 200x200\n* Gaussian noise texture. See VTKData/Data/Data/noise.png.\n"},
  {"SetNoiseType", PyvtkSurfaceLICPainter_SetNoiseType, METH_VARARGS,
   "V.SetNoiseType(int)\nC++: void SetNoiseType(int type)\n\nSelect the statistical distribution of randomly generated noise\nvalues. With uniform noise there is greater control over the\nrange of values in the noise texture. The Default is\nNOISE_TYPE_GAUSSIAN.\n"},
  {"GetNoiseType", PyvtkSurfaceLICPainter_GetNoiseType, METH_VARARGS,
   "V.GetNoiseType() -> int\nC++: virtual int GetNoiseType()\n\nSelect the statistical distribution of randomly generated noise\nvalues. With uniform noise there is greater control over the\nrange of values in the noise texture. The Default is\nNOISE_TYPE_GAUSSIAN.\n"},
  {"SetNoiseTextureSize", PyvtkSurfaceLICPainter_SetNoiseTextureSize, METH_VARARGS,
   "V.SetNoiseTextureSize(int)\nC++: void SetNoiseTextureSize(int length)\n\nSet/Get the side length in pixels of the noise texture. The\ntexture will be length^2 pixels in area.\n"},
  {"GetNoiseTextureSize", PyvtkSurfaceLICPainter_GetNoiseTextureSize, METH_VARARGS,
   "V.GetNoiseTextureSize() -> int\nC++: virtual int GetNoiseTextureSize()\n\nSet/Get the side length in pixels of the noise texture. The\ntexture will be length^2 pixels in area.\n"},
  {"SetNoiseGrainSize", PyvtkSurfaceLICPainter_SetNoiseGrainSize, METH_VARARGS,
   "V.SetNoiseGrainSize(int)\nC++: void SetNoiseGrainSize(int val)\n\nSet/Get the side length in pixels of the noise values in the\nnoise texture. Each noise value will be length^2 pixels in area.\n"},
  {"GetNoiseGrainSize", PyvtkSurfaceLICPainter_GetNoiseGrainSize, METH_VARARGS,
   "V.GetNoiseGrainSize() -> int\nC++: virtual int GetNoiseGrainSize()\n\nSet/Get the side length in pixels of the noise values in the\nnoise texture. Each noise value will be length^2 pixels in area.\n"},
  {"SetMinNoiseValue", PyvtkSurfaceLICPainter_SetMinNoiseValue, METH_VARARGS,
   "V.SetMinNoiseValue(float)\nC++: void SetMinNoiseValue(double val)\n\nSet/Get the minimum and mximum  gray scale values that the\ngenerated noise can take on. The generated noise will be in the\nrange of MinNoiseValue to MaxNoiseValue. Values are clamped\nwithin 0 to 1. MinNoiseValue must be less than MaxNoiseValue.\n"},
  {"SetMaxNoiseValue", PyvtkSurfaceLICPainter_SetMaxNoiseValue, METH_VARARGS,
   "V.SetMaxNoiseValue(float)\nC++: void SetMaxNoiseValue(double val)\n\nSet/Get the minimum and mximum  gray scale values that the\ngenerated noise can take on. The generated noise will be in the\nrange of MinNoiseValue to MaxNoiseValue. Values are clamped\nwithin 0 to 1. MinNoiseValue must be less than MaxNoiseValue.\n"},
  {"GetMinNoiseValue", PyvtkSurfaceLICPainter_GetMinNoiseValue, METH_VARARGS,
   "V.GetMinNoiseValue() -> float\nC++: virtual double GetMinNoiseValue()\n\nSet/Get the minimum and mximum  gray scale values that the\ngenerated noise can take on. The generated noise will be in the\nrange of MinNoiseValue to MaxNoiseValue. Values are clamped\nwithin 0 to 1. MinNoiseValue must be less than MaxNoiseValue.\n"},
  {"GetMaxNoiseValue", PyvtkSurfaceLICPainter_GetMaxNoiseValue, METH_VARARGS,
   "V.GetMaxNoiseValue() -> float\nC++: virtual double GetMaxNoiseValue()\n\nSet/Get the minimum and mximum  gray scale values that the\ngenerated noise can take on. The generated noise will be in the\nrange of MinNoiseValue to MaxNoiseValue. Values are clamped\nwithin 0 to 1. MinNoiseValue must be less than MaxNoiseValue.\n"},
  {"SetNumberOfNoiseLevels", PyvtkSurfaceLICPainter_SetNumberOfNoiseLevels, METH_VARARGS,
   "V.SetNumberOfNoiseLevels(int)\nC++: void SetNumberOfNoiseLevels(int val)\n\nSet/Get the number of discrete values a noise pixel may take on.\nDefault 1024.\n"},
  {"GetNumberOfNoiseLevels", PyvtkSurfaceLICPainter_GetNumberOfNoiseLevels, METH_VARARGS,
   "V.GetNumberOfNoiseLevels() -> int\nC++: virtual int GetNumberOfNoiseLevels()\n\nSet/Get the number of discrete values a noise pixel may take on.\nDefault 1024.\n"},
  {"SetImpulseNoiseProbability", PyvtkSurfaceLICPainter_SetImpulseNoiseProbability, METH_VARARGS,
   "V.SetImpulseNoiseProbability(float)\nC++: void SetImpulseNoiseProbability(double val)\n\nControl the density of of the noise. A value of 1.0 produces\nuniform random noise while values < 1.0 produce impulse noise\nwith the given probabilty.\n"},
  {"GetImpulseNoiseProbability", PyvtkSurfaceLICPainter_GetImpulseNoiseProbability, METH_VARARGS,
   "V.GetImpulseNoiseProbability() -> float\nC++: virtual double GetImpulseNoiseProbability()\n\nControl the density of of the noise. A value of 1.0 produces\nuniform random noise while values < 1.0 produce impulse noise\nwith the given probabilty.\n"},
  {"SetImpulseNoiseBackgroundValue", PyvtkSurfaceLICPainter_SetImpulseNoiseBackgroundValue, METH_VARARGS,
   "V.SetImpulseNoiseBackgroundValue(float)\nC++: void SetImpulseNoiseBackgroundValue(double val)\n\nThe color to use for untouched pixels when impulse noise\nprobability < 1.\n"},
  {"GetImpulseNoiseBackgroundValue", PyvtkSurfaceLICPainter_GetImpulseNoiseBackgroundValue, METH_VARARGS,
   "V.GetImpulseNoiseBackgroundValue() -> float\nC++: virtual double GetImpulseNoiseBackgroundValue()\n\nThe color to use for untouched pixels when impulse noise\nprobability < 1.\n"},
  {"SetNoiseGeneratorSeed", PyvtkSurfaceLICPainter_SetNoiseGeneratorSeed, METH_VARARGS,
   "V.SetNoiseGeneratorSeed(int)\nC++: void SetNoiseGeneratorSeed(int val)\n\nSet/Get the seed value used by the random number generator.\n"},
  {"GetNoiseGeneratorSeed", PyvtkSurfaceLICPainter_GetNoiseGeneratorSeed, METH_VARARGS,
   "V.GetNoiseGeneratorSeed() -> int\nC++: virtual int GetNoiseGeneratorSeed()\n\nSet/Get the seed value used by the random number generator.\n"},
  {"SetCompositeStrategy", PyvtkSurfaceLICPainter_SetCompositeStrategy, METH_VARARGS,
   "V.SetCompositeStrategy(int)\nC++: void SetCompositeStrategy(int val)\n\nControl the screen space decomposition where LIC is computed.\n"},
  {"GetCompositeStrategy", PyvtkSurfaceLICPainter_GetCompositeStrategy, METH_VARARGS,
   "V.GetCompositeStrategy() -> int\nC++: virtual int GetCompositeStrategy()\n\nControl the screen space decomposition where LIC is computed.\n"},
  {"IsSupported", PyvtkSurfaceLICPainter_IsSupported, METH_VARARGS,
   "V.IsSupported(vtkRenderWindow) -> bool\nC++: static bool IsSupported(vtkRenderWindow *context)\n\nReturns true if the rendering context supports extensions needed\nby this painter.\n"},
  {"WriteTimerLog", PyvtkSurfaceLICPainter_WriteTimerLog, METH_VARARGS,
   "V.WriteTimerLog(string)\nC++: virtual void WriteTimerLog(const char *)\n\nMethods used for parallel benchmarks. Use cmake to define\nvtkSurfaceLICPainterTIME to enable benchmarks. During each update\ntiming information is stored, it can be written to disk by\ncalling WriteLog.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSurfaceLICPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingLICPython.vtkSurfaceLICPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSurfaceLICPainter_StaticNew()
{
  return vtkSurfaceLICPainter::New();
}

PyObject *PyvtkSurfaceLICPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSurfaceLICPainter_Type, PyvtkSurfaceLICPainter_Methods,
    "vtkSurfaceLICPainter",
    PyvtkSurfaceLICPainter_Doc(), &PyvtkSurfaceLICPainter_StaticNew);

  PyTypeObject *pytype = &PyvtkSurfaceLICPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPainter_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 13; c++)
  {
    static const struct { const char *name; int value; }
      constants[13] = {
        { "ENHANCE_CONTRAST_OFF", vtkSurfaceLICPainter::ENHANCE_CONTRAST_OFF },
        { "ENHANCE_CONTRAST_LIC", vtkSurfaceLICPainter::ENHANCE_CONTRAST_LIC },
        { "ENHANCE_CONTRAST_COLOR", vtkSurfaceLICPainter::ENHANCE_CONTRAST_COLOR },
        { "ENHANCE_CONTRAST_BOTH", vtkSurfaceLICPainter::ENHANCE_CONTRAST_BOTH },
        { "COLOR_MODE_BLEND", vtkSurfaceLICPainter::COLOR_MODE_BLEND },
        { "COLOR_MODE_MAP", vtkSurfaceLICPainter::COLOR_MODE_MAP },
        { "NOISE_TYPE_UNIFORM", vtkSurfaceLICPainter::NOISE_TYPE_UNIFORM },
        { "NOISE_TYPE_GAUSSIAN", vtkSurfaceLICPainter::NOISE_TYPE_GAUSSIAN },
        { "NOISE_TYPE_PERLIN", vtkSurfaceLICPainter::NOISE_TYPE_PERLIN },
        { "COMPOSITE_INPLACE", vtkSurfaceLICPainter::COMPOSITE_INPLACE },
        { "COMPOSITE_INPLACE_DISJOINT", vtkSurfaceLICPainter::COMPOSITE_INPLACE_DISJOINT },
        { "COMPOSITE_BALANCED", vtkSurfaceLICPainter::COMPOSITE_BALANCED },
        { "COMPOSITE_AUTO", vtkSurfaceLICPainter::COMPOSITE_AUTO },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSurfaceLICPainter_Doc()
{
  static const char *docstring[] = {
    "vtkSurfaceLICPainter - painter that performs LIC on the surface of\n arbitrary geometry.\n\n",
    "Superclass: vtkPainter\n\n",
    "vtkSurfaceLICPainter painter performs LIC on the surface of arbitrary\n geometry. Point vectors are used as the vector field for generating\nthe LIC.\n The implementation was originallu  based on \"Image Space Based\nVisualization\n on Unsteady Flow on Surfaces\" by Laramee, Jobard and Hauser appeared\nin\n proceedings of IEEE Visualization '03, pages 131-138.\n\n\n Internal pipeline:\n\nnoise\n    |\n    [ PROJ ",
    "(GAT) (COMP) LIC2D (SCAT) SHADE (CCE) DEP]\n    |                                               | vectors        \n                                surface LIC  PROj  - prject vectors\nonto surface GAT   - gather data for compositing and guard pixel\ngeneration  (parallel only) COMP  - composite gathered data LIC2D -\nline intengral convolution, see vtkLineIntegralConvolution2D. SCAT  -\nscatter result (",
    "parallel only, not all compositors use it) SHADE -\ncombine LIC and scalar colors CCE   - color contrast enhancement\n(optional) DEP   - depth test and copy to back buffer\n\nThe result of each stage is cached in a texture so that during\ninteraction a stage may be skipped if the user has not modified its\nparameters or input data.\n\nThe parallel parts of algorithm are implemented in\nvtkPSurfaceLICPainte",
    "r. Note that for MPI enabled builds this class\nwill be automatically created by the object factory.\n\n@sa\nvtkSurfaceLICDefaultPainter vtkLineIntegralConvolution2D\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSurfaceLICPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSurfaceLICPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSurfaceLICPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

