// python wrapper for vtkTexturePainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkTexturePainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTexturePainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTexturePainter_ClassNew(); }

#ifndef DECLARED_PyvtkPainter_ClassNew
extern "C" { PyObject *PyvtkPainter_ClassNew(); }
#define DECLARED_PyvtkPainter_ClassNew
#endif

static const char **PyvtkTexturePainter_Doc();


static PyObject *
PyvtkTexturePainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkTexturePainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTexturePainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkTexturePainter *tempr = vtkTexturePainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkTexturePainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTexturePainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SLICE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SLICE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkTexturePainter::SLICE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SLICE_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SLICE_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkTexturePainter::SLICE_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_MAP_SCALARS(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "MAP_SCALARS");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkTexturePainter::MAP_SCALARS();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_LOOKUP_TABLE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "LOOKUP_TABLE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationObjectBaseKey *tempr = vtkTexturePainter::LOOKUP_TABLE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SCALAR_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALAR_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkTexturePainter::SCALAR_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SetScalarMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalarMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScalarMode(temp0);
    }
    else
    {
      op->vtkTexturePainter::SetScalarMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_GetScalarMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScalarMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetScalarMode() :
      op->vtkTexturePainter::GetScalarMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SCALAR_ARRAY_NAME(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALAR_ARRAY_NAME");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationStringKey *tempr = vtkTexturePainter::SCALAR_ARRAY_NAME();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SetScalarArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalarArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScalarArrayName(temp0);
    }
    else
    {
      op->vtkTexturePainter::SetScalarArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_GetScalarArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScalarArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetScalarArrayName() :
      op->vtkTexturePainter::GetScalarArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SCALAR_ARRAY_INDEX(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALAR_ARRAY_INDEX");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkTexturePainter::SCALAR_ARRAY_INDEX();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SetScalarArrayIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalarArrayIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScalarArrayIndex(temp0);
    }
    else
    {
      op->vtkTexturePainter::SetScalarArrayIndex(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_GetScalarArrayIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScalarArrayIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetScalarArrayIndex() :
      op->vtkTexturePainter::GetScalarArrayIndex());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SetSlice(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSlice");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSlice(temp0);
    }
    else
    {
      op->vtkTexturePainter::SetSlice(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_GetSlice(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSlice");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSlice() :
      op->vtkTexturePainter::GetSlice());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SetSliceMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSliceMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSliceMode(temp0);
    }
    else
    {
      op->vtkTexturePainter::SetSliceMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_GetSliceModeMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceModeMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSliceModeMinValue() :
      op->vtkTexturePainter::GetSliceModeMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_GetSliceModeMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceModeMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSliceModeMaxValue() :
      op->vtkTexturePainter::GetSliceModeMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_GetSliceMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSliceMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSliceMode() :
      op->vtkTexturePainter::GetSliceMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SetLookupTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLookupTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  vtkScalarsToColors *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkScalarsToColors"))
  {
    if (ap.IsBound())
    {
      op->SetLookupTable(temp0);
    }
    else
    {
      op->vtkTexturePainter::SetLookupTable(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SetMapScalars(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMapScalars");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMapScalars(temp0);
    }
    else
    {
      op->vtkTexturePainter::SetMapScalars(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_GetMapScalars(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMapScalars");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMapScalars() :
      op->vtkTexturePainter::GetMapScalars());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_USE_XY_PLANE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "USE_XY_PLANE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkTexturePainter::USE_XY_PLANE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SetUseXYPlane(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseXYPlane");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseXYPlane(temp0);
    }
    else
    {
      op->vtkTexturePainter::SetUseXYPlane(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_GetUseXYPlaneMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseXYPlaneMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetUseXYPlaneMinValue() :
      op->vtkTexturePainter::GetUseXYPlaneMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_GetUseXYPlaneMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseXYPlaneMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetUseXYPlaneMaxValue() :
      op->vtkTexturePainter::GetUseXYPlaneMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_UseXYPlaneOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseXYPlaneOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseXYPlaneOn();
    }
    else
    {
      op->vtkTexturePainter::UseXYPlaneOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_UseXYPlaneOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseXYPlaneOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseXYPlaneOff();
    }
    else
    {
      op->vtkTexturePainter::UseXYPlaneOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_GetUseXYPlane(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseXYPlane");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetUseXYPlane() :
      op->vtkTexturePainter::GetUseXYPlane());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkTexturePainter::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTexturePainter_SetWholeExtent_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetWholeExtent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  int temp0;
  int temp1;
  int temp2;
  int temp3;
  int temp4;
  int temp5;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetValue(temp5))
  {
    if (ap.IsBound())
    {
      op->SetWholeExtent(temp0, temp1, temp2, temp3, temp4, temp5);
    }
    else
    {
      op->vtkTexturePainter::SetWholeExtent(temp0, temp1, temp2, temp3, temp4, temp5);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkTexturePainter_SetWholeExtent_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetWholeExtent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTexturePainter *op = static_cast<vtkTexturePainter *>(vp);

  const int size0 = 6;
  int temp0[6];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetWholeExtent(temp0);
    }
    else
    {
      op->vtkTexturePainter::SetWholeExtent(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkTexturePainter_SetWholeExtent(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 6:
      return PyvtkTexturePainter_SetWholeExtent_s1(self, args);
    case 1:
      return PyvtkTexturePainter_SetWholeExtent_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetWholeExtent");
  return NULL;
}


static PyMethodDef PyvtkTexturePainter_Methods[] = {
  {"IsTypeOf", PyvtkTexturePainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkTexturePainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkTexturePainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkTexturePainter\nC++: static vtkTexturePainter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkTexturePainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTexturePainter\nC++: vtkTexturePainter *NewInstance()\n\n"},
  {"SLICE", PyvtkTexturePainter_SLICE, METH_VARARGS,
   "V.SLICE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *SLICE()\n\nSpecify the X, Y or Z slice to use. The slice mode dictates how\nthe data is slicde.\n"},
  {"SLICE_MODE", PyvtkTexturePainter_SLICE_MODE, METH_VARARGS,
   "V.SLICE_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *SLICE_MODE()\n\nSpecify how the slices are obtained.\n"},
  {"MAP_SCALARS", PyvtkTexturePainter_MAP_SCALARS, METH_VARARGS,
   "V.MAP_SCALARS() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *MAP_SCALARS()\n\nTurn on/off the mapping of color scalars through the lookup\ntable. The default is Off. If Off, unsigned char scalars will be\nused directly as texture. If On, scalars will be mapped through\nthe lookup table to generate 4-component unsigned char scalars.\nThis ivar does not affect other scalars like unsigned short,\nfloat, etc. These scalars are always mapped through lookup\ntables. Look at vtkTexture::MapColorScalarsThroughLookupTable for\nmore details.\n"},
  {"LOOKUP_TABLE", PyvtkTexturePainter_LOOKUP_TABLE, METH_VARARGS,
   "V.LOOKUP_TABLE() -> vtkInformationObjectBaseKey\nC++: static vtkInformationObjectBaseKey *LOOKUP_TABLE()\n\nSet the lookuptable to use for scalar mapping. If none is\nspecified and the scalars are not unsigned char scalars, then a\ndefault lookup table will be created and used.\n"},
  {"SCALAR_MODE", PyvtkTexturePainter_SCALAR_MODE, METH_VARARGS,
   "V.SCALAR_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *SCALAR_MODE()\n\nDetermines the whether the scalars are to be obtained from point\ndata or cell data. Look at the documentation for ScalarMode in\nvtkMapper for the different possible values and their effect.\n"},
  {"SetScalarMode", PyvtkTexturePainter_SetScalarMode, METH_VARARGS,
   "V.SetScalarMode(int)\nC++: virtual void SetScalarMode(int _arg)\n\nDetermines the whether the scalars are to be obtained from point\ndata or cell data. Look at the documentation for ScalarMode in\nvtkMapper for the different possible values and their effect.\n"},
  {"GetScalarMode", PyvtkTexturePainter_GetScalarMode, METH_VARARGS,
   "V.GetScalarMode() -> int\nC++: virtual int GetScalarMode()\n\nDetermines the whether the scalars are to be obtained from point\ndata or cell data. Look at the documentation for ScalarMode in\nvtkMapper for the different possible values and their effect.\n"},
  {"SCALAR_ARRAY_NAME", PyvtkTexturePainter_SCALAR_ARRAY_NAME, METH_VARARGS,
   "V.SCALAR_ARRAY_NAME() -> vtkInformationStringKey\nC++: static vtkInformationStringKey *SCALAR_ARRAY_NAME()\n\nThese three keys help identify the scalar array. If\nSCALAR_ARRAY_NAME is absent or NULL, SCALAR_ARRAY_INDEX is used.\nNOTE: We are deliberately not adding support to select a\ncomponent to color with. That is now a property of the lookup\ntable and ideally must be set on the lookup table.\n"},
  {"SetScalarArrayName", PyvtkTexturePainter_SetScalarArrayName, METH_VARARGS,
   "V.SetScalarArrayName(string)\nC++: virtual void SetScalarArrayName(const char *_arg)\n\nThese three keys help identify the scalar array. If\nSCALAR_ARRAY_NAME is absent or NULL, SCALAR_ARRAY_INDEX is used.\nNOTE: We are deliberately not adding support to select a\ncomponent to color with. That is now a property of the lookup\ntable and ideally must be set on the lookup table.\n"},
  {"GetScalarArrayName", PyvtkTexturePainter_GetScalarArrayName, METH_VARARGS,
   "V.GetScalarArrayName() -> string\nC++: virtual char *GetScalarArrayName()\n\nThese three keys help identify the scalar array. If\nSCALAR_ARRAY_NAME is absent or NULL, SCALAR_ARRAY_INDEX is used.\nNOTE: We are deliberately not adding support to select a\ncomponent to color with. That is now a property of the lookup\ntable and ideally must be set on the lookup table.\n"},
  {"SCALAR_ARRAY_INDEX", PyvtkTexturePainter_SCALAR_ARRAY_INDEX, METH_VARARGS,
   "V.SCALAR_ARRAY_INDEX() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *SCALAR_ARRAY_INDEX()\n\nSepecify the index of the array to color with when scalar array\nname is absent or null.\n"},
  {"SetScalarArrayIndex", PyvtkTexturePainter_SetScalarArrayIndex, METH_VARARGS,
   "V.SetScalarArrayIndex(int)\nC++: virtual void SetScalarArrayIndex(int _arg)\n\nSepecify the index of the array to color with when scalar array\nname is absent or null.\n"},
  {"GetScalarArrayIndex", PyvtkTexturePainter_GetScalarArrayIndex, METH_VARARGS,
   "V.GetScalarArrayIndex() -> int\nC++: virtual int GetScalarArrayIndex()\n\nSepecify the index of the array to color with when scalar array\nname is absent or null.\n"},
  {"SetSlice", PyvtkTexturePainter_SetSlice, METH_VARARGS,
   "V.SetSlice(int)\nC++: virtual void SetSlice(int _arg)\n\nGet/Set the Slice that needs to be rendering. This is applicable\nfor 3D images. If the Slice number is not valid, then the 0th\nslice is rendered.\n"},
  {"GetSlice", PyvtkTexturePainter_GetSlice, METH_VARARGS,
   "V.GetSlice() -> int\nC++: virtual int GetSlice()\n\nGet/Set the Slice that needs to be rendering. This is applicable\nfor 3D images. If the Slice number is not valid, then the 0th\nslice is rendered.\n"},
  {"SetSliceMode", PyvtkTexturePainter_SetSliceMode, METH_VARARGS,
   "V.SetSliceMode(int)\nC++: virtual void SetSliceMode(int _arg)\n\nIndicates the direction in which the slices are made into 3D\ndata. If the input image is 2D, the the entire data is shown.\n"},
  {"GetSliceModeMinValue", PyvtkTexturePainter_GetSliceModeMinValue, METH_VARARGS,
   "V.GetSliceModeMinValue() -> int\nC++: virtual int GetSliceModeMinValue()\n\nIndicates the direction in which the slices are made into 3D\ndata. If the input image is 2D, the the entire data is shown.\n"},
  {"GetSliceModeMaxValue", PyvtkTexturePainter_GetSliceModeMaxValue, METH_VARARGS,
   "V.GetSliceModeMaxValue() -> int\nC++: virtual int GetSliceModeMaxValue()\n\nIndicates the direction in which the slices are made into 3D\ndata. If the input image is 2D, the the entire data is shown.\n"},
  {"GetSliceMode", PyvtkTexturePainter_GetSliceMode, METH_VARARGS,
   "V.GetSliceMode() -> int\nC++: virtual int GetSliceMode()\n\nIndicates the direction in which the slices are made into 3D\ndata. If the input image is 2D, the the entire data is shown.\n"},
  {"SetLookupTable", PyvtkTexturePainter_SetLookupTable, METH_VARARGS,
   "V.SetLookupTable(vtkScalarsToColors)\nC++: void SetLookupTable(vtkScalarsToColors *)\n\nSet the lookuptable to use.\n"},
  {"SetMapScalars", PyvtkTexturePainter_SetMapScalars, METH_VARARGS,
   "V.SetMapScalars(int)\nC++: virtual void SetMapScalars(int _arg)\n\nSet if LUT must be used when scalars in the image can be directly\nused as colors. Look at\nvtkTexture::MapColorScalarsThroughLookupTable for more details.\n"},
  {"GetMapScalars", PyvtkTexturePainter_GetMapScalars, METH_VARARGS,
   "V.GetMapScalars() -> int\nC++: virtual int GetMapScalars()\n\nSet if LUT must be used when scalars in the image can be directly\nused as colors. Look at\nvtkTexture::MapColorScalarsThroughLookupTable for more details.\n"},
  {"USE_XY_PLANE", PyvtkTexturePainter_USE_XY_PLANE, METH_VARARGS,
   "V.USE_XY_PLANE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *USE_XY_PLANE()\n\nWhen set, the image slice is always rendered in the XY plane\n(Z==0) irrespective of the image bounds. Default if Off.\n"},
  {"SetUseXYPlane", PyvtkTexturePainter_SetUseXYPlane, METH_VARARGS,
   "V.SetUseXYPlane(int)\nC++: virtual void SetUseXYPlane(int _arg)\n\nWhen set, the image slice is always rendered in the XY plane\n(Z==0) irrespective of the image bounds. Default if Off.\n"},
  {"GetUseXYPlaneMinValue", PyvtkTexturePainter_GetUseXYPlaneMinValue, METH_VARARGS,
   "V.GetUseXYPlaneMinValue() -> int\nC++: virtual int GetUseXYPlaneMinValue()\n\nWhen set, the image slice is always rendered in the XY plane\n(Z==0) irrespective of the image bounds. Default if Off.\n"},
  {"GetUseXYPlaneMaxValue", PyvtkTexturePainter_GetUseXYPlaneMaxValue, METH_VARARGS,
   "V.GetUseXYPlaneMaxValue() -> int\nC++: virtual int GetUseXYPlaneMaxValue()\n\nWhen set, the image slice is always rendered in the XY plane\n(Z==0) irrespective of the image bounds. Default if Off.\n"},
  {"UseXYPlaneOn", PyvtkTexturePainter_UseXYPlaneOn, METH_VARARGS,
   "V.UseXYPlaneOn()\nC++: virtual void UseXYPlaneOn()\n\nWhen set, the image slice is always rendered in the XY plane\n(Z==0) irrespective of the image bounds. Default if Off.\n"},
  {"UseXYPlaneOff", PyvtkTexturePainter_UseXYPlaneOff, METH_VARARGS,
   "V.UseXYPlaneOff()\nC++: virtual void UseXYPlaneOff()\n\nWhen set, the image slice is always rendered in the XY plane\n(Z==0) irrespective of the image bounds. Default if Off.\n"},
  {"GetUseXYPlane", PyvtkTexturePainter_GetUseXYPlane, METH_VARARGS,
   "V.GetUseXYPlane() -> int\nC++: virtual int GetUseXYPlane()\n\nWhen set, the image slice is always rendered in the XY plane\n(Z==0) irrespective of the image bounds. Default if Off.\n"},
  {"ReleaseGraphicsResources", PyvtkTexturePainter_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: virtual void ReleaseGraphicsResources(vtkWindow *)\n\n"},
  {"SetWholeExtent", PyvtkTexturePainter_SetWholeExtent, METH_VARARGS,
   "V.SetWholeExtent(int, int, int, int, int, int)\nC++: void SetWholeExtent(int, int, int, int, int, int)\nV.SetWholeExtent((int, int, int, int, int, int))\nC++: void SetWholeExtent(int a[6])\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTexturePainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsRenderingPython.vtkTexturePainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTexturePainter_StaticNew()
{
  return vtkTexturePainter::New();
}

PyObject *PyvtkTexturePainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTexturePainter_Type, PyvtkTexturePainter_Methods,
    "vtkTexturePainter",
    PyvtkTexturePainter_Doc(), &PyvtkTexturePainter_StaticNew);

  PyTypeObject *pytype = &PyvtkTexturePainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPainter_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 3; c++)
  {
    static const struct { const char *name; int value; }
      constants[3] = {
        { "YZ_PLANE", vtkTexturePainter::YZ_PLANE },
        { "XZ_PLANE", vtkTexturePainter::XZ_PLANE },
        { "XY_PLANE", vtkTexturePainter::XY_PLANE },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTexturePainter_Doc()
{
  static const char *docstring[] = {
    "vtkTexturePainter - renders a slice of vtkImageData by loading the\nslice as a texture and then applying it to a quad.\n\n",
    "Superclass: vtkPainter\n\n",
    "vtkTexturePainter is a painter for vtkImageData. It can render a\nslice of image data by loading it as an texture and then displaying\nit on a quad. It uses the bounds of the slice to position the quad.\nUnlike other image data algorithms, this painter provides API to\nchoose the scalars to upload. If cell data is used, then cell centers\nare used to position the slice.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTexturePainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTexturePainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTexturePainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

