// python wrapper for vtkUniformVariables
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkUniformVariables.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkUniformVariables(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkUniformVariables_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkUniformVariables_Doc();


static PyObject *
PyvtkUniformVariables_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkUniformVariables::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkUniformVariables::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkUniformVariables *tempr = vtkUniformVariables::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkUniformVariables *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkUniformVariables::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_SetUniformi(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformi");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  char *temp0 = NULL;
  int temp1;
  int size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<int> store2(2*size2);
  int *temp2 = store2.Data();
  int *save2 = (size2 == 0 ? NULL : temp2 + size2);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
  {
    ap.SaveArray(temp2, save2, size2);

    if (ap.IsBound())
    {
      op->SetUniformi(temp0, temp1, temp2);
    }
    else
    {
      op->vtkUniformVariables::SetUniformi(temp0, temp1, temp2);
    }

    if (ap.ArrayHasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_SetUniformf(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformf");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  char *temp0 = NULL;
  int temp1;
  int size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<float> store2(2*size2);
  float *temp2 = store2.Data();
  float *save2 = (size2 == 0 ? NULL : temp2 + size2);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
  {
    ap.SaveArray(temp2, save2, size2);

    if (ap.IsBound())
    {
      op->SetUniformf(temp0, temp1, temp2);
    }
    else
    {
      op->vtkUniformVariables::SetUniformf(temp0, temp1, temp2);
    }

    if (ap.ArrayHasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_SetUniformiv(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformiv");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  char *temp0 = NULL;
  int temp1;
  int temp2;
  int size3 = ap.GetArgSize(3);
  vtkPythonArgs::Array<int> store3(2*size3);
  int *temp3 = store3.Data();
  int *save3 = (size3 == 0 ? NULL : temp3 + size3);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetArray(temp3, size3))
  {
    ap.SaveArray(temp3, save3, size3);

    if (ap.IsBound())
    {
      op->SetUniformiv(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkUniformVariables::SetUniformiv(temp0, temp1, temp2, temp3);
    }

    if (ap.ArrayHasChanged(temp3, save3, size3) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(3, temp3, size3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_SetUniformfv(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformfv");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  char *temp0 = NULL;
  int temp1;
  int temp2;
  int size3 = ap.GetArgSize(3);
  vtkPythonArgs::Array<float> store3(2*size3);
  float *temp3 = store3.Data();
  float *save3 = (size3 == 0 ? NULL : temp3 + size3);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetArray(temp3, size3))
  {
    ap.SaveArray(temp3, save3, size3);

    if (ap.IsBound())
    {
      op->SetUniformfv(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkUniformVariables::SetUniformfv(temp0, temp1, temp2, temp3);
    }

    if (ap.ArrayHasChanged(temp3, save3, size3) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(3, temp3, size3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_SetUniformMatrix(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  char *temp0 = NULL;
  int temp1;
  int temp2;
  int size3 = ap.GetArgSize(3);
  vtkPythonArgs::Array<float> store3(2*size3);
  float *temp3 = store3.Data();
  float *save3 = (size3 == 0 ? NULL : temp3 + size3);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetArray(temp3, size3))
  {
    ap.SaveArray(temp3, save3, size3);

    if (ap.IsBound())
    {
      op->SetUniformMatrix(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkUniformVariables::SetUniformMatrix(temp0, temp1, temp2, temp3);
    }

    if (ap.ArrayHasChanged(temp3, save3, size3) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(3, temp3, size3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_RemoveUniform(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveUniform");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RemoveUniform(temp0);
    }
    else
    {
      op->vtkUniformVariables::RemoveUniform(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_RemoveAllUniforms(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllUniforms");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllUniforms();
    }
    else
    {
      op->vtkUniformVariables::RemoveAllUniforms();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_Send(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Send");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  char *temp0 = NULL;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->Send(temp0, temp1);
    }
    else
    {
      op->vtkUniformVariables::Send(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_Start(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Start");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Start();
    }
    else
    {
      op->vtkUniformVariables::Start();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_IsAtEnd(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsAtEnd");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsAtEnd() :
      op->vtkUniformVariables::IsAtEnd());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_GetCurrentName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurrentName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetCurrentName() :
      op->vtkUniformVariables::GetCurrentName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_SendCurrentUniform(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SendCurrentUniform");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SendCurrentUniform(temp0);
    }
    else
    {
      op->vtkUniformVariables::SendCurrentUniform(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_Next(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Next");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Next();
    }
    else
    {
      op->vtkUniformVariables::Next();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_DeepCopy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DeepCopy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  vtkUniformVariables *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkUniformVariables"))
  {
    if (ap.IsBound())
    {
      op->DeepCopy(temp0);
    }
    else
    {
      op->vtkUniformVariables::DeepCopy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkUniformVariables_Merge(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Merge");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkUniformVariables *op = static_cast<vtkUniformVariables *>(vp);

  vtkUniformVariables *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkUniformVariables"))
  {
    if (ap.IsBound())
    {
      op->Merge(temp0);
    }
    else
    {
      op->vtkUniformVariables::Merge(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkUniformVariables_Methods[] = {
  {"IsTypeOf", PyvtkUniformVariables_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkUniformVariables_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkUniformVariables_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkUniformVariables\nC++: static vtkUniformVariables *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkUniformVariables_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkUniformVariables\nC++: vtkUniformVariables *NewInstance()\n\n"},
  {"SetUniformi", PyvtkUniformVariables_SetUniformi, METH_VARARGS,
   "V.SetUniformi(string, int, [int, ...])\nC++: void SetUniformi(const char *name, int numberOfComponents,\n    int *value)\n\nSet an integer uniform variable.\n\\pre name_exists: name!=0\n\\pre value_exists: value!=0\n\\pre valid_numberOfComponents: numberOfComponents>=1 &&\n    numberOfComponents<=4\n"},
  {"SetUniformf", PyvtkUniformVariables_SetUniformf, METH_VARARGS,
   "V.SetUniformf(string, int, [float, ...])\nC++: void SetUniformf(const char *name, int numberOfComponents,\n    float *value)\n\nSet an float uniform variable.\n\\pre name_exists: name!=0\n\\pre value_exists: value!=0\n\\pre valid_numberOfComponents: numberOfComponents>=1 &&\n    numberOfComponents<=4\n"},
  {"SetUniformiv", PyvtkUniformVariables_SetUniformiv, METH_VARARGS,
   "V.SetUniformiv(string, int, int, [int, ...])\nC++: void SetUniformiv(const char *name, int numberOfComponents,\n    int numberOfElements, int *value)\n\nSet an array of integer uniform variables. The array `value' is of size\n`numberOfElements'*`numberOfComponents.'.\n\\pre name_exists: name!=0\n\\pre value_exists: value!=0\n\\pre valid_numberOfComponents: numberOfComponents>=1 &&\n    numberOfComponents<=4\n\\pre valid_numberOfElements: numberOfElements>=1\n"},
  {"SetUniformfv", PyvtkUniformVariables_SetUniformfv, METH_VARARGS,
   "V.SetUniformfv(string, int, int, [float, ...])\nC++: void SetUniformfv(const char *name, int numberOfComponents,\n    int numberOfElements, float *value)\n\nSet an array of float uniform variables. The array `value' is of size\n`numberOfElements'*`numberOfComponents.'.\n\\pre name_exists: name!=0\n\\pre value_exists: value!=0\n\\pre valid_numberOfComponents: numberOfComponents>=1 &&\n    numberOfComponents<=4\n\\pre valid_numberOfElements: numberOfElements>=1\n"},
  {"SetUniformMatrix", PyvtkUniformVariables_SetUniformMatrix, METH_VARARGS,
   "V.SetUniformMatrix(string, int, int, [float, ...])\nC++: void SetUniformMatrix(const char *name, int rows,\n    int columns, float *value)\n\nSet a matrix uniform variable.\n\\pre name_exists: name!=0\n\\pre value_exists: value!=0\n\\pre valid_rows:  rows>=2 && rows<=4\n\\pre valid_columns: columns>=2 && columns<=4\n"},
  {"RemoveUniform", PyvtkUniformVariables_RemoveUniform, METH_VARARGS,
   "V.RemoveUniform(string)\nC++: void RemoveUniform(const char *name)\n\nRemove uniform `name' from the list.\n"},
  {"RemoveAllUniforms", PyvtkUniformVariables_RemoveAllUniforms, METH_VARARGS,
   "V.RemoveAllUniforms()\nC++: void RemoveAllUniforms()\n\nRemove all uniforms from the list.\n"},
  {"Send", PyvtkUniformVariables_Send, METH_VARARGS,
   "V.Send(string, int)\nC++: void Send(const char *name, int uniformIndex)\n\n\\pre need a valid OpenGL context and a shader program in use.\n"},
  {"Start", PyvtkUniformVariables_Start, METH_VARARGS,
   "V.Start()\nC++: void Start()\n\nPlace the internal cursor on the first uniform.\n"},
  {"IsAtEnd", PyvtkUniformVariables_IsAtEnd, METH_VARARGS,
   "V.IsAtEnd() -> bool\nC++: bool IsAtEnd()\n\nIs the iteration done?\n"},
  {"GetCurrentName", PyvtkUniformVariables_GetCurrentName, METH_VARARGS,
   "V.GetCurrentName() -> string\nC++: const char *GetCurrentName()\n\nName of the uniform at the current cursor position.\n\\pre not_done: !this->IsAtEnd()\n"},
  {"SendCurrentUniform", PyvtkUniformVariables_SendCurrentUniform, METH_VARARGS,
   "V.SendCurrentUniform(int)\nC++: void SendCurrentUniform(int uniformIndex)\n\n\\pre need a valid OpenGL context and a shader program in use.\n\\pre not_done: !this->IsAtEnd()\n"},
  {"Next", PyvtkUniformVariables_Next, METH_VARARGS,
   "V.Next()\nC++: void Next()\n\nMove the cursor to the next uniform.\n\\pre not_done: !this->IsAtEnd()\n"},
  {"DeepCopy", PyvtkUniformVariables_DeepCopy, METH_VARARGS,
   "V.DeepCopy(vtkUniformVariables)\nC++: void DeepCopy(vtkUniformVariables *other)\n\nCopy all the variables from `other'. Any existing variable will\nbe deleted first.\n\\pre other_exists: other!=0\n\\pre not_self: other!=this\n"},
  {"Merge", PyvtkUniformVariables_Merge, METH_VARARGS,
   "V.Merge(vtkUniformVariables)\nC++: void Merge(vtkUniformVariables *other)\n\nCopy all the variables from `other'. Any existing variable will\nbe overwritten.\n\\pre other_exists: other!=0\n\\pre not_self: other!=this\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkUniformVariables_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkUniformVariables", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkUniformVariables_StaticNew()
{
  return vtkUniformVariables::New();
}

PyObject *PyvtkUniformVariables_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkUniformVariables_Type, PyvtkUniformVariables_Methods,
    "vtkUniformVariables",
    PyvtkUniformVariables_Doc(), &PyvtkUniformVariables_StaticNew);

  PyTypeObject *pytype = &PyvtkUniformVariables_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkUniformVariables_Doc()
{
  static const char *docstring[] = {
    "vtkUniformVariables - GLSL uniform variables\n\n",
    "Superclass: vtkObject\n\n",
    "vtkUniformVariables is a list of uniform variables attached to either\na vtkShader2 object or to a vtkShaderProgram2. Uniform variables on a\nvtkShaderProgram2 override values of uniform variables on a\nvtkShader2.\n\n@sa\nvtkShader2 vtkShaderProgram2\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkUniformVariables(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkUniformVariables_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkUniformVariables", o) != 0)
  {
    Py_DECREF(o);
  }

}

