// python wrapper for vtkValuePainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkValuePainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkValuePainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkValuePainter_ClassNew(); }

#ifndef DECLARED_PyvtkStandardPolyDataPainter_ClassNew
extern "C" { PyObject *PyvtkStandardPolyDataPainter_ClassNew(); }
#define DECLARED_PyvtkStandardPolyDataPainter_ClassNew
#endif

static const char **PyvtkValuePainter_Doc();


static PyObject *
PyvtkValuePainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkValuePainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePainter *op = static_cast<vtkValuePainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkValuePainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkValuePainter *tempr = vtkValuePainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePainter *op = static_cast<vtkValuePainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkValuePainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkValuePainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkValuePainter_SetInputArrayToProcess_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputArrayToProcess");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePainter *op = static_cast<vtkValuePainter *>(vp);

  int temp0;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetInputArrayToProcess(temp0, temp1);
    }
    else
    {
      op->vtkValuePainter::SetInputArrayToProcess(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkValuePainter_SetInputArrayToProcess_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputArrayToProcess");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePainter *op = static_cast<vtkValuePainter *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetInputArrayToProcess(temp0, temp1);
    }
    else
    {
      op->vtkValuePainter::SetInputArrayToProcess(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkValuePainter_SetInputArrayToProcess_Methods[] = {
  {NULL, PyvtkValuePainter_SetInputArrayToProcess_s1, METH_VARARGS,
   "@iz"},
  {NULL, PyvtkValuePainter_SetInputArrayToProcess_s2, METH_VARARGS,
   "@ii"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkValuePainter_SetInputArrayToProcess(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkValuePainter_SetInputArrayToProcess_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetInputArrayToProcess");
  return NULL;
}



static PyObject *
PyvtkValuePainter_SetInputComponentToProcess(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInputComponentToProcess");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePainter *op = static_cast<vtkValuePainter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetInputComponentToProcess(temp0);
    }
    else
    {
      op->vtkValuePainter::SetInputComponentToProcess(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkValuePainter_SetScalarRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalarRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkValuePainter *op = static_cast<vtkValuePainter *>(vp);

  double temp0;
  double temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetScalarRange(temp0, temp1);
    }
    else
    {
      op->vtkValuePainter::SetScalarRange(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkValuePainter_SCALAR_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALAR_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkValuePainter::SCALAR_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePainter_SCALAR_RANGE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALAR_RANGE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationDoubleVectorKey *tempr = vtkValuePainter::SCALAR_RANGE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePainter_ARRAY_ID(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ARRAY_ID");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkValuePainter::ARRAY_ID();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePainter_ARRAY_NAME(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ARRAY_NAME");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationStringKey *tempr = vtkValuePainter::ARRAY_NAME();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePainter_ARRAY_COMPONENT(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ARRAY_COMPONENT");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkValuePainter::ARRAY_COMPONENT();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkValuePainter_ValueToColor(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ValueToColor");

  double temp0;
  double temp1;
  double temp2;
  int size3 = ap.GetArgSize(3);
  vtkPythonArgs::Array<unsigned char> store3(2*size3);
  unsigned char *temp3 = store3.Data();
  unsigned char *save3 = (size3 == 0 ? NULL : temp3 + size3);
  PyObject *result = NULL;

  if (ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetArray(temp3, size3))
  {
    ap.SaveArray(temp3, save3, size3);

    vtkValuePainter::ValueToColor(temp0, temp1, temp2, temp3);

    if (ap.ArrayHasChanged(temp3, save3, size3) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(3, temp3, size3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkValuePainter_ColorToValue(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ColorToValue");

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<unsigned char> store0(2*size0);
  unsigned char *temp0 = store0.Data();
  unsigned char *save0 = (size0 == 0 ? NULL : temp0 + size0);
  double temp1;
  double temp2;
  double temp3;
  PyObject *result = NULL;

  if (ap.CheckArgCount(4) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    ap.SaveArray(temp0, save0, size0);

    vtkValuePainter::ColorToValue(temp0, temp1, temp2, temp3);

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(3, temp3);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkValuePainter_Methods[] = {
  {"IsTypeOf", PyvtkValuePainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkValuePainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkValuePainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkValuePainter\nC++: static vtkValuePainter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkValuePainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkValuePainter\nC++: vtkValuePainter *NewInstance()\n\n"},
  {"SetInputArrayToProcess", PyvtkValuePainter_SetInputArrayToProcess, METH_VARARGS,
   "V.SetInputArrayToProcess(int, string)\nC++: void SetInputArrayToProcess(int fieldAssociation,\n    const char *name)\nV.SetInputArrayToProcess(int, int)\nC++: void SetInputArrayToProcess(int fieldAssociation,\n    int fieldAttributeType)\n\nSet the array to be drawn. By default point scalars are used.\nArguments are same as those passed to\nvtkAlgorithm::SetInputArrayToProcess except the first 3 arguments\ni.e. idx, port, connection.\n"},
  {"SetInputComponentToProcess", PyvtkValuePainter_SetInputComponentToProcess, METH_VARARGS,
   "V.SetInputComponentToProcess(int)\nC++: void SetInputComponentToProcess(int comp)\n\nSet the component (0..numcomponents-1) of the specified array to\nbe drawn. If input array is not a multicomponent array or\ncomponent is otherwise out of range the painter uses the 0'th\ncomponent instead.\n"},
  {"SetScalarRange", PyvtkValuePainter_SetScalarRange, METH_VARARGS,
   "V.SetScalarRange(float, float)\nC++: void SetScalarRange(double min, double max)\n\nUse the provided scalar range instead of the range of the input\ndata array.\n"},
  {"SCALAR_MODE", PyvtkValuePainter_SCALAR_MODE, METH_VARARGS,
   "V.SCALAR_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *SCALAR_MODE()\n\nOptionally passed down from RenderPass pipeline to controls what\ndata array to draw.\n"},
  {"SCALAR_RANGE", PyvtkValuePainter_SCALAR_RANGE, METH_VARARGS,
   "V.SCALAR_RANGE() -> vtkInformationDoubleVectorKey\nC++: static vtkInformationDoubleVectorKey *SCALAR_RANGE()\n\nOptionally passed down from RenderPass pipeline to controls what\ndata array to draw.\n"},
  {"ARRAY_ID", PyvtkValuePainter_ARRAY_ID, METH_VARARGS,
   "V.ARRAY_ID() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *ARRAY_ID()\n\nOptionally passed down from RenderPass pipeline to controls what\ndata array to draw.\n"},
  {"ARRAY_NAME", PyvtkValuePainter_ARRAY_NAME, METH_VARARGS,
   "V.ARRAY_NAME() -> vtkInformationStringKey\nC++: static vtkInformationStringKey *ARRAY_NAME()\n\nOptionally passed down from RenderPass pipeline to controls what\ndata array to draw.\n"},
  {"ARRAY_COMPONENT", PyvtkValuePainter_ARRAY_COMPONENT, METH_VARARGS,
   "V.ARRAY_COMPONENT() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *ARRAY_COMPONENT()\n\nOptionally passed down from RenderPass pipeline to controls what\ndata array to draw.\n"},
  {"ValueToColor", PyvtkValuePainter_ValueToColor, METH_VARARGS,
   "V.ValueToColor(float, float, float, [int, ...])\nC++: static void ValueToColor(double value, double min,\n    double scale, unsigned char *color)\n\nInternal convenience method to convert a value to a color TODO:\nmake this templated and programmable\n"},
  {"ColorToValue", PyvtkValuePainter_ColorToValue, METH_VARARGS,
   "V.ColorToValue([int, ...], float, float, float)\nC++: static void ColorToValue(unsigned char *color, double min,\n    double scale, double &value)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkValuePainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkValuePainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkValuePainter_StaticNew()
{
  return vtkValuePainter::New();
}

PyObject *PyvtkValuePainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkValuePainter_Type, PyvtkValuePainter_Methods,
    "vtkValuePainter",
    PyvtkValuePainter_Doc(), &PyvtkValuePainter_StaticNew);

  PyTypeObject *pytype = &PyvtkValuePainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkStandardPolyDataPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkValuePainter_Doc()
{
  static const char *docstring[] = {
    "vtkValuePainter - painter that renders arrays encoded into pixel\ncolors.\n\n",
    "Superclass: vtkStandardPolyDataPainter\n\n",
    "vtkValuePainter renders polygonal geometry where data values are\nencoded into 24 bit integers and send to the screen. The pixel colors\ncan then be read and converted back into values later.\n\n@sa\nvtkValuePass, vtkValuePasses\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkValuePainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkValuePainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkValuePainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

