// python wrapper for vtkVolumeTextureMapper2D
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkVolumeTextureMapper2D.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkVolumeTextureMapper2D(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkVolumeTextureMapper2D_ClassNew(); }

#ifndef DECLARED_PyvtkVolumeTextureMapper_ClassNew
extern "C" { PyObject *PyvtkVolumeTextureMapper_ClassNew(); }
#define DECLARED_PyvtkVolumeTextureMapper_ClassNew
#endif

static const char **PyvtkVolumeTextureMapper2D_Doc();


static PyObject *
PyvtkVolumeTextureMapper2D_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkVolumeTextureMapper2D::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkVolumeTextureMapper2D::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkVolumeTextureMapper2D *tempr = vtkVolumeTextureMapper2D::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVolumeTextureMapper2D *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkVolumeTextureMapper2D::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_SetTargetTextureSize_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTargetTextureSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetTargetTextureSize(temp0, temp1);
    }
    else
    {
      op->vtkVolumeTextureMapper2D::SetTargetTextureSize(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkVolumeTextureMapper2D_SetTargetTextureSize_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTargetTextureSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  const int size0 = 2;
  int temp0[2];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetTargetTextureSize(temp0);
    }
    else
    {
      op->vtkVolumeTextureMapper2D::SetTargetTextureSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkVolumeTextureMapper2D_SetTargetTextureSize(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkVolumeTextureMapper2D_SetTargetTextureSize_s1(self, args);
    case 1:
      return PyvtkVolumeTextureMapper2D_SetTargetTextureSize_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetTargetTextureSize");
  return NULL;
}



static PyObject *
PyvtkVolumeTextureMapper2D_GetTargetTextureSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTargetTextureSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetTargetTextureSize() :
      op->vtkVolumeTextureMapper2D::GetTargetTextureSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_SetMaximumNumberOfPlanes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaximumNumberOfPlanes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMaximumNumberOfPlanes(temp0);
    }
    else
    {
      op->vtkVolumeTextureMapper2D::SetMaximumNumberOfPlanes(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_GetMaximumNumberOfPlanes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumNumberOfPlanes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMaximumNumberOfPlanes() :
      op->vtkVolumeTextureMapper2D::GetMaximumNumberOfPlanes());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_SetMaximumStorageSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaximumStorageSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMaximumStorageSize(temp0);
    }
    else
    {
      op->vtkVolumeTextureMapper2D::SetMaximumStorageSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_GetMaximumStorageSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumStorageSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMaximumStorageSize() :
      op->vtkVolumeTextureMapper2D::GetMaximumStorageSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_Render(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Render");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  vtkRenderer *temp0 = NULL;
  vtkVolume *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkRenderer") &&
      ap.GetVTKObject(temp1, "vtkVolume"))
  {
    if (ap.IsBound())
    {
      op->Render(temp0, temp1);
    }
    else
    {
      op->vtkVolumeTextureMapper2D::Render(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_RenderQuads(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RenderQuads");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  int temp0;
  int size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<float> store1(2*size1);
  float *temp1 = store1.Data();
  float *save1 = (size1 == 0 ? NULL : temp1 + size1);
  int size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<float> store2(2*size2);
  float *temp2 = store2.Data();
  float *save2 = (size2 == 0 ? NULL : temp2 + size2);
  int size3 = ap.GetArgSize(3);
  vtkPythonArgs::Array<unsigned char> store3(2*size3);
  unsigned char *temp3 = store3.Data();
  unsigned char *save3 = (size3 == 0 ? NULL : temp3 + size3);
  const int size4 = 2;
  int temp4[2];
  int save4[2];
  int temp5;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetArray(temp2, size2) &&
      ap.GetArray(temp3, size3) &&
      ap.GetArray(temp4, size4) &&
      ap.GetValue(temp5))
  {
    ap.SaveArray(temp1, save1, size1);
    ap.SaveArray(temp2, save2, size2);
    ap.SaveArray(temp3, save3, size3);
    ap.SaveArray(temp4, save4, size4);

    if (ap.IsBound())
    {
      op->RenderQuads(temp0, temp1, temp2, temp3, temp4, temp5);
    }
    else
    {
      op->vtkVolumeTextureMapper2D::RenderQuads(temp0, temp1, temp2, temp3, temp4, temp5);
    }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (ap.ArrayHasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (ap.ArrayHasChanged(temp3, save3, size3) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(3, temp3, size3);
    }

    if (ap.ArrayHasChanged(temp4, save4, size4) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(4, temp4, size4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_GetInternalSkipFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInternalSkipFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetInternalSkipFactor() :
      op->vtkVolumeTextureMapper2D::GetInternalSkipFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_GetAxisTextureSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAxisTextureSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetAxisTextureSize() :
      op->vtkVolumeTextureMapper2D::GetAxisTextureSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_GetSaveTextures(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSaveTextures");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSaveTextures() :
      op->vtkVolumeTextureMapper2D::GetSaveTextures());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper2D_GetTexture(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTexture");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper2D *op = static_cast<vtkVolumeTextureMapper2D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned char *tempr = (ap.IsBound() ?
      op->GetTexture() :
      op->vtkVolumeTextureMapper2D::GetTexture());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkVolumeTextureMapper2D_Methods[] = {
  {"IsTypeOf", PyvtkVolumeTextureMapper2D_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkVolumeTextureMapper2D_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkVolumeTextureMapper2D_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkVolumeTextureMapper2D\nC++: static vtkVolumeTextureMapper2D *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkVolumeTextureMapper2D_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkVolumeTextureMapper2D\nC++: vtkVolumeTextureMapper2D *NewInstance()\n\n"},
  {"SetTargetTextureSize", PyvtkVolumeTextureMapper2D_SetTargetTextureSize, METH_VARARGS,
   "V.SetTargetTextureSize(int, int)\nC++: void SetTargetTextureSize(int, int)\nV.SetTargetTextureSize((int, int))\nC++: void SetTargetTextureSize(int a[2])\n\n"},
  {"GetTargetTextureSize", PyvtkVolumeTextureMapper2D_GetTargetTextureSize, METH_VARARGS,
   "V.GetTargetTextureSize() -> (int, int)\nC++: int *GetTargetTextureSize()\n\n"},
  {"SetMaximumNumberOfPlanes", PyvtkVolumeTextureMapper2D_SetMaximumNumberOfPlanes, METH_VARARGS,
   "V.SetMaximumNumberOfPlanes(int)\nC++: virtual void SetMaximumNumberOfPlanes(int _arg)\n\nThis is the maximum number of planes that will be created for\ntexture mapping the volume. If the volume has more voxels than\nthis along the viewing direction, then planes of the volume will\nbe skipped to ensure that this maximum is not violated. A skip\nfactor is used, and is incremented until the maximum condition is\nsatisfied.\n"},
  {"GetMaximumNumberOfPlanes", PyvtkVolumeTextureMapper2D_GetMaximumNumberOfPlanes, METH_VARARGS,
   "V.GetMaximumNumberOfPlanes() -> int\nC++: virtual int GetMaximumNumberOfPlanes()\n\nThis is the maximum number of planes that will be created for\ntexture mapping the volume. If the volume has more voxels than\nthis along the viewing direction, then planes of the volume will\nbe skipped to ensure that this maximum is not violated. A skip\nfactor is used, and is incremented until the maximum condition is\nsatisfied.\n"},
  {"SetMaximumStorageSize", PyvtkVolumeTextureMapper2D_SetMaximumStorageSize, METH_VARARGS,
   "V.SetMaximumStorageSize(int)\nC++: virtual void SetMaximumStorageSize(int _arg)\n\nThis is the maximum size of saved textures in bytes. If this size\nis large enough to hold the RGBA textures for all three\ndirections (XxYxZx3x4 is the approximate value - it is actually a\nbit larger due to wasted space in the textures) then the textures\nwill be saved.\n"},
  {"GetMaximumStorageSize", PyvtkVolumeTextureMapper2D_GetMaximumStorageSize, METH_VARARGS,
   "V.GetMaximumStorageSize() -> int\nC++: virtual int GetMaximumStorageSize()\n\nThis is the maximum size of saved textures in bytes. If this size\nis large enough to hold the RGBA textures for all three\ndirections (XxYxZx3x4 is the approximate value - it is actually a\nbit larger due to wasted space in the textures) then the textures\nwill be saved.\n"},
  {"Render", PyvtkVolumeTextureMapper2D_Render, METH_VARARGS,
   "V.Render(vtkRenderer, vtkVolume)\nC++: void Render(vtkRenderer *, vtkVolume *)\n\nWARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT\nUSE THIS METHOD OUTSIDE OF THE RENDERING PROCESS Render the\nvolume\n"},
  {"RenderQuads", PyvtkVolumeTextureMapper2D_RenderQuads, METH_VARARGS,
   "V.RenderQuads(int, [float, ...], [float, ...], [int, ...], [int,\n    int], int)\nC++: virtual void RenderQuads(int count, float *v, float *t,\n    unsigned char *texture, int size[2], int reverseFlag)\n\n"},
  {"GetInternalSkipFactor", PyvtkVolumeTextureMapper2D_GetInternalSkipFactor, METH_VARARGS,
   "V.GetInternalSkipFactor() -> int\nC++: int GetInternalSkipFactor()\n\nMade public only for access from the templated method. Not a\nvtkGetMacro to avoid the PrintSelf defect.\n"},
  {"GetAxisTextureSize", PyvtkVolumeTextureMapper2D_GetAxisTextureSize, METH_VARARGS,
   "V.GetAxisTextureSize() -> (int, ...)\nC++: int *GetAxisTextureSize()\n\n"},
  {"GetSaveTextures", PyvtkVolumeTextureMapper2D_GetSaveTextures, METH_VARARGS,
   "V.GetSaveTextures() -> int\nC++: int GetSaveTextures()\n\n"},
  {"GetTexture", PyvtkVolumeTextureMapper2D_GetTexture, METH_VARARGS,
   "V.GetTexture() -> (int, ...)\nC++: unsigned char *GetTexture()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkVolumeTextureMapper2D_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingVolumePython.vtkVolumeTextureMapper2D", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkVolumeTextureMapper2D_StaticNew()
{
  return vtkVolumeTextureMapper2D::New();
}

PyObject *PyvtkVolumeTextureMapper2D_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkVolumeTextureMapper2D_Type, PyvtkVolumeTextureMapper2D_Methods,
    "vtkVolumeTextureMapper2D",
    PyvtkVolumeTextureMapper2D_Doc(), &PyvtkVolumeTextureMapper2D_StaticNew);

  PyTypeObject *pytype = &PyvtkVolumeTextureMapper2D_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkVolumeTextureMapper_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkVolumeTextureMapper2D_Doc()
{
  static const char *docstring[] = {
    "vtkVolumeTextureMapper2D - Abstract class for a volume mapper\n\n",
    "Superclass: vtkVolumeTextureMapper\n\n",
    "vtkVolumeTextureMapper2D renders a volume using 2D texture mapping.\n\n@sa\nvtkVolumeMapper@deprecated\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkVolumeTextureMapper2D(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkVolumeTextureMapper2D_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkVolumeTextureMapper2D", o) != 0)
  {
    Py_DECREF(o);
  }

}

