// python wrapper for vtkVolumeTextureMapper3D
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkVolumeTextureMapper3D.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkVolumeTextureMapper3D(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkVolumeTextureMapper3D_ClassNew(); }

#ifndef DECLARED_PyvtkVolumeMapper_ClassNew
extern "C" { PyObject *PyvtkVolumeMapper_ClassNew(); }
#define DECLARED_PyvtkVolumeMapper_ClassNew
#endif

static const char **PyvtkVolumeTextureMapper3D_Doc();


static PyObject *
PyvtkVolumeTextureMapper3D_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkVolumeTextureMapper3D::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkVolumeTextureMapper3D::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkVolumeTextureMapper3D *tempr = vtkVolumeTextureMapper3D::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVolumeTextureMapper3D *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkVolumeTextureMapper3D::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_SetSampleDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSampleDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSampleDistance(temp0);
    }
    else
    {
      op->vtkVolumeTextureMapper3D::SetSampleDistance(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_GetSampleDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSampleDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetSampleDistance() :
      op->vtkVolumeTextureMapper3D::GetSampleDistance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_GetVolumeDimensions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVolumeDimensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetVolumeDimensions() :
      op->vtkVolumeTextureMapper3D::GetVolumeDimensions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_GetVolumeSpacing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVolumeSpacing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float *tempr = (ap.IsBound() ?
      op->GetVolumeSpacing() :
      op->vtkVolumeTextureMapper3D::GetVolumeSpacing());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_IsRenderSupported(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsRenderSupported");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  vtkVolumeProperty *temp0 = NULL;
  vtkRenderer *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkVolumeProperty") &&
      ap.GetVTKObject(temp1, "vtkRenderer"))
  {
    int tempr = (ap.IsBound() ?
      op->IsRenderSupported(temp0, temp1) :
      op->vtkVolumeTextureMapper3D::IsRenderSupported(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_GetNumberOfPolygons(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfPolygons");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfPolygons() :
      op->vtkVolumeTextureMapper3D::GetNumberOfPolygons());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_GetActualSampleDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetActualSampleDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetActualSampleDistance() :
      op->vtkVolumeTextureMapper3D::GetActualSampleDistance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_Render(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Render");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  vtkRenderer *temp0 = NULL;
  vtkVolume *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkRenderer") &&
      ap.GetVTKObject(temp1, "vtkVolume"))
  {
    if (ap.IsBound())
    {
      op->Render(temp0, temp1);
    }
    else
    {
      op->vtkVolumeTextureMapper3D::Render(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_GetNumberOfScalarComponents(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfScalarComponents");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  vtkImageData *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageData"))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfScalarComponents(temp0) :
      op->vtkVolumeTextureMapper3D::GetNumberOfScalarComponents(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_SetPreferredRenderMethod(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPreferredRenderMethod");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPreferredRenderMethod(temp0);
    }
    else
    {
      op->vtkVolumeTextureMapper3D::SetPreferredRenderMethod(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_GetPreferredRenderMethodMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPreferredRenderMethodMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPreferredRenderMethodMinValue() :
      op->vtkVolumeTextureMapper3D::GetPreferredRenderMethodMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_GetPreferredRenderMethodMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPreferredRenderMethodMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPreferredRenderMethodMaxValue() :
      op->vtkVolumeTextureMapper3D::GetPreferredRenderMethodMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_SetPreferredMethodToFragmentProgram(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPreferredMethodToFragmentProgram");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetPreferredMethodToFragmentProgram();
    }
    else
    {
      op->vtkVolumeTextureMapper3D::SetPreferredMethodToFragmentProgram();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_SetPreferredMethodToNVidia(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPreferredMethodToNVidia");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetPreferredMethodToNVidia();
    }
    else
    {
      op->vtkVolumeTextureMapper3D::SetPreferredMethodToNVidia();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_GetPreferredRenderMethod(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPreferredRenderMethod");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPreferredRenderMethod() :
      op->vtkVolumeTextureMapper3D::GetPreferredRenderMethod());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_SetUseCompressedTexture(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseCompressedTexture");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseCompressedTexture(temp0);
    }
    else
    {
      op->vtkVolumeTextureMapper3D::SetUseCompressedTexture(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper3D_GetUseCompressedTexture(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseCompressedTexture");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper3D *op = static_cast<vtkVolumeTextureMapper3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseCompressedTexture() :
      op->vtkVolumeTextureMapper3D::GetUseCompressedTexture());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkVolumeTextureMapper3D_Methods[] = {
  {"IsTypeOf", PyvtkVolumeTextureMapper3D_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkVolumeTextureMapper3D_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkVolumeTextureMapper3D_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkVolumeTextureMapper3D\nC++: static vtkVolumeTextureMapper3D *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkVolumeTextureMapper3D_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkVolumeTextureMapper3D\nC++: vtkVolumeTextureMapper3D *NewInstance()\n\n"},
  {"SetSampleDistance", PyvtkVolumeTextureMapper3D_SetSampleDistance, METH_VARARGS,
   "V.SetSampleDistance(float)\nC++: virtual void SetSampleDistance(float _arg)\n\nThe distance at which to space sampling planes. This may not be\nhonored for interactive renders. An interactive render is defined\nas one that has less than 1 second of allocated render time.\n"},
  {"GetSampleDistance", PyvtkVolumeTextureMapper3D_GetSampleDistance, METH_VARARGS,
   "V.GetSampleDistance() -> float\nC++: virtual float GetSampleDistance()\n\nThe distance at which to space sampling planes. This may not be\nhonored for interactive renders. An interactive render is defined\nas one that has less than 1 second of allocated render time.\n"},
  {"GetVolumeDimensions", PyvtkVolumeTextureMapper3D_GetVolumeDimensions, METH_VARARGS,
   "V.GetVolumeDimensions() -> (int, int, int)\nC++: int *GetVolumeDimensions()\n\nThese are the dimensions of the 3D texture\n"},
  {"GetVolumeSpacing", PyvtkVolumeTextureMapper3D_GetVolumeSpacing, METH_VARARGS,
   "V.GetVolumeSpacing() -> (float, float, float)\nC++: float *GetVolumeSpacing()\n\nThis is the spacing of the 3D texture\n"},
  {"IsRenderSupported", PyvtkVolumeTextureMapper3D_IsRenderSupported, METH_VARARGS,
   "V.IsRenderSupported(vtkVolumeProperty, vtkRenderer) -> int\nC++: virtual int IsRenderSupported(vtkVolumeProperty *,\n    vtkRenderer *r)\n\nBased on hardware and properties, we may or may not be able to\nrender using 3D texture mapping. This indicates if 3D texture\nmapping is supported by the hardware, and if the other extensions\nnecessary to support the specific properties are available.\n"},
  {"GetNumberOfPolygons", PyvtkVolumeTextureMapper3D_GetNumberOfPolygons, METH_VARARGS,
   "V.GetNumberOfPolygons() -> int\nC++: virtual int GetNumberOfPolygons()\n\nAllow access to the number of polygons used for the rendering.\n"},
  {"GetActualSampleDistance", PyvtkVolumeTextureMapper3D_GetActualSampleDistance, METH_VARARGS,
   "V.GetActualSampleDistance() -> float\nC++: virtual float GetActualSampleDistance()\n\nAllow access to the actual sample distance used to render the\nimage.\n"},
  {"Render", PyvtkVolumeTextureMapper3D_Render, METH_VARARGS,
   "V.Render(vtkRenderer, vtkVolume)\nC++: void Render(vtkRenderer *, vtkVolume *)\n\nWARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT\nUSE THIS METHOD OUTSIDE OF THE RENDERING PROCESS Render the\nvolume\n"},
  {"GetNumberOfScalarComponents", PyvtkVolumeTextureMapper3D_GetNumberOfScalarComponents, METH_VARARGS,
   "V.GetNumberOfScalarComponents(vtkImageData) -> int\nC++: int GetNumberOfScalarComponents(vtkImageData *input)\n\nReturns the number of components of the point scalar field\n"},
  {"SetPreferredRenderMethod", PyvtkVolumeTextureMapper3D_SetPreferredRenderMethod, METH_VARARGS,
   "V.SetPreferredRenderMethod(int)\nC++: virtual void SetPreferredRenderMethod(int _arg)\n\nSet the preferred render method. If it is supported, this one\nwill be used. Don't allow ATI_METHOD - it is not actually\nsupported.\n"},
  {"GetPreferredRenderMethodMinValue", PyvtkVolumeTextureMapper3D_GetPreferredRenderMethodMinValue, METH_VARARGS,
   "V.GetPreferredRenderMethodMinValue() -> int\nC++: virtual int GetPreferredRenderMethodMinValue()\n\nSet the preferred render method. If it is supported, this one\nwill be used. Don't allow ATI_METHOD - it is not actually\nsupported.\n"},
  {"GetPreferredRenderMethodMaxValue", PyvtkVolumeTextureMapper3D_GetPreferredRenderMethodMaxValue, METH_VARARGS,
   "V.GetPreferredRenderMethodMaxValue() -> int\nC++: virtual int GetPreferredRenderMethodMaxValue()\n\nSet the preferred render method. If it is supported, this one\nwill be used. Don't allow ATI_METHOD - it is not actually\nsupported.\n"},
  {"SetPreferredMethodToFragmentProgram", PyvtkVolumeTextureMapper3D_SetPreferredMethodToFragmentProgram, METH_VARARGS,
   "V.SetPreferredMethodToFragmentProgram()\nC++: void SetPreferredMethodToFragmentProgram()\n\nSet the preferred render method. If it is supported, this one\nwill be used. Don't allow ATI_METHOD - it is not actually\nsupported.\n"},
  {"SetPreferredMethodToNVidia", PyvtkVolumeTextureMapper3D_SetPreferredMethodToNVidia, METH_VARARGS,
   "V.SetPreferredMethodToNVidia()\nC++: void SetPreferredMethodToNVidia()\n\nSet the preferred render method. If it is supported, this one\nwill be used. Don't allow ATI_METHOD - it is not actually\nsupported.\n"},
  {"GetPreferredRenderMethod", PyvtkVolumeTextureMapper3D_GetPreferredRenderMethod, METH_VARARGS,
   "V.GetPreferredRenderMethod() -> int\nC++: virtual int GetPreferredRenderMethod()\n\nSet the preferred render method. If it is supported, this one\nwill be used. Don't allow ATI_METHOD - it is not actually\nsupported.\n"},
  {"SetUseCompressedTexture", PyvtkVolumeTextureMapper3D_SetUseCompressedTexture, METH_VARARGS,
   "V.SetUseCompressedTexture(bool)\nC++: virtual void SetUseCompressedTexture(bool _arg)\n\nSet/Get if the mapper use compressed textures (if supported by\nthe hardware). Initial value is false. There are two reasons to\nuse compressed textures: 1. rendering can be 4 times faster. 2.\nIt saves some VRAM. There is one reason to not use compressed\ntextures: quality may be lower than with uncompressed textures.\n"},
  {"GetUseCompressedTexture", PyvtkVolumeTextureMapper3D_GetUseCompressedTexture, METH_VARARGS,
   "V.GetUseCompressedTexture() -> bool\nC++: virtual bool GetUseCompressedTexture()\n\nSet/Get if the mapper use compressed textures (if supported by\nthe hardware). Initial value is false. There are two reasons to\nuse compressed textures: 1. rendering can be 4 times faster. 2.\nIt saves some VRAM. There is one reason to not use compressed\ntextures: quality may be lower than with uncompressed textures.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkVolumeTextureMapper3D_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingVolumePython.vtkVolumeTextureMapper3D", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkVolumeTextureMapper3D_StaticNew()
{
  return vtkVolumeTextureMapper3D::New();
}

PyObject *PyvtkVolumeTextureMapper3D_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkVolumeTextureMapper3D_Type, PyvtkVolumeTextureMapper3D_Methods,
    "vtkVolumeTextureMapper3D",
    PyvtkVolumeTextureMapper3D_Doc(), &PyvtkVolumeTextureMapper3D_StaticNew);

  PyTypeObject *pytype = &PyvtkVolumeTextureMapper3D_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkVolumeMapper_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 4; c++)
  {
    static const struct { const char *name; int value; }
      constants[4] = {
        { "FRAGMENT_PROGRAM_METHOD", vtkVolumeTextureMapper3D::FRAGMENT_PROGRAM_METHOD },
        { "NVIDIA_METHOD", vtkVolumeTextureMapper3D::NVIDIA_METHOD },
        { "ATI_METHOD", vtkVolumeTextureMapper3D::ATI_METHOD },
        { "NO_METHOD", vtkVolumeTextureMapper3D::NO_METHOD },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkVolumeTextureMapper3D_Doc()
{
  static const char *docstring[] = {
    "vtkVolumeTextureMapper3D - volume render with 3D texture mapping\n\n",
    "Superclass: vtkVolumeMapper\n\n",
    "vtkVolumeTextureMapper3D renders a volume using 3D texture mapping.\nThis class is actually an abstract superclass - with all the actual\nwork done by vtkOpenGLVolumeTextureMapper3D.\n\nThis mappers currently supports:\n\n- any data type as input\n- one component, or two or four non-independent components\n- composite blending\n- intermixed opaque geometry\n- multiple volumes can be rendered if they can be ",
    "sorted into\n  back-to-front order (use the vtkFrustumCoverageCuller)\n\nThis mapper does not support:\n- more than one independent component\n- maximum intensity projection\n\nInternally, this mapper will potentially change the resolution of the\ninput data. The data will be resampled to be a power of two in each\ndirection, and also no greater than 128*256*256 voxels (any aspect)\nfor one or two component",
    " data, or 128*128*256 voxels (any aspect) for\nfour component data. The limits are currently hardcoded after a check\nusing the GL_PROXY_TEXTURE3D because some graphics drivers were\nalways responding \"yes\" to the proxy call despite not being able to\nallocate that much texture memory.\n\nCurrently, calculations are computed using 8 bits per RGBA channel.\nIn the future this should be expanded to handle ",
    "newer boards that can\nsupport 15 bit float compositing.\n\nThis mapper supports two main families of graphics hardware: nvidia\nand ATI. There are two different implementations of 3D texture\nmapping used - one based on nvidia's GL_NV_texture_shader2 and\nGL_NV_register_combiners2 extension, and one based on ATI's\nGL_ATI_fragment_shader (supported also by some nvidia boards) To use\nthis class in an app",
    "lication that will run on various hardware\nconfigurations, you should have a back-up volume rendering method.\nYou should create a vtkVolumeTextureMapper3D, assign its input, make\nsure you have a current OpenGL context (you've rendered at least\nonce), then call IsRenderSupported with a vtkVolumeProperty as an\nargument. This method will return 0 if the input has more than one\nindependent component, ",
    "or if the graphics hardware does not support\nthe set of required extensions for using at least one of the two\nimplemented methods (nvidia or ati)\n\n@par Thanks: Thanks to Alexandre Gouaillard at the Megason Lab,\nDepartment of Systems Biology, Harvard Medical School\nhttps://wiki.med.harvard.edu/SysBio/Megason/ for the idea and initial\npatch to speed-up rendering with compressed textures.\n\n@sa\nvtkVol",
    "umeMapper@deprecated\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkVolumeTextureMapper3D(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkVolumeTextureMapper3D_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkVolumeTextureMapper3D", o) != 0)
  {
    Py_DECREF(o);
  }

}

