// python wrapper for vtkVolumeTextureMapper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkInformationVector.h"
#include "vtkVolumeTextureMapper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkVolumeTextureMapper(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkVolumeTextureMapper_ClassNew(); }

#ifndef DECLARED_PyvtkVolumeMapper_ClassNew
extern "C" { PyObject *PyvtkVolumeMapper_ClassNew(); }
#define DECLARED_PyvtkVolumeMapper_ClassNew
#endif

static const char **PyvtkVolumeTextureMapper_Doc();


static PyObject *
PyvtkVolumeTextureMapper_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkVolumeTextureMapper::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkVolumeTextureMapper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkVolumeTextureMapper *tempr = vtkVolumeTextureMapper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVolumeTextureMapper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkVolumeTextureMapper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_SetGradientEstimator(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGradientEstimator");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  vtkEncodedGradientEstimator *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkEncodedGradientEstimator"))
  {
    if (ap.IsBound())
    {
      op->SetGradientEstimator(temp0);
    }
    else
    {
      op->vtkVolumeTextureMapper::SetGradientEstimator(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetGradientEstimator(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGradientEstimator");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkEncodedGradientEstimator *tempr = (ap.IsBound() ?
      op->GetGradientEstimator() :
      op->vtkVolumeTextureMapper::GetGradientEstimator());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetGradientShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGradientShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkEncodedGradientShader *tempr = (ap.IsBound() ?
      op->GetGradientShader() :
      op->vtkVolumeTextureMapper::GetGradientShader());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetGradientOpacityArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGradientOpacityArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float *tempr = (ap.IsBound() ?
      op->GetGradientOpacityArray() :
      op->vtkVolumeTextureMapper::GetGradientOpacityArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetRGBAArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRGBAArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned char *tempr = (ap.IsBound() ?
      op->GetRGBAArray() :
      op->vtkVolumeTextureMapper::GetRGBAArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetRedDiffuseShadingTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRedDiffuseShadingTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float *tempr = (ap.IsBound() ?
      op->GetRedDiffuseShadingTable() :
      op->vtkVolumeTextureMapper::GetRedDiffuseShadingTable());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetGreenDiffuseShadingTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGreenDiffuseShadingTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float *tempr = (ap.IsBound() ?
      op->GetGreenDiffuseShadingTable() :
      op->vtkVolumeTextureMapper::GetGreenDiffuseShadingTable());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetBlueDiffuseShadingTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBlueDiffuseShadingTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float *tempr = (ap.IsBound() ?
      op->GetBlueDiffuseShadingTable() :
      op->vtkVolumeTextureMapper::GetBlueDiffuseShadingTable());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetRedSpecularShadingTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRedSpecularShadingTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float *tempr = (ap.IsBound() ?
      op->GetRedSpecularShadingTable() :
      op->vtkVolumeTextureMapper::GetRedSpecularShadingTable());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetGreenSpecularShadingTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGreenSpecularShadingTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float *tempr = (ap.IsBound() ?
      op->GetGreenSpecularShadingTable() :
      op->vtkVolumeTextureMapper::GetGreenSpecularShadingTable());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetBlueSpecularShadingTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBlueSpecularShadingTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float *tempr = (ap.IsBound() ?
      op->GetBlueSpecularShadingTable() :
      op->vtkVolumeTextureMapper::GetBlueSpecularShadingTable());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetEncodedNormals(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEncodedNormals");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned short *tempr = (ap.IsBound() ?
      op->GetEncodedNormals() :
      op->vtkVolumeTextureMapper::GetEncodedNormals());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetGradientMagnitudes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGradientMagnitudes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned char *tempr = (ap.IsBound() ?
      op->GetGradientMagnitudes() :
      op->vtkVolumeTextureMapper::GetGradientMagnitudes());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetShade(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShade");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetShade() :
      op->vtkVolumeTextureMapper::GetShade());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetRenderWindow(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRenderWindow");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderWindow *tempr = (ap.IsBound() ?
      op->GetRenderWindow() :
      op->vtkVolumeTextureMapper::GetRenderWindow());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetDataOrigin(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataOrigin");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetDataOrigin() :
      op->vtkVolumeTextureMapper::GetDataOrigin());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetDataSpacing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataSpacing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetDataSpacing() :
      op->vtkVolumeTextureMapper::GetDataSpacing());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_Render(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Render");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  vtkRenderer *temp0 = NULL;
  vtkVolume *temp1 = NULL;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkRenderer") &&
      ap.GetVTKObject(temp1, "vtkVolume"))
  {
    op->Render(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeTextureMapper_GetGradientMagnitudeScale_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGradientMagnitudeScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetGradientMagnitudeScale() :
      op->vtkVolumeTextureMapper::GetGradientMagnitudeScale());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkVolumeTextureMapper_GetGradientMagnitudeScale_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGradientMagnitudeScale");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    float tempr = (ap.IsBound() ?
      op->GetGradientMagnitudeScale(temp0) :
      op->vtkVolumeTextureMapper::GetGradientMagnitudeScale(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkVolumeTextureMapper_GetGradientMagnitudeScale(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 0:
      return PyvtkVolumeTextureMapper_GetGradientMagnitudeScale_s1(self, args);
    case 1:
      return PyvtkVolumeTextureMapper_GetGradientMagnitudeScale_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetGradientMagnitudeScale");
  return NULL;
}



static PyObject *
PyvtkVolumeTextureMapper_GetGradientMagnitudeBias_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGradientMagnitudeBias");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetGradientMagnitudeBias() :
      op->vtkVolumeTextureMapper::GetGradientMagnitudeBias());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkVolumeTextureMapper_GetGradientMagnitudeBias_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGradientMagnitudeBias");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeTextureMapper *op = static_cast<vtkVolumeTextureMapper *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    float tempr = (ap.IsBound() ?
      op->GetGradientMagnitudeBias(temp0) :
      op->vtkVolumeTextureMapper::GetGradientMagnitudeBias(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkVolumeTextureMapper_GetGradientMagnitudeBias(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 0:
      return PyvtkVolumeTextureMapper_GetGradientMagnitudeBias_s1(self, args);
    case 1:
      return PyvtkVolumeTextureMapper_GetGradientMagnitudeBias_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetGradientMagnitudeBias");
  return NULL;
}


static PyMethodDef PyvtkVolumeTextureMapper_Methods[] = {
  {"IsTypeOf", PyvtkVolumeTextureMapper_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkVolumeTextureMapper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkVolumeTextureMapper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkVolumeTextureMapper\nC++: static vtkVolumeTextureMapper *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkVolumeTextureMapper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkVolumeTextureMapper\nC++: vtkVolumeTextureMapper *NewInstance()\n\n"},
  {"SetGradientEstimator", PyvtkVolumeTextureMapper_SetGradientEstimator, METH_VARARGS,
   "V.SetGradientEstimator(vtkEncodedGradientEstimator)\nC++: virtual void SetGradientEstimator(\n    vtkEncodedGradientEstimator *gradest)\n\nSet / Get the gradient estimator used to estimate normals\n"},
  {"GetGradientEstimator", PyvtkVolumeTextureMapper_GetGradientEstimator, METH_VARARGS,
   "V.GetGradientEstimator() -> vtkEncodedGradientEstimator\nC++: virtual vtkEncodedGradientEstimator *GetGradientEstimator()\n\nSet / Get the gradient estimator used to estimate normals\n"},
  {"GetGradientShader", PyvtkVolumeTextureMapper_GetGradientShader, METH_VARARGS,
   "V.GetGradientShader() -> vtkEncodedGradientShader\nC++: virtual vtkEncodedGradientShader *GetGradientShader()\n\nGet the gradient shader.\n"},
  {"GetGradientOpacityArray", PyvtkVolumeTextureMapper_GetGradientOpacityArray, METH_VARARGS,
   "V.GetGradientOpacityArray() -> (float, ...)\nC++: float *GetGradientOpacityArray()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetRGBAArray", PyvtkVolumeTextureMapper_GetRGBAArray, METH_VARARGS,
   "V.GetRGBAArray() -> (int, ...)\nC++: unsigned char *GetRGBAArray()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetRedDiffuseShadingTable", PyvtkVolumeTextureMapper_GetRedDiffuseShadingTable, METH_VARARGS,
   "V.GetRedDiffuseShadingTable() -> (float, ...)\nC++: float *GetRedDiffuseShadingTable()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetGreenDiffuseShadingTable", PyvtkVolumeTextureMapper_GetGreenDiffuseShadingTable, METH_VARARGS,
   "V.GetGreenDiffuseShadingTable() -> (float, ...)\nC++: float *GetGreenDiffuseShadingTable()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetBlueDiffuseShadingTable", PyvtkVolumeTextureMapper_GetBlueDiffuseShadingTable, METH_VARARGS,
   "V.GetBlueDiffuseShadingTable() -> (float, ...)\nC++: float *GetBlueDiffuseShadingTable()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetRedSpecularShadingTable", PyvtkVolumeTextureMapper_GetRedSpecularShadingTable, METH_VARARGS,
   "V.GetRedSpecularShadingTable() -> (float, ...)\nC++: float *GetRedSpecularShadingTable()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetGreenSpecularShadingTable", PyvtkVolumeTextureMapper_GetGreenSpecularShadingTable, METH_VARARGS,
   "V.GetGreenSpecularShadingTable() -> (float, ...)\nC++: float *GetGreenSpecularShadingTable()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetBlueSpecularShadingTable", PyvtkVolumeTextureMapper_GetBlueSpecularShadingTable, METH_VARARGS,
   "V.GetBlueSpecularShadingTable() -> (float, ...)\nC++: float *GetBlueSpecularShadingTable()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetEncodedNormals", PyvtkVolumeTextureMapper_GetEncodedNormals, METH_VARARGS,
   "V.GetEncodedNormals() -> (int, ...)\nC++: unsigned short *GetEncodedNormals()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetGradientMagnitudes", PyvtkVolumeTextureMapper_GetGradientMagnitudes, METH_VARARGS,
   "V.GetGradientMagnitudes() -> (int, ...)\nC++: unsigned char *GetGradientMagnitudes()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetShade", PyvtkVolumeTextureMapper_GetShade, METH_VARARGS,
   "V.GetShade() -> int\nC++: virtual int GetShade()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetRenderWindow", PyvtkVolumeTextureMapper_GetRenderWindow, METH_VARARGS,
   "V.GetRenderWindow() -> vtkRenderWindow\nC++: virtual vtkRenderWindow *GetRenderWindow()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetDataOrigin", PyvtkVolumeTextureMapper_GetDataOrigin, METH_VARARGS,
   "V.GetDataOrigin() -> (float, float, float)\nC++: double *GetDataOrigin()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"GetDataSpacing", PyvtkVolumeTextureMapper_GetDataSpacing, METH_VARARGS,
   "V.GetDataSpacing() -> (float, float, float)\nC++: double *GetDataSpacing()\n\nAllow access to the arrays / variables from the templated\nfunctions in the subclasses.\n"},
  {"Render", PyvtkVolumeTextureMapper_Render, METH_VARARGS,
   "V.Render(vtkRenderer, vtkVolume)\nC++: void Render(vtkRenderer *ren, vtkVolume *vol)\n\nWARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT\nUSE THIS METHOD OUTSIDE OF THE RENDERING PROCESS Render the\nvolume\n"},
  {"GetGradientMagnitudeScale", PyvtkVolumeTextureMapper_GetGradientMagnitudeScale, METH_VARARGS,
   "V.GetGradientMagnitudeScale() -> float\nC++: float GetGradientMagnitudeScale()\nV.GetGradientMagnitudeScale(int) -> float\nC++: float GetGradientMagnitudeScale(int)\n\nWARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE Values\nneeded by the volume\n"},
  {"GetGradientMagnitudeBias", PyvtkVolumeTextureMapper_GetGradientMagnitudeBias, METH_VARARGS,
   "V.GetGradientMagnitudeBias() -> float\nC++: float GetGradientMagnitudeBias()\nV.GetGradientMagnitudeBias(int) -> float\nC++: float GetGradientMagnitudeBias(int)\n\nWARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE Values\nneeded by the volume\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkVolumeTextureMapper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingVolumePython.vtkVolumeTextureMapper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkVolumeTextureMapper_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkVolumeTextureMapper_Type, PyvtkVolumeTextureMapper_Methods,
    "vtkVolumeTextureMapper",
    PyvtkVolumeTextureMapper_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkVolumeTextureMapper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkVolumeMapper_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkVolumeTextureMapper_Doc()
{
  static const char *docstring[] = {
    "vtkVolumeTextureMapper - Abstract class for a volume mapper\n\n",
    "Superclass: vtkVolumeMapper\n\n",
    "vtkVolumeTextureMapper is the abstract definition of a volume mapper\nthat uses a texture mapping approach.\n\n@sa\nvtkVolumeMapper\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkVolumeTextureMapper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkVolumeTextureMapper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkVolumeTextureMapper", o) != 0)
  {
    Py_DECREF(o);
  }

}

