// Loadable modules
//
// Generated by ../../bin/vtkkwProcessXML
//
#ifndef __vtkSMXML_UncertaintyRendering_h
#define __vtkSMXML_UncertaintyRendering_h

#include <string.h>


// From file /builddir/build/BUILD/ParaView-v5.4.1/Plugins/UncertaintyRendering/vtkUncertaintyRendering.xml
static const char* const UncertaintyRenderingvtkUncertaintyRenderingInterfaces0 =
"<ServerManagerConfiguration>\n"
"  <ProxyGroup name=\"representations\">\n"
"    <RepresentationProxy name=\"UncertaintySurfaceRepresentation\"\n"
"                                           class=\"vtkUncertaintySurfaceRepresentation\"\n"
"                                           processes=\"client|dataserver|renderserver\"\n"
"                                           base_proxygroup=\"internal_representations\"\n"
"                                           base_proxyname=\"SurfaceRepresentationBase\" >\n"
"      <Documentation>\n"
"        Representation proxy for uncertainty surface rendering.\n"
"      </Documentation>\n"
"\n"
"      <InputProperty command=\"SetInputConnection\"\n"
"                     name=\"Input\">\n"
"        <DataTypeDomain name=\"input_type\">\n"
"          <DataType value=\"vtkDataObject\" />\n"
"        </DataTypeDomain>\n"
"        <InputArrayDomain attribute_type=\"point\"\n"
"                          name=\"input_array\"/>\n"
"        <Documentation>Data input for the representation.</Documentation>\n"
"      </InputProperty>\n"
"\n"
"      <StringVectorProperty name=\"SelectUncertaintyArray\"\n"
"                            command=\"SelectUncertaintyArray\"\n"
"                            element_types=\"0 0 0 0 2\"\n"
"                            number_of_elements=\"5\"\n"
"                            label=\"Uncertainty Array\"\n"
"                            panel_visibility=\"advanced\"\n"
"                            panel_visibility_default_for_representation=\"Uncertainty Surface\">\n"
"        <ArrayListDomain name=\"array_list\"\n"
"                         input_domain_name=\"input_array\">\n"
"          <RequiredProperties>\n"
"            <Property name=\"Input\" function=\"Input\"/>\n"
"          </RequiredProperties>\n"
"        </ArrayListDomain>\n"
"\n"
"        <Documentation>\n"
"          This property specifies the name of the uncertainty array.\n"
"        </Documentation>\n"
"      </StringVectorProperty>\n"
"\n"
"      <DoubleVectorProperty name=\"UncertaintyScaleFactor\"\n"
"                            command=\"SetUncertaintyScaleFactor\"\n"
"                            default_values=\"1.0\"\n"
"                            number_of_elements=\"1\"\n"
"                            label=\"Uncertainty Scale Factor\">\n"
"        <DoubleRangeDomain name=\"range\" min=\"0\" max=\"10\"/>\n"
"        <Documentation>\n"
"          This property sets the uncertainty scale factor.\n"
"        </Documentation>\n"
"      </DoubleVectorProperty>\n"
"\n"
"      <ProxyProperty name=\"UncertaintyTransferFunction\"\n"
"                     command=\"SetUncertaintyTransferFunction\"\n"
"                     label=\"Uncertainty Transfer Function\"\n"
"                     panel_widget=\"transfer_function_editor\">\n"
"       <ProxyListDomain name=\"proxy_list\">\n"
"         <Proxy group=\"piecewise_functions\" name=\"PiecewiseFunction\" />\n"
"       </ProxyListDomain>\n"
"        <Documentation>\n"
"          Sets the transfer function used to map scalars to uncertainty values.\n"
"        </Documentation>\n"
"      </ProxyProperty>\n"
"    </RepresentationProxy>\n"
"  </ProxyGroup>\n"
"</ServerManagerConfiguration>\n"
"\n";
// Get single string
char* UncertaintyRenderingvtkUncertaintyRenderingInterfaces()
{
  size_t len = ( 0
    + strlen(UncertaintyRenderingvtkUncertaintyRenderingInterfaces0) );
  char* res = new char[ len + 1];
  res[0] = 0;
  strncat(res, UncertaintyRenderingvtkUncertaintyRenderingInterfaces0, len + 1 - strlen(res));
  return res;
}


// From file /builddir/build/BUILD/ParaView-v5.4.1/Plugins/UncertaintyRendering/vtkUncertaintyRenderingExtension.xml
static const char* const UncertaintyRenderingvtkUncertaintyRenderingExtensionInterfaces0 =
"<ServerManagerConfiguration>\n"
"  <ProxyGroup name=\"representations\">\n"
"    <Extension name=\"GeometryRepresentation\">\n"
"      <RepresentationType subproxy=\"UncertaintySurfaceRepresentation\"\n"
"                          text=\"Uncertainty Surface\"\n"
"                          subtype=\"Surface\" />\n"
"\n"
"      <SubProxy>\n"
"        <Proxy name=\"UncertaintySurfaceRepresentation\"\n"
"               proxygroup=\"representations\"\n"
"               proxyname=\"UncertaintySurfaceRepresentation\" />\n"
"\n"
"        <ShareProperties subproxy=\"SurfaceRepresentation\">\n"
"          <Exception name=\"Input\" />\n"
"          <Exception name=\"Visibility\" />\n"
"        </ShareProperties>\n"
"\n"
"        <ExposedProperties>\n"
"          <Property name=\"SelectUncertaintyArray\"  exposed_name=\"SelectUncertaintyArray\"/>\n"
"          <Property name=\"UncertaintyTransferFunction\" exposed_name=\"UncertaintyTransferFunction\"/>\n"
"          <Property name=\"UncertaintyScaleFactor\" exposed_name=\"UncertaintyUncertaintyScaleFactor\"/>\n"
"        </ExposedProperties>\n"
"      </SubProxy>\n"
"    </Extension>\n"
"\n"
"    <Extension name=\"UnstructuredGridRepresentation\">\n"
"      <RepresentationType subproxy=\"UncertaintySurfaceRepresentation\"\n"
"                          text=\"Uncertainty Surface\"\n"
"                          subtype=\"Surface\" />\n"
"      <SubProxy>\n"
"        <Proxy name=\"UncertaintySurfaceRepresentation\"\n"
"               proxygroup=\"representations\"\n"
"               proxyname=\"UncertaintySurfaceRepresentation\" />\n"
"\n"
"        <ShareProperties subproxy=\"SurfaceRepresentation\">\n"
"          <Exception name=\"Input\" />\n"
"          <Exception name=\"Visibility\" />\n"
"        </ShareProperties>\n"
"\n"
"        <ExposedProperties>\n"
"          <Property name=\"SelectUncertaintyArray\"  exposed_name=\"SelectUncertaintyArray\"/>\n"
"          <Property name=\"UncertaintyTransferFunction\" exposed_name=\"UncertaintyTransferFunction\"/>\n"
"          <Property name=\"UncertaintyScaleFactor\" exposed_name=\"UncertaintyUncertaintyScaleFactor\"/>\n"
"        </ExposedProperties>\n"
"      </SubProxy>\n"
"    </Extension>\n"
"\n"
"    <Extension name=\"UniformGridRepresentation\">\n"
"      <RepresentationType subproxy=\"UncertaintySurfaceRepresentation\"\n"
"                          text=\"Uncertainty Surface\"\n"
"                          subtype=\"Surface\" />\n"
"      <SubProxy>\n"
"        <Proxy name=\"UncertaintySurfaceRepresentation\"\n"
"               proxygroup=\"representations\"\n"
"               proxyname=\"UncertaintySurfaceRepresentation\" />\n"
"\n"
"        <ShareProperties subproxy=\"SurfaceRepresentation\">\n"
"          <Exception name=\"Input\" />\n"
"          <Exception name=\"Visibility\" />\n"
"        </ShareProperties>\n"
"\n"
"        <ExposedProperties>\n"
"          <Property name=\"SelectUncertaintyArray\"  exposed_name=\"SelectUncertaintyArray\"/>\n"
"          <Property name=\"UncertaintyTransferFunction\" exposed_name=\"UncertaintyTransferFunction\"/>\n"
"          <Property name=\"UncertaintyScaleFactor\" exposed_name=\"UncertaintyScaleFactor\"/>\n"
"        </ExposedProperties>\n"
"      </SubProxy>\n"
"    </Extension>\n"
"  </ProxyGroup>\n"
"</ServerManagerConfiguration>\n"
"\n";
// Get single string
char* UncertaintyRenderingvtkUncertaintyRenderingExtensionInterfaces()
{
  size_t len = ( 0
    + strlen(UncertaintyRenderingvtkUncertaintyRenderingExtensionInterfaces0) );
  char* res = new char[ len + 1];
  res[0] = 0;
  strncat(res, UncertaintyRenderingvtkUncertaintyRenderingExtensionInterfaces0, len + 1 - strlen(res));
  return res;
}



#endif
