// python wrapper for vtkColorMaterialHelper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkColorMaterialHelper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkColorMaterialHelper(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkColorMaterialHelper_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkColorMaterialHelper_Doc();


static PyObject *
PyvtkColorMaterialHelper_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkColorMaterialHelper::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkColorMaterialHelper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkColorMaterialHelper *op = static_cast<vtkColorMaterialHelper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkColorMaterialHelper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkColorMaterialHelper_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkColorMaterialHelper *tempr = vtkColorMaterialHelper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkColorMaterialHelper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkColorMaterialHelper *op = static_cast<vtkColorMaterialHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkColorMaterialHelper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkColorMaterialHelper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkColorMaterialHelper_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkColorMaterialHelper *op = static_cast<vtkColorMaterialHelper *>(vp);

  vtkShaderProgram2 *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkShaderProgram2"))
  {
    if (ap.IsBound())
    {
      op->Initialize(temp0);
    }
    else
    {
      op->vtkColorMaterialHelper::Initialize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkColorMaterialHelper_GetShader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetShader");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkColorMaterialHelper *op = static_cast<vtkColorMaterialHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkShaderProgram2 *tempr = (ap.IsBound() ?
      op->GetShader() :
      op->vtkColorMaterialHelper::GetShader());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkColorMaterialHelper_SetUniformVariables(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformVariables");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkColorMaterialHelper *op = static_cast<vtkColorMaterialHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetUniformVariables();
    }
    else
    {
      op->vtkColorMaterialHelper::SetUniformVariables();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkColorMaterialHelper_PrepareForRendering(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PrepareForRendering");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkColorMaterialHelper *op = static_cast<vtkColorMaterialHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PrepareForRendering();
    }
    else
    {
      op->vtkColorMaterialHelper::PrepareForRendering();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkColorMaterialHelper_Render(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Render");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkColorMaterialHelper *op = static_cast<vtkColorMaterialHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Render();
    }
    else
    {
      op->vtkColorMaterialHelper::Render();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkColorMaterialHelper_Methods[] = {
  {"IsTypeOf", PyvtkColorMaterialHelper_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkColorMaterialHelper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkColorMaterialHelper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkColorMaterialHelper\nC++: static vtkColorMaterialHelper *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkColorMaterialHelper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkColorMaterialHelper\nC++: vtkColorMaterialHelper *NewInstance()\n\n"},
  {"Initialize", PyvtkColorMaterialHelper_Initialize, METH_VARARGS,
   "V.Initialize(vtkShaderProgram2)\nC++: void Initialize(vtkShaderProgram2 *)\n\n"},
  {"GetShader", PyvtkColorMaterialHelper_GetShader, METH_VARARGS,
   "V.GetShader() -> vtkShaderProgram2\nC++: virtual vtkShaderProgram2 *GetShader()\n\n"},
  {"SetUniformVariables", PyvtkColorMaterialHelper_SetUniformVariables, METH_VARARGS,
   "V.SetUniformVariables()\nC++: void SetUniformVariables()\n\nCapture current OpenGL state and initialize uniform variables\nused by the helper shader.\n"},
  {"PrepareForRendering", PyvtkColorMaterialHelper_PrepareForRendering, METH_VARARGS,
   "V.PrepareForRendering()\nC++: void PrepareForRendering()\n\nCaptures current OpenGL state. DEPRECATED (Use\nPrepareForRendering2 instead)\n"},
  {"Render", PyvtkColorMaterialHelper_Render, METH_VARARGS,
   "V.Render()\nC++: void Render()\n\nInitializes uniform variables with the last captured OpenGL\nstate. NOTHING IS RENDERED THIS SETS UNIFORMS. DEPRECATED: Use\nSetUnformVariables instead.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkColorMaterialHelper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkColorMaterialHelper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkColorMaterialHelper_StaticNew()
{
  return vtkColorMaterialHelper::New();
}

PyObject *PyvtkColorMaterialHelper_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkColorMaterialHelper_Type, PyvtkColorMaterialHelper_Methods,
    "vtkColorMaterialHelper",
    PyvtkColorMaterialHelper_Doc(), &PyvtkColorMaterialHelper_StaticNew);

  PyTypeObject *pytype = &PyvtkColorMaterialHelper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkColorMaterialHelper_Doc()
{
  static const char *docstring[] = {
    "vtkColorMaterialHelper - a helper to assist in simulating the\n ColorMaterial behaviour of the default OpenGL pipeline.\n\n",
    "Superclass: vtkObject\n\n",
    "vtkColorMaterialHelper is a helper to assist in simulating the\n ColorMaterial behaviour of the default OpenGL pipeline. Look at\n vtkColorMaterialHelper_s for available GLSL functions.\n\n@sa\n vtkShaderProgram2\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkColorMaterialHelper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkColorMaterialHelper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkColorMaterialHelper", o) != 0)
  {
    Py_DECREF(o);
  }

}

