// python wrapper for vtkOpenGLDisplayListPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkOpenGLDisplayListPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLDisplayListPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLDisplayListPainter_ClassNew(); }

#ifndef DECLARED_PyvtkDisplayListPainter_ClassNew
extern "C" { PyObject *PyvtkDisplayListPainter_ClassNew(); }
#define DECLARED_PyvtkDisplayListPainter_ClassNew
#endif

static const char **PyvtkOpenGLDisplayListPainter_Doc();


static PyObject *
PyvtkOpenGLDisplayListPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkOpenGLDisplayListPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLDisplayListPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLDisplayListPainter *op = static_cast<vtkOpenGLDisplayListPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLDisplayListPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLDisplayListPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkOpenGLDisplayListPainter *tempr = vtkOpenGLDisplayListPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLDisplayListPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLDisplayListPainter *op = static_cast<vtkOpenGLDisplayListPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkOpenGLDisplayListPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLDisplayListPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLDisplayListPainter_ReleaseGraphicsResources(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ReleaseGraphicsResources");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLDisplayListPainter *op = static_cast<vtkOpenGLDisplayListPainter *>(vp);

  vtkWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkWindow"))
  {
    if (ap.IsBound())
    {
      op->ReleaseGraphicsResources(temp0);
    }
    else
    {
      op->vtkOpenGLDisplayListPainter::ReleaseGraphicsResources(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkOpenGLDisplayListPainter_Methods[] = {
  {"IsTypeOf", PyvtkOpenGLDisplayListPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkOpenGLDisplayListPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkOpenGLDisplayListPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkOpenGLDisplayListPainter\nC++: static vtkOpenGLDisplayListPainter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkOpenGLDisplayListPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLDisplayListPainter\nC++: vtkOpenGLDisplayListPainter *NewInstance()\n\n"},
  {"ReleaseGraphicsResources", PyvtkOpenGLDisplayListPainter_ReleaseGraphicsResources, METH_VARARGS,
   "V.ReleaseGraphicsResources(vtkWindow)\nC++: void ReleaseGraphicsResources(vtkWindow *)\n\nRelease any graphics resources that are being consumed by this\nmapper. The parameter window could be used to determine which\ngraphic resources to release. In this case, releases the display\nlists.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkOpenGLDisplayListPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkOpenGLDisplayListPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLDisplayListPainter_StaticNew()
{
  return vtkOpenGLDisplayListPainter::New();
}

PyObject *PyvtkOpenGLDisplayListPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLDisplayListPainter_Type, PyvtkOpenGLDisplayListPainter_Methods,
    "vtkOpenGLDisplayListPainter",
    PyvtkOpenGLDisplayListPainter_Doc(), &PyvtkOpenGLDisplayListPainter_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLDisplayListPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDisplayListPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkOpenGLDisplayListPainter_Doc()
{
  static const char *docstring[] = {
    "vtkOpenGLDisplayListPainter - display list painter using OpenGL.\n\n",
    "Superclass: vtkDisplayListPainter\n\n",
    "vtkOpenGLDisplayListPainter creates an OpenGL display list for\nrendering. This painter creates a different display list for every\nrender request with a different set of typeflags. If any of the data\nor inputs change, then all display lists are discarded.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkOpenGLDisplayListPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOpenGLDisplayListPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLDisplayListPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

