// python wrapper for vtkProjectedAAHexahedraMapper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkProjectedAAHexahedraMapper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkProjectedAAHexahedraMapper(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkProjectedAAHexahedraMapper_ClassNew(); }

#ifndef DECLARED_PyvtkUnstructuredGridVolumeMapper_ClassNew
extern "C" { PyObject *PyvtkUnstructuredGridVolumeMapper_ClassNew(); }
#define DECLARED_PyvtkUnstructuredGridVolumeMapper_ClassNew
#endif

static const char **PyvtkProjectedAAHexahedraMapper_Doc();


static PyObject *
PyvtkProjectedAAHexahedraMapper_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkProjectedAAHexahedraMapper::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkProjectedAAHexahedraMapper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProjectedAAHexahedraMapper *op = static_cast<vtkProjectedAAHexahedraMapper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkProjectedAAHexahedraMapper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkProjectedAAHexahedraMapper_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkProjectedAAHexahedraMapper *tempr = vtkProjectedAAHexahedraMapper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkProjectedAAHexahedraMapper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProjectedAAHexahedraMapper *op = static_cast<vtkProjectedAAHexahedraMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkProjectedAAHexahedraMapper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkProjectedAAHexahedraMapper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkProjectedAAHexahedraMapper_SetVisibilitySort(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVisibilitySort");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProjectedAAHexahedraMapper *op = static_cast<vtkProjectedAAHexahedraMapper *>(vp);

  vtkVisibilitySort *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkVisibilitySort"))
  {
    if (ap.IsBound())
    {
      op->SetVisibilitySort(temp0);
    }
    else
    {
      op->vtkProjectedAAHexahedraMapper::SetVisibilitySort(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkProjectedAAHexahedraMapper_GetVisibilitySort(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVisibilitySort");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProjectedAAHexahedraMapper *op = static_cast<vtkProjectedAAHexahedraMapper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVisibilitySort *tempr = (ap.IsBound() ?
      op->GetVisibilitySort() :
      op->vtkProjectedAAHexahedraMapper::GetVisibilitySort());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkProjectedAAHexahedraMapper_IsRenderSupported(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsRenderSupported");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProjectedAAHexahedraMapper *op = static_cast<vtkProjectedAAHexahedraMapper *>(vp);

  vtkRenderWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderWindow"))
  {
    bool tempr = op->IsRenderSupported(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkProjectedAAHexahedraMapper_Methods[] = {
  {"IsTypeOf", PyvtkProjectedAAHexahedraMapper_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkProjectedAAHexahedraMapper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkProjectedAAHexahedraMapper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkProjectedAAHexahedraMapper\nC++: static vtkProjectedAAHexahedraMapper *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkProjectedAAHexahedraMapper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkProjectedAAHexahedraMapper\nC++: vtkProjectedAAHexahedraMapper *NewInstance()\n\n"},
  {"SetVisibilitySort", PyvtkProjectedAAHexahedraMapper_SetVisibilitySort, METH_VARARGS,
   "V.SetVisibilitySort(vtkVisibilitySort)\nC++: virtual void SetVisibilitySort(vtkVisibilitySort *sort)\n\nAlgorithm used to sort the cells according to viewpoint of the\ncamera. Initial value is a vtkCellCenterDepthSort object.\n"},
  {"GetVisibilitySort", PyvtkProjectedAAHexahedraMapper_GetVisibilitySort, METH_VARARGS,
   "V.GetVisibilitySort() -> vtkVisibilitySort\nC++: virtual vtkVisibilitySort *GetVisibilitySort()\n\nAlgorithm used to sort the cells according to viewpoint of the\ncamera. Initial value is a vtkCellCenterDepthSort object.\n"},
  {"IsRenderSupported", PyvtkProjectedAAHexahedraMapper_IsRenderSupported, METH_VARARGS,
   "V.IsRenderSupported(vtkRenderWindow) -> bool\nC++: virtual bool IsRenderSupported(vtkRenderWindow *w)\n\nCheck if the required OpenGL extensions are supported by the\nOpenGL context attached to the render window `w'.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkProjectedAAHexahedraMapper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingVolumePython.vtkProjectedAAHexahedraMapper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkProjectedAAHexahedraMapper_StaticNew()
{
  return vtkProjectedAAHexahedraMapper::New();
}

PyObject *PyvtkProjectedAAHexahedraMapper_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkProjectedAAHexahedraMapper_Type, PyvtkProjectedAAHexahedraMapper_Methods,
    "vtkProjectedAAHexahedraMapper",
    PyvtkProjectedAAHexahedraMapper_Doc(), &PyvtkProjectedAAHexahedraMapper_StaticNew);

  PyTypeObject *pytype = &PyvtkProjectedAAHexahedraMapper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkUnstructuredGridVolumeMapper_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkProjectedAAHexahedraMapper_Doc()
{
  static const char *docstring[] = {
    "vtkProjectedAAHexahedraMapper - volume mapper for axis-aligned\nhexahedra\n\n",
    "Superclass: vtkUnstructuredGridVolumeMapper\n\n",
    "High quality volume renderer for axis-aligned hexahedra\n\n@par Implementation: Implementation by Stephane Marchesin\n(stephane.marchesin@gmail.com) CEA/DIF - Commissariat a l'Energie\nAtomique, Centre DAM Ile-De-France BP12, F-91297 Arpajon, France.\n\n@par Implementation: This mapper implements the paper \"High-Quality, Semi-Analytical Volume Rendering for AMR\nData\", Stephane Marchesin and Guillaume Co",
    "lin de Verdiere, IEEE Vis\n2009.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkProjectedAAHexahedraMapper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkProjectedAAHexahedraMapper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkProjectedAAHexahedraMapper", o) != 0)
  {
    Py_DECREF(o);
  }

}

