// python wrapper for vtkScalarsToColorsPainter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkScalarsToColorsPainter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkScalarsToColorsPainter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkScalarsToColorsPainter_ClassNew(); }

#ifndef DECLARED_PyvtkPainter_ClassNew
extern "C" { PyObject *PyvtkPainter_ClassNew(); }
#define DECLARED_PyvtkPainter_ClassNew
#endif

static const char **PyvtkScalarsToColorsPainter_Doc();


static PyObject *
PyvtkScalarsToColorsPainter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkScalarsToColorsPainter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScalarsToColorsPainter *op = static_cast<vtkScalarsToColorsPainter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkScalarsToColorsPainter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkScalarsToColorsPainter *tempr = vtkScalarsToColorsPainter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScalarsToColorsPainter *op = static_cast<vtkScalarsToColorsPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkScalarsToColorsPainter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkScalarsToColorsPainter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_USE_LOOKUP_TABLE_SCALAR_RANGE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "USE_LOOKUP_TABLE_SCALAR_RANGE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScalarsToColorsPainter::USE_LOOKUP_TABLE_SCALAR_RANGE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_SCALAR_RANGE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALAR_RANGE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationDoubleVectorKey *tempr = vtkScalarsToColorsPainter::SCALAR_RANGE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_SCALAR_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALAR_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScalarsToColorsPainter::SCALAR_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_COLOR_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "COLOR_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScalarsToColorsPainter::COLOR_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_INTERPOLATE_SCALARS_BEFORE_MAPPING(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "INTERPOLATE_SCALARS_BEFORE_MAPPING");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScalarsToColorsPainter::INTERPOLATE_SCALARS_BEFORE_MAPPING();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_LOOKUP_TABLE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "LOOKUP_TABLE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationObjectBaseKey *tempr = vtkScalarsToColorsPainter::LOOKUP_TABLE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_SetLookupTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLookupTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScalarsToColorsPainter *op = static_cast<vtkScalarsToColorsPainter *>(vp);

  vtkScalarsToColors *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkScalarsToColors"))
  {
    if (ap.IsBound())
    {
      op->SetLookupTable(temp0);
    }
    else
    {
      op->vtkScalarsToColorsPainter::SetLookupTable(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_GetLookupTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLookupTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScalarsToColorsPainter *op = static_cast<vtkScalarsToColorsPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkScalarsToColors *tempr = (ap.IsBound() ?
      op->GetLookupTable() :
      op->vtkScalarsToColorsPainter::GetLookupTable());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_CreateDefaultLookupTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateDefaultLookupTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScalarsToColorsPainter *op = static_cast<vtkScalarsToColorsPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CreateDefaultLookupTable();
    }
    else
    {
      op->vtkScalarsToColorsPainter::CreateDefaultLookupTable();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_SCALAR_VISIBILITY(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALAR_VISIBILITY");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScalarsToColorsPainter::SCALAR_VISIBILITY();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_ARRAY_ACCESS_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ARRAY_ACCESS_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScalarsToColorsPainter::ARRAY_ACCESS_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_ARRAY_ID(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ARRAY_ID");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScalarsToColorsPainter::ARRAY_ID();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_ARRAY_NAME(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ARRAY_NAME");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationStringKey *tempr = vtkScalarsToColorsPainter::ARRAY_NAME();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_ARRAY_COMPONENT(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ARRAY_COMPONENT");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScalarsToColorsPainter::ARRAY_COMPONENT();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_FIELD_DATA_TUPLE_ID(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "FIELD_DATA_TUPLE_ID");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScalarsToColorsPainter::FIELD_DATA_TUPLE_ID();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_SCALAR_MATERIAL_MODE(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SCALAR_MATERIAL_MODE");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInformationIntegerKey *tempr = vtkScalarsToColorsPainter::SCALAR_MATERIAL_MODE();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_GetPremultiplyColorsWithAlpha(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPremultiplyColorsWithAlpha");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScalarsToColorsPainter *op = static_cast<vtkScalarsToColorsPainter *>(vp);

  vtkActor *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkActor"))
  {
    int tempr = (ap.IsBound() ?
      op->GetPremultiplyColorsWithAlpha(temp0) :
      op->vtkScalarsToColorsPainter::GetPremultiplyColorsWithAlpha(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_GetOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScalarsToColorsPainter *op = static_cast<vtkScalarsToColorsPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDataObject *tempr = (ap.IsBound() ?
      op->GetOutput() :
      op->vtkScalarsToColorsPainter::GetOutput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkScalarsToColorsPainter_GetTextureSizeLimit(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTextureSizeLimit");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkScalarsToColorsPainter *op = static_cast<vtkScalarsToColorsPainter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetTextureSizeLimit() :
      op->vtkScalarsToColorsPainter::GetTextureSizeLimit());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkScalarsToColorsPainter_Methods[] = {
  {"IsTypeOf", PyvtkScalarsToColorsPainter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkScalarsToColorsPainter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkScalarsToColorsPainter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkScalarsToColorsPainter\nC++: static vtkScalarsToColorsPainter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkScalarsToColorsPainter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkScalarsToColorsPainter\nC++: vtkScalarsToColorsPainter *NewInstance()\n\n"},
  {"USE_LOOKUP_TABLE_SCALAR_RANGE", PyvtkScalarsToColorsPainter_USE_LOOKUP_TABLE_SCALAR_RANGE, METH_VARARGS,
   "V.USE_LOOKUP_TABLE_SCALAR_RANGE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *USE_LOOKUP_TABLE_SCALAR_RANGE(\n    )\n\nControl whether the mapper sets the lookuptable range based on\nits own ScalarRange, or whether it will use the LookupTable\nScalarRange regardless of it's own setting. By default the Mapper\nis allowed to set the LookupTable range, but users who are\nsharing LookupTables between mappers/actors will probably wish to\nforce the mapper to use the LookupTable unchanged.\n"},
  {"SCALAR_RANGE", PyvtkScalarsToColorsPainter_SCALAR_RANGE, METH_VARARGS,
   "V.SCALAR_RANGE() -> vtkInformationDoubleVectorKey\nC++: static vtkInformationDoubleVectorKey *SCALAR_RANGE()\n\nSpecify range in terms of scalar minimum and maximum (smin,smax).\nThese values are used to map scalars into lookup table. Has no\neffect when UseLookupTableScalarRange is true.\n"},
  {"SCALAR_MODE", PyvtkScalarsToColorsPainter_SCALAR_MODE, METH_VARARGS,
   "V.SCALAR_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *SCALAR_MODE()\n\nControl how the painter works with scalar point data and cell\nattribute data. See vtkMapper::ScalarMode for more details.\n"},
  {"COLOR_MODE", PyvtkScalarsToColorsPainter_COLOR_MODE, METH_VARARGS,
   "V.COLOR_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *COLOR_MODE()\n\nControl how the scalar data is mapped to colors. By default\n(ColorModeToDefault), unsigned char scalars are treated as\ncolors, and NOT mapped through the lookup table, while everything\nelse is. Setting ColorModeToMapScalars means that all scalar data\nwill be mapped through the lookup table.\n"},
  {"INTERPOLATE_SCALARS_BEFORE_MAPPING", PyvtkScalarsToColorsPainter_INTERPOLATE_SCALARS_BEFORE_MAPPING, METH_VARARGS,
   "V.INTERPOLATE_SCALARS_BEFORE_MAPPING() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *INTERPOLATE_SCALARS_BEFORE_MAPPING(\n    )\n\nBy default, vertex color is used to map colors to a surface.\nColors are interpolated after being mapped. This option avoids\ncolor interpolation by using a one dimensional texture map for\nthe colors.\n"},
  {"LOOKUP_TABLE", PyvtkScalarsToColorsPainter_LOOKUP_TABLE, METH_VARARGS,
   "V.LOOKUP_TABLE() -> vtkInformationObjectBaseKey\nC++: static vtkInformationObjectBaseKey *LOOKUP_TABLE()\n\nSpecify a lookup table for the mapper to use.\n"},
  {"SetLookupTable", PyvtkScalarsToColorsPainter_SetLookupTable, METH_VARARGS,
   "V.SetLookupTable(vtkScalarsToColors)\nC++: void SetLookupTable(vtkScalarsToColors *lut)\n\nSpecify a lookup table for the mapper to use.\n"},
  {"GetLookupTable", PyvtkScalarsToColorsPainter_GetLookupTable, METH_VARARGS,
   "V.GetLookupTable() -> vtkScalarsToColors\nC++: vtkScalarsToColors *GetLookupTable()\n\nSpecify a lookup table for the mapper to use.\n"},
  {"CreateDefaultLookupTable", PyvtkScalarsToColorsPainter_CreateDefaultLookupTable, METH_VARARGS,
   "V.CreateDefaultLookupTable()\nC++: virtual void CreateDefaultLookupTable()\n\nCreate default lookup table. Generally used to create one when\nnone is available with the scalar data.\n"},
  {"SCALAR_VISIBILITY", PyvtkScalarsToColorsPainter_SCALAR_VISIBILITY, METH_VARARGS,
   "V.SCALAR_VISIBILITY() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *SCALAR_VISIBILITY()\n\nTurn on/off flag to control whether scalar data is used to color\nobjects.\n"},
  {"ARRAY_ACCESS_MODE", PyvtkScalarsToColorsPainter_ARRAY_ACCESS_MODE, METH_VARARGS,
   "V.ARRAY_ACCESS_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *ARRAY_ACCESS_MODE()\n\nControls what data array is used to generate colors.\n"},
  {"ARRAY_ID", PyvtkScalarsToColorsPainter_ARRAY_ID, METH_VARARGS,
   "V.ARRAY_ID() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *ARRAY_ID()\n\nControls what data array is used to generate colors.\n"},
  {"ARRAY_NAME", PyvtkScalarsToColorsPainter_ARRAY_NAME, METH_VARARGS,
   "V.ARRAY_NAME() -> vtkInformationStringKey\nC++: static vtkInformationStringKey *ARRAY_NAME()\n\nControls what data array is used to generate colors.\n"},
  {"ARRAY_COMPONENT", PyvtkScalarsToColorsPainter_ARRAY_COMPONENT, METH_VARARGS,
   "V.ARRAY_COMPONENT() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *ARRAY_COMPONENT()\n\nControls what data array is used to generate colors.\n"},
  {"FIELD_DATA_TUPLE_ID", PyvtkScalarsToColorsPainter_FIELD_DATA_TUPLE_ID, METH_VARARGS,
   "V.FIELD_DATA_TUPLE_ID() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *FIELD_DATA_TUPLE_ID()\n\nControls what data array is used to generate colors.\n"},
  {"SCALAR_MATERIAL_MODE", PyvtkScalarsToColorsPainter_SCALAR_MATERIAL_MODE, METH_VARARGS,
   "V.SCALAR_MATERIAL_MODE() -> vtkInformationIntegerKey\nC++: static vtkInformationIntegerKey *SCALAR_MATERIAL_MODE()\n\nSet the light-model color mode.\n"},
  {"GetPremultiplyColorsWithAlpha", PyvtkScalarsToColorsPainter_GetPremultiplyColorsWithAlpha, METH_VARARGS,
   "V.GetPremultiplyColorsWithAlpha(vtkActor) -> int\nC++: virtual int GetPremultiplyColorsWithAlpha(vtkActor *actor)\n\nFor alpha blending, we sometime premultiply the colors with alpha\nand change the alpha blending function. This call returns whether\nwe are premultiplying or using the default blending function.\nCurrently this checks if the actor has a texture, if not it\nreturns true. TODO: It is possible to make this decision\ndependent on key passed down from a painter upstream that makes a\nmore informed decision for alpha blending depending on extensions\navailable, for example.\n"},
  {"GetOutput", PyvtkScalarsToColorsPainter_GetOutput, METH_VARARGS,
   "V.GetOutput() -> vtkDataObject\nC++: vtkDataObject *GetOutput()\n\nSubclasses need to override this to return the output of the\npipeline.\n"},
  {"GetTextureSizeLimit", PyvtkScalarsToColorsPainter_GetTextureSizeLimit, METH_VARARGS,
   "V.GetTextureSizeLimit() -> int\nC++: virtual vtkIdType GetTextureSizeLimit()\n\nReturn the texture size limit. Subclasses need to override this\nto return the actual correct texture size limit.  Here it is\nhardcoded to 1024.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkScalarsToColorsPainter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingOpenGLPython.vtkScalarsToColorsPainter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkScalarsToColorsPainter_StaticNew()
{
  return vtkScalarsToColorsPainter::New();
}

PyObject *PyvtkScalarsToColorsPainter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkScalarsToColorsPainter_Type, PyvtkScalarsToColorsPainter_Methods,
    "vtkScalarsToColorsPainter",
    PyvtkScalarsToColorsPainter_Doc(), &PyvtkScalarsToColorsPainter_StaticNew);

  PyTypeObject *pytype = &PyvtkScalarsToColorsPainter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPainter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkScalarsToColorsPainter_Doc()
{
  static const char *docstring[] = {
    "vtkScalarsToColorsPainter - painter that converts scalars to colors.\n\n",
    "Superclass: vtkPainter\n\n",
    "It enable/disables coloring state depending on the ScalarMode.\n\nThis is a painter that converts scalars to colors. It enable/disables\ncoloring state depending on the ScalarMode. This painter is composite\ndataset enabled.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkScalarsToColorsPainter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkScalarsToColorsPainter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkScalarsToColorsPainter", o) != 0)
  {
    Py_DECREF(o);
  }

}

